#!/usr/bin/env perl

BEGIN {
   use Env qw( APIIS_HOME );
   die "\n\tAPIIS_HOME is not set!\n\n" unless $APIIS_HOME;
   push @INC, "$APIIS_HOME/lib";
}

use Apiis;
Apiis->initialize( VERSION => '$Revision: 1.3 $ ');
our $apiis;
use Apiis::DataBase::DBCreation;
use Apiis::Auth::AR_Common;
use Apiis::Auth::AR_Init;
use Apiis::Misc qw ( mychomp LocalToRawDate show_progress ); # ...
use Apiis::DataBase::User;


my $this_project=shift;
my $dummy = Apiis::DataBase::User->new(
				       id       => ($apiis->os_user || 'nobody'),
				       password => 'nopassword',
				      );

$apiis->join_model("$this_project", userobj => $dummy,database => 0);
$apiis->check_status();



die __("The runall process is working only with the new access rights setup. 
        The value of 'access_rights' parameter in $APIIS_HOME/etc/apiisrc 
        have to be set as 'AR'. You should check also the inclusion which is 
        done at the end of xml file. The correct entity name which should be 
        placed there is '&AccessRightsTables' ('&OldAuthTables' is defined for 
        the old access rights setup).
       ") if ($apiis->access_rights eq "auth" or $apiis->access_rights eq "none");


my $db_name = $apiis->Model->db_name;
my $system_user = $apiis->Model->db_user;
my $user_creator=$apiis->os_user;
my $db_encoding="UNICODE";
# create db-user apiis_admin if not exist
my @retuser = `psql template1 -A -t -c 'select usename from pg_user'`;
my $usertest = 1;
foreach my $testuser ( @retuser ) {
  $usertest = 2 if ( $testuser eq "apiis_admin\n" );
}
system ( "createuser apiis_admin -S -r -d" ) if $usertest == 1; #postgresql8
#system ( "createuser apiis_admin  -a -d" ) if $usertest == 1; old setup postgresql7


eval {
### creating configuration file for the access rights #############################
access_rights_ar_batch();
###############################################################


### creating database ####################################################
my $lang_dir=$apiis->APIIS_LOCAL."/initial"; #directory with language file
my $lang_file='languages.dat'; #file with languages  
CreateDatabase($db_encoding,$db_name,$loginname,$lang_file,$lang_dir);
##########################################################################

### inserting codes for the sql actions ###
insert_codes();
### creating admin account ###############################################
my $administrator= $apiis->os_user;
my $user_marker = $apiis->node_name;
my @admin_groups = qw (administrator_scripts administrator_dbt  arm_admin);
access_rights($administrator,\@admin_groups,'Administrator','Administrator','en',$user_marker,'pass');


### login the administrator ###


my $user_obj=Apiis::DataBase::User->new(id =>$administrator);
$user_obj->password('pass');
$apiis->DataBase->connect(user=>'application',userobj=>$user_obj);
$apiis->check_status;
$apiis->join_auth($administrator,'DBT');


#creating all accounts required for the Access Rights Manager
#create_other_accounts();

### inserting default unit for animal identification ###

# my $ins_unit=Apiis::DataBase::Record->new(tablename=>'unit',);
# $ins_unit->check_status(die =>'ERR');
# $ins_unit->column('ext_unit')->extdata('ORGANISM');
# $ins_unit->column('ext_id')->extdata('ID');
# $ins_unit->column('opening_dt')->extdata($apiis->now);
# $ins_unit->insert;
# $ins_unit->check_status(die=>'ERR');


### inserting default unit for animal location ###

# $ins_unit=Apiis::DataBase::Record->new(tablename=>'unit',);
# $ins_unit->check_status(die =>'ERR');
# $ins_unit->column('ext_unit')->extdata('LOCATION');
# $ins_unit->column('ext_id')->extdata('DEFAULT');
# $ins_unit->column('opening_dt')->extdata($apiis->now);
# $ins_unit->insert;
# $ins_unit->check_status(die=>'ERR');


### inserting unknown sire (1) and unknown dam (2) ###
# my %unknown=('1'=>'unknown_sire',
# 	     '2'=>'unknown_dam',
# 	    );
# for my $i (1,2) {
#   my $ins_transfer=Apiis::DataBase::Record->new( tablename => 'transfer', );
#   $ins_transfer->check_status( die => 'ERR' );
#   $ins_transfer->column('db_unit')->extdata('','ID');
#   $ins_transfer->column('ext_organism')->extdata($unknown{$i});
#   $ins_transfer->column('db_organism')->intdata($i);
#   $ins_transfer->column('db_organism')->encoded(1);
#   $ins_transfer->column('opening_dt')->extdata($apiis->now);
#   $ins_transfer->insert;
#   $ins_transfer->check_status (die => 'ERR');
# }
# 
# $apiis->DataBase->commit;
# $apiis->check_status(die =>'ERR');


### inserting default code for each class  or unit###
#my %code_classes;
#my %unit_classes;
#my @tables=$apiis->Model->tables;
#foreach my $tab (@tables) {
#  my $table=$apiis->Model->table($tab);
#  my @columns=$table->columns;
#  foreach my $column (@columns) {
#    my ($fk_table, $fk_column, @rest) = $table->column($column)->foreignkey;
#    if ($fk_table eq 'codes' and $fk_column eq 'db_code') {
#      my ($forgetme,$class)=split('=',$rest[0]);
#      $code_classes{$class}=1;
#    }
#    if ($fk_table eq 'unit' and $fk_column eq 'db_unit' and $rest[0]) {
#      $unit_classes{$rest[0]}=1;
#    }
#  }
#}

#foreach my $cclass (keys %code_classes) {
  #insert DEFAULT code for each class
#  my $ext_code="DEFAULT";
#  my $short_name="DEFAULT";
#  my $long_name="DEFAULT";
#  my @codes={ 'ext_code'=>'DEFAULT',
#	      'short_name'=>'DEFAULT',
#	      'long_name'=>'DEFAULT',
#	    };
  #special case id_set insert  default code id_set1,2,3
#  if (uc($cclass) eq 'ID_SET') {
#    @codes=();
#    for (my $i=0;$i<3;$i++) {
#      push @codes, { 'ext_code'=>'id_set'.$i,
#		     'short_name'=>'scheme'.$i,
#		     'long_name'=>'scheme'.$i,
#		   };
#    }
#  }elsif (uc($cclass) eq 'SEX') {
#    #special case sex insert  default codes for male and female
#    @codes=();
#    push @codes, {'ext_code'=>'f',
#		  'short_name'=>'female',
#		  'long_name'=>'female',
#		 },
#		   {'ext_code'=>'m',
#		    'short_name'=>'male',
#		    'long_name'=>'male',
#		   };
#  };
  
#  foreach my $code (@codes) {
#    $ext_code=$code->{'ext_code'};
#    $short_name=$code->{'short_name'};
#    $long_name=$code->{'long_name'};

#   my $ins_codes=Apiis::DataBase::Record->new( tablename => 'codes', );
#    $ins_codes->check_status( die => 'ERR' );
#    $ins_codes->column('ext_code')->extdata($ext_code);
#    $ins_codes->column('class')->extdata($cclass);
#    $ins_codes->column('short_name')->extdata($short_name);
#    $ins_codes->column('long_name')->extdata($long_name);
#    $ins_codes->column('opening_dt')->extdata($apiis->now);
#    $ins_codes->insert;
#    $ins_codes->check_status (die => 'ERR');
#  }

#}


#foreach my $uclass (keys %unit_classes) {
#  next if (uc ($uclass) eq 'LOCATION');
  #insert DEFAULT code for each unit
#  my $ext_id="DEFAULT";
#  my $ins_unit=Apiis::DataBase::Record->new( tablename => 'unit', );
#  $ins_unit->check_status( die => 'ERR' );
#  $ins_unit->column('ext_unit')->extdata($uclass);
#  $ins_unit->column('ext_id')->extdata($ext_id);
#  $ins_unit->column('opening_dt')->extdata($apiis->now);
#  $ins_unit->insert;
#  $ins_unit->check_status (die => 'ERR');
#}

$apiis->DataBase->commit;
$apiis->check_status(die =>'ERR');

};

if ($@) {
  print "$@\n";
  exit(1);
}

