#!/usr/bin/env perl

BEGIN {
   use Env qw( APIIS_HOME );
   die "\n\tAPIIS_HOME is not set!\n\n" unless $APIIS_HOME;
   push @INC, "$APIIS_HOME/lib";
}

use strict;
use warnings;
use Apiis;
Apiis->initialize;
use Data::Dumper;

# Connect to the database as the user 'cong'
require Apiis::DataBase::User;
my $dummy = Apiis::DataBase::User->new(
       id => 'cong',
       password => 'pass',
);
#$dummy->print;

$apiis->join_model('molabis',
      userobj => $dummy
);

$apiis->check_status(die => 'ERR');

# Insert default data into the table 'Codes'
my $ins_codes=Apiis::DataBase::Record->new( tablename => 'codes', );

my $class_name = 'COUNTRY';
my $ext_code   = 'VN';
my $short_name = 'Viet Nam';
my $long_name  = 'Socialist Republic of Vietnam';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');


$class_name = 'COUNTRY';
$ext_code   = 'DE';
$short_name = 'Germany';
$long_name  = 'Federal Republic of Germany';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');


$class_name = 'LANGUAGE';
$ext_code   = 'DE';
$short_name = 'German';
$long_name  = 'German';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');


$class_name = 'LANGUAGE';
$ext_code   = 'VN';
$short_name = 'Vietnamese';
$long_name  = 'Vietnamese';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');


$class_name = 'SPECIES';
$ext_code   = 'Chicken';
$short_name = 'Chicken';
$long_name  = 'Chicken';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'SPECIES';
$ext_code   = 'Cow';
$short_name = 'Cow';
$long_name  = 'Cow';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'BREED';
$ext_code   = 'Ac';
$short_name = 'Vietnamese Ac';
$long_name  = 'Vietnamese Ac';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');


$class_name = 'BREED';
$ext_code   = 'Sultan';
$short_name = 'Turkey Sultan';
$long_name  = 'Turkey Sultan';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');


$class_name = 'DONOR_TYPE';
$ext_code   = 'Animals';
$short_name = 'Animals';
$long_name  = 'Animals';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');


$class_name = 'DONOR_TYPE';
$ext_code   = 'Plants';
$short_name = 'Plants';
$long_name  = 'Plants';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PROTOCOL_TYPE';
$ext_code   = 'Sampling';
$short_name = 'Sampling';
$long_name  = 'Sampling';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PROTOCOL_TYPE';
$ext_code   = 'DNA extraction';
$short_name = 'DNA extraction';
$long_name  = 'DNA extraction';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PROTOCOL_TYPE';
$ext_code   = 'DNA validation';
$short_name = 'DNA validation';
$long_name  = 'DNA validation';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PROTOCOL_TYPE';
$ext_code   = 'PCR amplification';
$short_name = 'PCR amplification';
$long_name  = 'PCR amplification';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PROTOCOL_TYPE';
$ext_code   = 'PCR validation';
$short_name = 'PCR validation';
$long_name  = 'PCR validation';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PROTOCOL_TYPE';
$ext_code   = 'Electrophoresis';
$short_name = 'Electrophoresis';
$long_name  = 'Electrophoresis';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'SOFTWARE';
$ext_code   = 'Software A';
$short_name = 'Software A';
$long_name  = 'Software A';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'SOFTWARE';
$ext_code   = 'Software B';
$short_name = 'Software B';
$long_name  = 'Software B';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'SOFTWARE';
$ext_code   = 'Software C';
$short_name = 'Software C';
$long_name  = 'Software C';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PRIMER';
$ext_code   = 'Primer A01';
$short_name = 'Primer A01';
$long_name  = 'Primer A01';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PRIMER';
$ext_code   = 'Primer A02';
$short_name = 'Primer A02';
$long_name  = 'Primer A02';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PRIMER';
$ext_code   = 'Primer B01';
$short_name = 'Primer B01';
$long_name  = 'Primer B01';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PRIMER';
$ext_code   = 'Primer B02';
$short_name = 'Primer B02';
$long_name  = 'Primer B02';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PRIMER';
$ext_code   = 'Primer C01';
$short_name = 'Primer C01';
$long_name  = 'Primer C01';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PRIMER';
$ext_code   = 'Primer C02';
$short_name = 'Primer C02';
$long_name  = 'Primer C02';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PRIMER';
$ext_code   = 'Primer D01';
$short_name = 'Primer D01';
$long_name  = 'Primer D01';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'PRIMER';
$ext_code   = 'Primer D02';
$short_name = 'Primer D02';
$long_name  = 'Primer D02';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');


$class_name = 'METHOD';
$ext_code   = 'Capillary Electrophoresis';
$short_name = 'Capillary Electrophoresis';
$long_name  = 'Capillary Electrophoresis';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'METHOD';
$ext_code   = 'Gel Electrophoresis';
$short_name = 'Gel Electrophoresis';
$long_name  = 'Gel Electrophoresis';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'MATERIAL_TYPE';
$ext_code   = 'Blood';
$short_name = 'Blood samples';
$long_name  = 'Blood samples';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'MATERIAL_TYPE';
$ext_code   = 'DNA';
$short_name = 'DNA';
$long_name  = 'DNA';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'VESSEL_TYPE';
$ext_code   = 'Tube 250ml';
$short_name = 'Tube 250ml';
$long_name  = 'Tube 250ml';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'VESSEL_TYPE';
$ext_code   = 'Vessel 500ml';
$short_name = 'Vessel 500ml';
$long_name  = 'Vessel 500ml';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'MARKER_TYPE';
$ext_code   = 'Microsatellite';
$short_name = 'Microsatellite';
$long_name  = 'Microsatellite';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'MARKER_TYPE';
$ext_code   = 'SNP';
$short_name = 'SNP';
$long_name  = 'SNP';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');

$class_name = 'SEX';
$ext_code   = 'm';
$short_name = 'Male';
$long_name  = 'Male';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');


$class_name = 'SEX';
$ext_code   = 'f';
$short_name = 'Female';
$long_name  = 'Female';
$ins_codes->check_status( die => 'ERR' );
$ins_codes->column('ext_code')->extdata($ext_code);
$ins_codes->column('class')->extdata($class_name);
$ins_codes->column('short_name')->extdata($short_name);
$ins_codes->column('long_name')->extdata($long_name);
$ins_codes->column('opening_dt')->extdata($apiis->now);
$ins_codes->insert;
$ins_codes->check_status (die => 'ERR');


# Insert default data into the Unit
my $ins_unit=Apiis::DataBase::Record->new(tablename=>'unit',);
$ins_unit->check_status(die =>'ERR');
$ins_unit->column('ext_unit')->extdata('ORGANIZATION');
$ins_unit->column('ext_id')->extdata('Org1');
$ins_unit->column('opening_dt')->extdata($apiis->now);
$ins_unit->insert;
$ins_unit->check_status(die=>'ERR');

$ins_unit=Apiis::DataBase::Record->new(tablename=>'unit',);
$ins_unit->check_status(die =>'ERR');
$ins_unit->column('ext_unit')->extdata('ORGANISMS');
$ins_unit->column('ext_id')->extdata('ID');
$ins_unit->column('opening_dt')->extdata($apiis->now);
$ins_unit->insert;
$ins_unit->check_status(die=>'ERR');


# Insert unknown sire (1) and unknown dam (2)
my %unknown=('1'=>'unknown_sire',
             '2'=>'unknown_dam',
            );
for my $i (1,2) {
  my $ins_transfer=Apiis::DataBase::Record->new( tablename => 'transfer', );
  $ins_transfer->check_status( die => 'ERR' );
  $ins_transfer->column('db_unit')->extdata('ORGANISMS','ID');
  $ins_transfer->column('ext_organism')->extdata($unknown{$i});
  $ins_transfer->column('db_organism')->intdata($i);
  $ins_transfer->column('db_organism')->encoded(1);
  $ins_transfer->column('opening_dt')->extdata($apiis->now);
  $ins_transfer->insert;
  $ins_transfer->check_status (die => 'ERR');
}


$apiis->DataBase->dbh->commit;

