package Molab::Tooltip;

=head1 NAME

Tooltip.pm

=head1 DESCRIPTION

Make tooptips for data inputs on the web layout

=cut

use Apiis::Init;
use Config::IniFiles;

=head2 build


=cut

sub build {
	my ($section_name,$section_key) = @_;
    my $tooltip_head = "Context-sensitive Help";
    my $tooltip_body = get_help_content($section_name,$section_key);
	if ($tooltip_body ne ""){
# 		$tooltip_body .= "<br /><br />Click here to read more ...";
	} else {
    	$tooltip_body = "No help for this item";
	}
    my $tooltip = "cssbody=[tooltip_body] cssheader=[tooltip_head] ";
    $tooltip .= " header=[".$tooltip_head."] ";
    $tooltip .= " body=[".$tooltip_body."]";
    my $help = "<div title=\"".$tooltip."\"><img src=\"../images/help_icon.png\" alt=\"Help\" /></div>";
	$apiis->log('notice',$help);
	return $help;
}

sub get_help_content{
	my ($section_name,$section_key) = @_;
	# which language is used to translate labels
	my $cfg = new Config::IniFiles( -file => "../../etc/apiisrc" );
	my $lang;
	if ($cfg->val( 'I18N', 'language' )) {
	    $lang = $cfg->val( 'I18N', 'language' );
	} else {
		$lang = "en";
	}
	
	my $infile = "../../etc/help_".$lang.".conf";
	tie %ini, 'Config::IniFiles', ( -file => $infile );
	my %my_section = %{$ini{$section_name}};
	if (defined	$my_section{$section_key}){
    	return  $my_section{$section_key};
	}
	return "";
}

1;


=head1 AUTHOR

Truong Van Chi Cong <tvccong1976@yahoo.com>

=cut

__END__

