#!/usr/bin/env perl

=head1 NAME

export.cgi

=head1 DESCRIPTION

	This script reads binary data (files) from database and return it with MIME TYPE attached to the header.

	input:	session_id - identifier of the current session
			blob_id - identifier of blob (file) which should be got from database

	output:	print blob directly to the STDOUT (web browser) or print ERROR 

=cut

BEGIN {
    use Env qw( APIIS_HOME SCRIPT_NAME );
    die "\n\tAPIIS_HOME is not set!\n\n" unless $APIIS_HOME;
    push @INC, "$APIIS_HOME/lib";
}

binmode(STDIN);
binmode(STDOUT);
use warnings;
use strict;
use CGI;
use Apiis;
use Apiis::Init;
use Apache::Session::File;
use Apiis::DataBase::User;
use Apiis::Auth::AR_Common;
use HTML::Template;
use File::MimeInfo;

my $blob = new CGI;

#my %session;
my @id = split( ',', $blob->param('sid') || undef );
my $id = $id[1];
#
my $session_dir = "/tmp/molab_session_data";   	# directory for molab sessions
my %session;

tie %session, 'Apache::Session::File', $id[0], { Directory => $session_dir, };
my $sid = $session{_session_id};    #reading session id for current session

Apiis->initialize( VERSION => '$Revision: 1.2 $' );
our $user_obj = Apiis::DataBase::User->new( id => $session{'username'} );
$user_obj->password( $session{'password'} );
push @INC, $apiis->project("molabis") . "/lib";
$apiis->join_model( 'molabis', userobj => $user_obj );

print STDERR $apiis->status,"\n" if ($apiis->status);
my $sql = "select codes.short_name, codes.long_name from codes, blobs";
$sql   .= " where blobs.blob_id=" . $id;
$sql   .= " and codes.class='MIMETYPE' and codes.db_code=blobs.db_mimetype";

my $sql_ref = $apiis->DataBase->user_sql($sql);

# when no error status continue to get blob itself from database
if ( not $sql_ref->status ) {
    my @data_array = $sql_ref->handle->fetchrow_array;
    my $mimetype   = $data_array[0];
# 	my $extension  = $data_array[1];
	my $extension = "";
    if ($mimetype ne ""){
		$extension = File::MimeInfo::extensions($mimetype);
	}
    my $sql_blob   = "select blob from blobs where blob_id=" . $id;
    $apiis->log('notice',"Mimetype: " . $mimetype);
    $sql_ref = $apiis->DataBase->user_sql($sql_blob);
    if ( not $sql_ref->status ) {
        my @data_array = $sql_ref->handle->fetchrow_array;
        #mime type is set from database data
	    if ($mimetype eq ""){
			print "Content-Type:application/x-download\n";
		}
		else {
			print "Content-Type:$mimetype\n";
		}
		print "Content-Disposition:attachment;filename=$id.$extension\n\n";
#       print $blob->header( -type => $mimetype, -expires => '0' ); 
    
        binmode(STDOUT);
        print $data_array[0];
    }
}
else {
    print $blob->header( -type => 'text/html' );
    print __("No such file in thedatabase") . " blob_id=" . $id[1];
}
untie %session;    #unlock session file for next request

=head1 AUTHOR

Truong Van Chi Cong <cong.chi@fli.bund.de>
Lucjan Soltys <soltys@tzv.fal.de>

=cut

