#!/usr/bin/env perl
##############################################################################
# $Id: show_description.cgi,v 1.1 2008-08-26 15:55:59 cong Exp $
##############################################################################

=head1 NAME

show_description.cgi -- Show help details

=head1 DESCRIPTION

This script shows the details of the help in an external window.

=cut

BEGIN {
    use Env qw( APIIS_HOME );
    die "\n\tAPIIS_HOME is not set!\n\n" unless $APIIS_HOME;
    push @INC, "$APIIS_HOME/lib";
}
use warnings;
use strict;
use CGI qw ( :all escape escapeHTML);
use Apache::Session::File;
use Apiis;
use Apiis::Init;
use Apiis::Errors;
use Apiis::DataBase::Init;
use Apiis::DataBase::User;
use Apiis::DataBase::Record;
use HTML::Template;
use open ':utf8'; #needed for correct showing of umlauts
use open ':std';
my $description = new CGI;

my @id     = split( '\,', $description->param('sid') || '' );
my $table  = $id[1];
my $column = $id[2];
my $session_dir = "/tmp/molab_session_data";   	# directory for molab sessions
my %session;
tie %session, 'Apache::Session::File', $id[0],
            { Directory => $session_dir, };
my $sid = $session{_session_id};    #reading session id for current session

Apiis->initialize( VERSION => '$Revision: 1.1 $' );
our $user_obj = Apiis::DataBase::User->new( id => $session{'username'} );
$user_obj->password( $session{'password'} );

$apiis->join_model( 'molabis', userobj => $user_obj );
push @INC, $apiis->project("molabis") . "/lib";

# set interface acording to language set in session
#$user_obj->language( $session{gui_lang} )     if ( $session{gui_lang} );
#$Apiis::apiis->language( $session{gui_lang} ) if ( $session{gui_lang} );

my $template =
    HTML::Template->new(
    filename => $apiis->APIIS_LOCAL . '/templates/description.html' );

$template->param( 'title' => __("Long description and example") );

if ( defined $session{'description_hash'} ) {

    require ContextHelp;
    my $bubble_description =
        Molab::ContextHelp::get_description( $session{'description_hash'}, $table, $column );

    $template->param(
        'short_description' => $$bubble_description{'description'} );
    my $nl = "<br />\n";
    $template->param( 'l_long_description' => __("Long description") );
    my $description_string =
        escapeHTML( $$bubble_description{'long_description'} );
    #replace end of line with HTML <br> tag
    $description_string =~ s/[\x0A]/$nl/g;
    $template->param( 'long_description' => $description_string );
    $template->param( 'l_example'        => __("Example") );
    $description_string = escapeHTML( $$bubble_description{'examples'} );
    #replace end of line with HTML <br> tag
    $description_string =~ s/[\x0A]/$nl/g;
    $template->param( 'example' => $description_string );
}

#use Encode;
print "Content-Type: text/html; charset=utf-8\n\n", $template->output;
untie %session;    #unlock session file for next request