--
-- PostgreSQL database dump
--

SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

--
-- Name: admin; Type: SCHEMA; Schema: -; Owner: apiis_admin
--

CREATE SCHEMA "admin";


ALTER SCHEMA "admin" OWNER TO apiis_admin;

--
-- Name: apiis_admin; Type: SCHEMA; Schema: -; Owner: apiis_admin
--

CREATE SCHEMA apiis_admin;


ALTER SCHEMA apiis_admin OWNER TO apiis_admin;

--
-- Name: cong; Type: SCHEMA; Schema: -; Owner: apiis_admin
--

CREATE SCHEMA cong;


ALTER SCHEMA cong OWNER TO apiis_admin;

--
-- Name: manager; Type: SCHEMA; Schema: -; Owner: apiis_admin
--

CREATE SCHEMA manager;


ALTER SCHEMA manager OWNER TO apiis_admin;

--
-- Name: molabis; Type: SCHEMA; Schema: -; Owner: apiis_admin
--

CREATE SCHEMA molabis;


ALTER SCHEMA molabis OWNER TO apiis_admin;

--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'Standard public schema';


--
-- Name: scientist; Type: SCHEMA; Schema: -; Owner: apiis_admin
--

CREATE SCHEMA scientist;


ALTER SCHEMA scientist OWNER TO apiis_admin;

--
-- Name: staff; Type: SCHEMA; Schema: -; Owner: apiis_admin
--

CREATE SCHEMA staff;


ALTER SCHEMA staff OWNER TO apiis_admin;

--
-- Name: super_staff; Type: SCHEMA; Schema: -; Owner: apiis_admin
--

CREATE SCHEMA super_staff;


ALTER SCHEMA super_staff OWNER TO apiis_admin;

--
-- Name: visitor; Type: SCHEMA; Schema: -; Owner: apiis_admin
--

CREATE SCHEMA visitor;


ALTER SCHEMA visitor OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: amplified_samples; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE amplified_samples (
    amplification_id integer,
    dna_id integer,
    validation_id integer,
    "comment" text,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.amplified_samples OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: amplified_samples; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW amplified_samples AS
    SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = NULL::text) UNION SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = 'SmallPop'::text);


ALTER TABLE "admin".amplified_samples OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: analyzed_samples; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE analyzed_samples (
    electrophoresis_id integer,
    dna_id integer,
    marker_id integer,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.analyzed_samples OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: analyzed_samples; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW analyzed_samples AS
    SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = NULL::text) UNION SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = 'SmallPop'::text);


ALTER TABLE "admin".analyzed_samples OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_constraints; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_constraints (
    cons_id integer,
    cons_name text,
    cons_type text,
    cons_desc text,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_constraints OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_constraints; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_constraints AS
    SELECT ar_constraints.cons_id, ar_constraints.cons_name, ar_constraints.cons_type, ar_constraints.cons_desc, ar_constraints.last_change_dt, ar_constraints.last_change_user, ar_constraints.dirty, ar_constraints.chk_lvl, ar_constraints.guid, ar_constraints."owner", ar_constraints.version, ar_constraints.synch FROM apiis_admin.ar_constraints WHERE (ar_constraints."owner" = NULL::text) UNION SELECT ar_constraints.cons_id, ar_constraints.cons_name, ar_constraints.cons_type, ar_constraints.cons_desc, ar_constraints.last_change_dt, ar_constraints.last_change_user, ar_constraints.dirty, ar_constraints.chk_lvl, ar_constraints.guid, ar_constraints."owner", ar_constraints.version, ar_constraints.synch FROM apiis_admin.ar_constraints WHERE (ar_constraints."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_constraints OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_dbtdescriptors; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_dbtdescriptors (
    descriptor_id integer,
    descriptor_name text,
    descriptor_value text,
    descriptor_desc text,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_dbtdescriptors OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_dbtdescriptors; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_dbtdescriptors AS
    SELECT ar_dbtdescriptors.descriptor_id, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value, ar_dbtdescriptors.descriptor_desc, ar_dbtdescriptors.last_change_dt, ar_dbtdescriptors.last_change_user, ar_dbtdescriptors.dirty, ar_dbtdescriptors.chk_lvl, ar_dbtdescriptors.guid, ar_dbtdescriptors."owner", ar_dbtdescriptors.version, ar_dbtdescriptors.synch FROM apiis_admin.ar_dbtdescriptors WHERE (ar_dbtdescriptors."owner" = NULL::text) UNION SELECT ar_dbtdescriptors.descriptor_id, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value, ar_dbtdescriptors.descriptor_desc, ar_dbtdescriptors.last_change_dt, ar_dbtdescriptors.last_change_user, ar_dbtdescriptors.dirty, ar_dbtdescriptors.chk_lvl, ar_dbtdescriptors.guid, ar_dbtdescriptors."owner", ar_dbtdescriptors.version, ar_dbtdescriptors.synch FROM apiis_admin.ar_dbtdescriptors WHERE (ar_dbtdescriptors."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_dbtdescriptors OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_dbtpolicies; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_dbtpolicies (
    dbtpolicy_id integer,
    action_id integer,
    table_id integer,
    descriptor_id integer,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_dbtpolicies OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_dbtpolicies; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_dbtpolicies AS
    SELECT ar_dbtpolicies.dbtpolicy_id, ar_dbtpolicies.action_id, ar_dbtpolicies.table_id, ar_dbtpolicies.descriptor_id, ar_dbtpolicies.last_change_dt, ar_dbtpolicies.last_change_user, ar_dbtpolicies.dirty, ar_dbtpolicies.chk_lvl, ar_dbtpolicies.guid, ar_dbtpolicies."owner", ar_dbtpolicies.version, ar_dbtpolicies.synch FROM apiis_admin.ar_dbtpolicies WHERE (ar_dbtpolicies."owner" = NULL::text) UNION SELECT ar_dbtpolicies.dbtpolicy_id, ar_dbtpolicies.action_id, ar_dbtpolicies.table_id, ar_dbtpolicies.descriptor_id, ar_dbtpolicies.last_change_dt, ar_dbtpolicies.last_change_user, ar_dbtpolicies.dirty, ar_dbtpolicies.chk_lvl, ar_dbtpolicies.guid, ar_dbtpolicies."owner", ar_dbtpolicies.version, ar_dbtpolicies.synch FROM apiis_admin.ar_dbtpolicies WHERE (ar_dbtpolicies."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_dbtpolicies OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_dbttables; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_dbttables (
    table_id integer,
    table_name text,
    table_columns text,
    table_desc text,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_dbttables OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_dbttables; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_dbttables AS
    SELECT ar_dbttables.table_id, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbttables.table_desc, ar_dbttables.last_change_dt, ar_dbttables.last_change_user, ar_dbttables.dirty, ar_dbttables.chk_lvl, ar_dbttables.guid, ar_dbttables."owner", ar_dbttables.version, ar_dbttables.synch FROM apiis_admin.ar_dbttables WHERE (ar_dbttables."owner" = NULL::text) UNION SELECT ar_dbttables.table_id, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbttables.table_desc, ar_dbttables.last_change_dt, ar_dbttables.last_change_user, ar_dbttables.dirty, ar_dbttables.chk_lvl, ar_dbttables.guid, ar_dbttables."owner", ar_dbttables.version, ar_dbttables.synch FROM apiis_admin.ar_dbttables WHERE (ar_dbttables."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_dbttables OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_role_constraints; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_role_constraints (
    cons_id integer,
    first_role_id integer,
    second_role_id integer,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_role_constraints OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_role_constraints; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_role_constraints AS
    SELECT ar_role_constraints.cons_id, ar_role_constraints.first_role_id, ar_role_constraints.second_role_id, ar_role_constraints.last_change_dt, ar_role_constraints.last_change_user, ar_role_constraints.dirty, ar_role_constraints.chk_lvl, ar_role_constraints.guid, ar_role_constraints."owner", ar_role_constraints.version, ar_role_constraints.synch FROM apiis_admin.ar_role_constraints WHERE (ar_role_constraints."owner" = NULL::text) UNION SELECT ar_role_constraints.cons_id, ar_role_constraints.first_role_id, ar_role_constraints.second_role_id, ar_role_constraints.last_change_dt, ar_role_constraints.last_change_user, ar_role_constraints.dirty, ar_role_constraints.chk_lvl, ar_role_constraints.guid, ar_role_constraints."owner", ar_role_constraints.version, ar_role_constraints.synch FROM apiis_admin.ar_role_constraints WHERE (ar_role_constraints."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_role_constraints OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_role_dbtpolicies; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_role_dbtpolicies (
    role_id integer,
    dbtpolicy_id integer,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_role_dbtpolicies OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_role_dbtpolicies; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_role_dbtpolicies AS
    SELECT ar_role_dbtpolicies.role_id, ar_role_dbtpolicies.dbtpolicy_id, ar_role_dbtpolicies.last_change_dt, ar_role_dbtpolicies.last_change_user, ar_role_dbtpolicies.dirty, ar_role_dbtpolicies.chk_lvl, ar_role_dbtpolicies.guid, ar_role_dbtpolicies."owner", ar_role_dbtpolicies.version, ar_role_dbtpolicies.synch FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies."owner" = NULL::text) UNION SELECT ar_role_dbtpolicies.role_id, ar_role_dbtpolicies.dbtpolicy_id, ar_role_dbtpolicies.last_change_dt, ar_role_dbtpolicies.last_change_user, ar_role_dbtpolicies.dirty, ar_role_dbtpolicies.chk_lvl, ar_role_dbtpolicies.guid, ar_role_dbtpolicies."owner", ar_role_dbtpolicies.version, ar_role_dbtpolicies.synch FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_role_dbtpolicies OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_role_stpolicies; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_role_stpolicies (
    role_id integer,
    stpolicy_id integer,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_role_stpolicies OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_role_stpolicies; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_role_stpolicies AS
    SELECT ar_role_stpolicies.role_id, ar_role_stpolicies.stpolicy_id, ar_role_stpolicies.last_change_dt, ar_role_stpolicies.last_change_user, ar_role_stpolicies.dirty, ar_role_stpolicies.chk_lvl, ar_role_stpolicies.guid, ar_role_stpolicies."owner", ar_role_stpolicies.version, ar_role_stpolicies.synch FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies."owner" = NULL::text) UNION SELECT ar_role_stpolicies.role_id, ar_role_stpolicies.stpolicy_id, ar_role_stpolicies.last_change_dt, ar_role_stpolicies.last_change_user, ar_role_stpolicies.dirty, ar_role_stpolicies.chk_lvl, ar_role_stpolicies.guid, ar_role_stpolicies."owner", ar_role_stpolicies.version, ar_role_stpolicies.synch FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_role_stpolicies OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_roles; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_roles (
    role_id integer,
    role_name text,
    role_long_name text,
    role_type text,
    role_subset text,
    role_descr text,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_roles OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_roles; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_roles AS
    SELECT ar_roles.role_id, ar_roles.role_name, ar_roles.role_long_name, ar_roles.role_type, ar_roles.role_subset, ar_roles.role_descr, ar_roles.last_change_dt, ar_roles.last_change_user, ar_roles.dirty, ar_roles.chk_lvl, ar_roles.guid, ar_roles."owner", ar_roles.version, ar_roles.synch FROM apiis_admin.ar_roles WHERE (ar_roles."owner" = NULL::text) UNION SELECT ar_roles.role_id, ar_roles.role_name, ar_roles.role_long_name, ar_roles.role_type, ar_roles.role_subset, ar_roles.role_descr, ar_roles.last_change_dt, ar_roles.last_change_user, ar_roles.dirty, ar_roles.chk_lvl, ar_roles.guid, ar_roles."owner", ar_roles.version, ar_roles.synch FROM apiis_admin.ar_roles WHERE (ar_roles."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_roles OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_stpolicies; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_stpolicies (
    stpolicy_id integer,
    stpolicy_name text,
    stpolicy_type text,
    stpolicy_desc text,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_stpolicies OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_stpolicies; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_stpolicies AS
    SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc, ar_stpolicies.last_change_dt, ar_stpolicies.last_change_user, ar_stpolicies.dirty, ar_stpolicies.chk_lvl, ar_stpolicies.guid, ar_stpolicies."owner", ar_stpolicies.version, ar_stpolicies.synch FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies."owner" = NULL::text) UNION SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc, ar_stpolicies.last_change_dt, ar_stpolicies.last_change_user, ar_stpolicies.dirty, ar_stpolicies.chk_lvl, ar_stpolicies.guid, ar_stpolicies."owner", ar_stpolicies.version, ar_stpolicies.synch FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_stpolicies OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_user_roles; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_user_roles (
    user_id integer,
    role_id integer,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_user_roles OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_user_roles; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_user_roles AS
    SELECT ar_user_roles.user_id, ar_user_roles.role_id, ar_user_roles.last_change_dt, ar_user_roles.last_change_user, ar_user_roles.dirty, ar_user_roles.chk_lvl, ar_user_roles.guid, ar_user_roles."owner", ar_user_roles.version, ar_user_roles.synch FROM apiis_admin.ar_user_roles WHERE (ar_user_roles."owner" = NULL::text) UNION SELECT ar_user_roles.user_id, ar_user_roles.role_id, ar_user_roles.last_change_dt, ar_user_roles.last_change_user, ar_user_roles.dirty, ar_user_roles.chk_lvl, ar_user_roles.guid, ar_user_roles."owner", ar_user_roles.version, ar_user_roles.synch FROM apiis_admin.ar_user_roles WHERE (ar_user_roles."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_user_roles OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_users; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_users (
    user_id integer,
    user_login text,
    user_password text,
    user_language_id integer,
    user_marker text,
    user_disabled boolean,
    user_status boolean,
    user_last_login timestamp without time zone,
    user_last_activ_time time without time zone,
    user_session_id text,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_users OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_users; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_users AS
    SELECT ar_users.user_id, ar_users.user_login, ar_users.user_password, ar_users.user_language_id, ar_users.user_marker, ar_users.user_disabled, ar_users.user_status, ar_users.user_last_login, ar_users.user_last_activ_time, ar_users.user_session_id, ar_users.last_change_dt, ar_users.last_change_user, ar_users.dirty, ar_users.chk_lvl, ar_users.guid, ar_users."owner", ar_users.version, ar_users.synch FROM apiis_admin.ar_users WHERE (ar_users."owner" = NULL::text) UNION SELECT ar_users.user_id, ar_users.user_login, ar_users.user_password, ar_users.user_language_id, ar_users.user_marker, ar_users.user_disabled, ar_users.user_status, ar_users.user_last_login, ar_users.user_last_activ_time, ar_users.user_session_id, ar_users.last_change_dt, ar_users.last_change_user, ar_users.dirty, ar_users.chk_lvl, ar_users.guid, ar_users."owner", ar_users.version, ar_users.synch FROM apiis_admin.ar_users WHERE (ar_users."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_users OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: ar_users_data; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE ar_users_data (
    user_id integer,
    user_first_name text,
    user_second_name text,
    user_institution text,
    user_email text,
    user_country text,
    user_street text,
    user_town text,
    user_zip text,
    user_other_info text,
    opening_dt date,
    closing_dt date,
    last_change_dt timestamp without time zone,
    last_change_user text,
    creation_dt timestamp without time zone,
    creation_user text,
    end_dt timestamp without time zone,
    end_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.ar_users_data OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: ar_users_data; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW ar_users_data AS
    SELECT ar_users_data.user_id, ar_users_data.user_first_name, ar_users_data.user_second_name, ar_users_data.user_institution, ar_users_data.user_email, ar_users_data.user_country, ar_users_data.user_street, ar_users_data.user_town, ar_users_data.user_zip, ar_users_data.user_other_info, ar_users_data.opening_dt, ar_users_data.closing_dt, ar_users_data.last_change_dt, ar_users_data.last_change_user, ar_users_data.creation_dt, ar_users_data.creation_user, ar_users_data.end_dt, ar_users_data.end_user, ar_users_data.dirty, ar_users_data.chk_lvl, ar_users_data.guid, ar_users_data."owner", ar_users_data.version, ar_users_data.synch FROM apiis_admin.ar_users_data WHERE (ar_users_data."owner" = NULL::text) UNION SELECT ar_users_data.user_id, ar_users_data.user_first_name, ar_users_data.user_second_name, ar_users_data.user_institution, ar_users_data.user_email, ar_users_data.user_country, ar_users_data.user_street, ar_users_data.user_town, ar_users_data.user_zip, ar_users_data.user_other_info, ar_users_data.opening_dt, ar_users_data.closing_dt, ar_users_data.last_change_dt, ar_users_data.last_change_user, ar_users_data.creation_dt, ar_users_data.creation_user, ar_users_data.end_dt, ar_users_data.end_user, ar_users_data.dirty, ar_users_data.chk_lvl, ar_users_data.guid, ar_users_data."owner", ar_users_data.version, ar_users_data.synch FROM apiis_admin.ar_users_data WHERE (ar_users_data."owner" = 'SmallPop'::text);


ALTER TABLE "admin".ar_users_data OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: blobs; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE blobs (
    blob_id integer,
    blob bytea,
    db_mimetype integer,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.blobs OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: blobs; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW blobs AS
    SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = NULL::text) UNION SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = 'SmallPop'::text);


ALTER TABLE "admin".blobs OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: codes; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE codes (
    ext_code text,
    "class" text,
    db_code integer,
    short_name text,
    long_name text,
    description text,
    opening_dt date,
    closing_dt date,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.codes OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: codes; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW codes AS
    SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = NULL::text) UNION SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = 'SmallPop'::text);


ALTER TABLE "admin".codes OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: contacts; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE contacts (
    db_contact integer,
    title text,
    salutation text,
    first_name text,
    second_name text,
    third_name text,
    birth_dt date,
    db_language integer,
    street text,
    zip text,
    town text,
    db_country integer,
    label text,
    phone text,
    phone2 text,
    fax text,
    email text,
    bank_name text,
    bank_zip text,
    account text,
    opening_dt date,
    closing_dt date,
    "comment" text,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.contacts OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: contacts; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW contacts AS
    SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = NULL::text) UNION SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = 'SmallPop'::text);


ALTER TABLE "admin".contacts OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: dna_extraction; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE dna_extraction (
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint,
    dna_id integer,
    sample_id integer,
    project_id integer,
    validation_id integer,
    dna_concentration real,
    dna_purity real,
    reused text
);


ALTER TABLE apiis_admin.dna_extraction OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: dna_extraction; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW dna_extraction AS
    SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = NULL::text) UNION SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = 'SmallPop'::text);


ALTER TABLE "admin".dna_extraction OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: electrophoresises; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE electrophoresises (
    electrophoresis_id integer,
    ext_electrophoresis text,
    project_id integer,
    db_user integer,
    db_software integer,
    product_id integer,
    protocol_id integer,
    electrophoresis_dt date,
    db_method integer,
    purpose integer,
    "comment" text,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.electrophoresises OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: electrophoresises; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW electrophoresises AS
    SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = NULL::text) UNION SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = 'SmallPop'::text);


ALTER TABLE "admin".electrophoresises OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: event; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE event (
    event_id integer,
    db_event_type integer,
    db_sampler integer,
    event_dt date,
    db_location integer,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.event OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: event; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW event AS
    SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = NULL::text) UNION SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = 'SmallPop'::text);


ALTER TABLE "admin".event OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: gel_images; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE gel_images (
    gel_id integer,
    sample_id integer,
    lane smallint,
    "valid" text,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.gel_images OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: gel_images; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW gel_images AS
    SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = NULL::text) UNION SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = 'SmallPop'::text);


ALTER TABLE "admin".gel_images OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: inspool; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE inspool (
    ds text,
    record_seq integer,
    in_date date,
    ext_unit integer,
    proc_dt date,
    status text,
    record text,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.inspool OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: inspool; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW inspool AS
    SELECT inspool.ds, inspool.record_seq, inspool.in_date, inspool.ext_unit, inspool.proc_dt, inspool.status, inspool.record, inspool.last_change_dt, inspool.last_change_user, inspool.dirty, inspool.chk_lvl, inspool.guid, inspool."owner", inspool.version, inspool.synch FROM apiis_admin.inspool WHERE (inspool."owner" = NULL::text) UNION SELECT inspool.ds, inspool.record_seq, inspool.in_date, inspool.ext_unit, inspool.proc_dt, inspool.status, inspool.record, inspool.last_change_dt, inspool.last_change_user, inspool.dirty, inspool.chk_lvl, inspool.guid, inspool."owner", inspool.version, inspool.synch FROM apiis_admin.inspool WHERE (inspool."owner" = 'SmallPop'::text);


ALTER TABLE "admin".inspool OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: inspool_err; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE inspool_err (
    record_seq integer,
    err_type text,
    "action" text,
    dbtable text,
    dbcol text,
    err_source text,
    short_msg text,
    long_msg text,
    ext_col text,
    ext_val text,
    mod_val text,
    comp_val text,
    target_col text,
    ds text,
    ext_unit text,
    status text,
    err_dt timestamp without time zone,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.inspool_err OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: inspool_err; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW inspool_err AS
    SELECT inspool_err.record_seq, inspool_err.err_type, inspool_err."action", inspool_err.dbtable, inspool_err.dbcol, inspool_err.err_source, inspool_err.short_msg, inspool_err.long_msg, inspool_err.ext_col, inspool_err.ext_val, inspool_err.mod_val, inspool_err.comp_val, inspool_err.target_col, inspool_err.ds, inspool_err.ext_unit, inspool_err.status, inspool_err.err_dt, inspool_err.last_change_dt, inspool_err.last_change_user, inspool_err.dirty, inspool_err.chk_lvl, inspool_err.guid, inspool_err."owner", inspool_err.version, inspool_err.synch FROM apiis_admin.inspool_err WHERE (inspool_err."owner" = NULL::text) UNION SELECT inspool_err.record_seq, inspool_err.err_type, inspool_err."action", inspool_err.dbtable, inspool_err.dbcol, inspool_err.err_source, inspool_err.short_msg, inspool_err.long_msg, inspool_err.ext_col, inspool_err.ext_val, inspool_err.mod_val, inspool_err.comp_val, inspool_err.target_col, inspool_err.ds, inspool_err.ext_unit, inspool_err.status, inspool_err.err_dt, inspool_err.last_change_dt, inspool_err.last_change_user, inspool_err.dirty, inspool_err.chk_lvl, inspool_err.guid, inspool_err."owner", inspool_err.version, inspool_err.synch FROM apiis_admin.inspool_err WHERE (inspool_err."owner" = 'SmallPop'::text);


ALTER TABLE "admin".inspool_err OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: languages; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE languages (
    lang_id integer,
    iso_lang text,
    lang text,
    last_change_dt timestamp without time zone,
    last_change_user text,
    creation_dt timestamp without time zone,
    creation_user text,
    end_dt timestamp without time zone,
    end_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.languages OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: languages; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW languages AS
    SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = NULL::text) UNION SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = 'SmallPop'::text);


ALTER TABLE "admin".languages OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: load_stat; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE load_stat (
    ds text,
    job_start timestamp without time zone,
    job_end timestamp without time zone,
    status integer,
    rec_tot_no smallint,
    rec_err_no smallint,
    rec_ok_no smallint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.load_stat OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: load_stat; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW load_stat AS
    SELECT load_stat.ds, load_stat.job_start, load_stat.job_end, load_stat.status, load_stat.rec_tot_no, load_stat.rec_err_no, load_stat.rec_ok_no, load_stat.last_change_dt, load_stat.last_change_user, load_stat.dirty, load_stat.chk_lvl, load_stat.guid, load_stat."owner", load_stat.version, load_stat.synch FROM apiis_admin.load_stat WHERE (load_stat."owner" = NULL::text) UNION SELECT load_stat.ds, load_stat.job_start, load_stat.job_end, load_stat.status, load_stat.rec_tot_no, load_stat.rec_err_no, load_stat.rec_ok_no, load_stat.last_change_dt, load_stat.last_change_user, load_stat.dirty, load_stat.chk_lvl, load_stat.guid, load_stat."owner", load_stat.version, load_stat.synch FROM apiis_admin.load_stat WHERE (load_stat."owner" = 'SmallPop'::text);


ALTER TABLE "admin".load_stat OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: locations; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE locations (
    db_organism integer,
    db_location integer,
    entry_dt date,
    db_entry_action integer,
    exit_dt date,
    db_exit_action integer,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.locations OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: locations; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW locations AS
    SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = NULL::text) UNION SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = 'SmallPop'::text);


ALTER TABLE "admin".locations OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: markers; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE markers (
    marker_id smallint,
    marker_name text,
    db_marker_type integer,
    db_primer1 integer,
    db_primer2 integer,
    "comment" text,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.markers OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: markers; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW markers AS
    SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = NULL::text) UNION SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = 'SmallPop'::text);


ALTER TABLE "admin".markers OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: microsatellites; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE microsatellites (
    microsatellite_id integer,
    dna_id integer,
    project_id integer,
    marker_id integer,
    allele1 smallint,
    allele2 smallint,
    "comment" text,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.microsatellites OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: microsatellites; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW microsatellites AS
    SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = NULL::text) UNION SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = 'SmallPop'::text);


ALTER TABLE "admin".microsatellites OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: new_pest; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE new_pest (
    "class" text,
    "key" text,
    trait text,
    estimator double precision,
    pev double precision,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.new_pest OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: new_pest; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW new_pest AS
    SELECT new_pest."class", new_pest."key", new_pest.trait, new_pest.estimator, new_pest.pev, new_pest.last_change_dt, new_pest.last_change_user, new_pest.dirty, new_pest.chk_lvl, new_pest.guid, new_pest."owner", new_pest.version, new_pest.synch FROM apiis_admin.new_pest WHERE (new_pest."owner" = NULL::text) UNION SELECT new_pest."class", new_pest."key", new_pest.trait, new_pest.estimator, new_pest.pev, new_pest.last_change_dt, new_pest.last_change_user, new_pest.dirty, new_pest.chk_lvl, new_pest.guid, new_pest."owner", new_pest.version, new_pest.synch FROM apiis_admin.new_pest WHERE (new_pest."owner" = 'SmallPop'::text);


ALTER TABLE "admin".new_pest OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: nodes; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE nodes (
    nodename text,
    address text,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.nodes OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: nodes; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW nodes AS
    SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = NULL::text) UNION SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = 'SmallPop'::text);


ALTER TABLE "admin".nodes OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: organisms; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE organisms (
    db_organism integer,
    db_sire integer,
    db_dam integer,
    db_sex integer,
    birth_dt date,
    birth_year text,
    latitude double precision,
    longitude double precision,
    db_donor_type integer,
    db_species integer,
    db_breed integer,
    db_photo integer,
    "comment" text,
    la_rep text,
    la_rep_dt date,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean,
    db_hybrid integer
);


ALTER TABLE apiis_admin.organisms OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: organisms; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW organisms AS
    SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = NULL::text) UNION SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = 'SmallPop'::text);


ALTER TABLE "admin".organisms OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: pcr_amplification; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE pcr_amplification (
    amplification_id integer,
    ext_amplification text,
    project_id integer,
    protocol_id integer,
    "comment" text,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.pcr_amplification OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: pcr_amplification; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW pcr_amplification AS
    SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = NULL::text) UNION SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = 'SmallPop'::text);


ALTER TABLE "admin".pcr_amplification OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: pcr_markers; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE pcr_markers (
    amplification_id integer,
    marker_id integer,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.pcr_markers OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: pcr_markers; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW pcr_markers AS
    SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = NULL::text) UNION SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = 'SmallPop'::text);


ALTER TABLE "admin".pcr_markers OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: projects; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE projects (
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint,
    project_id integer,
    project_name text,
    keyword text,
    begin_dt date,
    finish_dt date,
    description text,
    "comment" text
);


ALTER TABLE apiis_admin.projects OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: projects; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW projects AS
    SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = NULL::text) UNION SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = 'SmallPop'::text);


ALTER TABLE "admin".projects OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: protocols; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE protocols (
    protocol_id integer,
    protocol_name text,
    "comment" text,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint,
    db_protocol_type integer
);


ALTER TABLE apiis_admin.protocols OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: protocols; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW protocols AS
    SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = NULL::text) UNION SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = 'SmallPop'::text);


ALTER TABLE "admin".protocols OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: sample_collection; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE sample_collection (
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint,
    sample_id integer,
    project_id integer,
    reused text
);


ALTER TABLE apiis_admin.sample_collection OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: sample_collection; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW sample_collection AS
    SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = NULL::text) UNION SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = 'SmallPop'::text);


ALTER TABLE "admin".sample_collection OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: samples; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE samples (
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint,
    sample_id integer,
    ext_sample text,
    db_organism integer,
    db_vessel_type integer,
    db_material_type integer,
    db_user integer,
    protocol_id integer,
    production_dt date,
    storage_dt date,
    "comment" text
);


ALTER TABLE apiis_admin.samples OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: samples; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW samples AS
    SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = NULL::text) UNION SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = 'SmallPop'::text);


ALTER TABLE "admin".samples OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: sequences; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE sequences (
    sequence_id integer,
    dna_id integer,
    project_id integer,
    marker_id integer,
    "sequence" text,
    "comment" text,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.sequences OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: sequences; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW sequences AS
    SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = NULL::text) UNION SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = 'SmallPop'::text);


ALTER TABLE "admin".sequences OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: sources; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE sources (
    source text,
    tablename text,
    "class" text,
    columnnames text,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.sources OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: sources; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW sources AS
    SELECT sources.source, sources.tablename, sources."class", sources.columnnames, sources.last_change_dt, sources.last_change_user, sources.dirty, sources.chk_lvl, sources.guid, sources."owner", sources.version, sources.synch FROM apiis_admin.sources WHERE (sources."owner" = NULL::text) UNION SELECT sources.source, sources.tablename, sources."class", sources.columnnames, sources.last_change_dt, sources.last_change_user, sources.dirty, sources.chk_lvl, sources.guid, sources."owner", sources.version, sources.synch FROM apiis_admin.sources WHERE (sources."owner" = 'SmallPop'::text);


ALTER TABLE "admin".sources OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: storage; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE "storage" (
    storage_id integer,
    storage_name text,
    parent_id integer,
    "comment" text,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin."storage" OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: storage; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW "storage" AS
    SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = NULL::text) UNION SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = 'SmallPop'::text);


ALTER TABLE "admin"."storage" OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: storage_samples; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE storage_samples (
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint,
    storage_id integer,
    sample_id integer,
    no_units smallint
);


ALTER TABLE apiis_admin.storage_samples OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: storage_samples; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW storage_samples AS
    SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = NULL::text) UNION SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = 'SmallPop'::text);


ALTER TABLE "admin".storage_samples OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: targets; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE targets (
    target text,
    tablename text,
    "class" text,
    columnnames text,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.targets OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: targets; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW targets AS
    SELECT targets.target, targets.tablename, targets."class", targets.columnnames, targets.last_change_dt, targets.last_change_user, targets.dirty, targets.chk_lvl, targets.guid, targets."owner", targets.version, targets.synch FROM apiis_admin.targets WHERE (targets."owner" = NULL::text) UNION SELECT targets.target, targets.tablename, targets."class", targets.columnnames, targets.last_change_dt, targets.last_change_user, targets.dirty, targets.chk_lvl, targets.guid, targets."owner", targets.version, targets.synch FROM apiis_admin.targets WHERE (targets."owner" = 'SmallPop'::text);


ALTER TABLE "admin".targets OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: transfer; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE transfer (
    db_organism integer,
    ext_organism text,
    db_unit integer,
    id_set integer,
    opening_dt date,
    closing_dt date,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.transfer OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: transfer; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW transfer AS
    SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = NULL::text) UNION SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = 'SmallPop'::text);


ALTER TABLE "admin".transfer OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: unit; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE unit (
    db_unit integer,
    ext_unit text,
    ext_id text,
    db_contact integer,
    db_member integer,
    opening_dt date,
    closing_dt date,
    last_change_dt timestamp without time zone,
    last_change_user text,
    dirty boolean,
    chk_lvl smallint,
    guid integer,
    "owner" text,
    version integer,
    synch boolean
);


ALTER TABLE apiis_admin.unit OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: unit; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW unit AS
    SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = NULL::text) UNION SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = 'SmallPop'::text);


ALTER TABLE "admin".unit OWNER TO apiis_admin;

--
-- Name: v_dbtar_admin; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW v_dbtar_admin AS
    SELECT ar_dbtpolicies.dbtpolicy_id, codes.ext_code AS sqlaction, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value FROM apiis_admin.codes, apiis_admin.ar_dbtpolicies, apiis_admin.ar_dbttables, apiis_admin.ar_dbtdescriptors WHERE ((((ar_dbtpolicies.table_id = ar_dbttables.table_id) AND (ar_dbtpolicies.descriptor_id = ar_dbtdescriptors.descriptor_id)) AND (ar_dbtpolicies.action_id = codes.db_code)) AND (ar_dbtpolicies.dbtpolicy_id IN (SELECT ar_role_dbtpolicies.dbtpolicy_id FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies.role_id = ANY (ARRAY[111, 132])))));


ALTER TABLE "admin".v_dbtar_admin OWNER TO apiis_admin;

--
-- Name: v_star_admin; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW v_star_admin AS
    SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies.stpolicy_id IN (SELECT ar_role_stpolicies.stpolicy_id FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies.role_id = ANY (ARRAY[111, 132]))));


ALTER TABLE "admin".v_star_admin OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: validation; Type: TABLE; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE TABLE validation (
    validation_id integer,
    gel_id integer,
    protocol_id integer,
    "comment" text,
    chk_lvl smallint,
    dirty boolean,
    guid bigint,
    last_change_dt timestamp without time zone,
    last_change_user text,
    "owner" text,
    synch boolean,
    version smallint
);


ALTER TABLE apiis_admin.validation OWNER TO apiis_admin;

SET search_path = "admin", pg_catalog;

--
-- Name: validation; Type: VIEW; Schema: admin; Owner: apiis_admin
--

CREATE VIEW validation AS
    SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = NULL::text) UNION SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = 'SmallPop'::text);


ALTER TABLE "admin".validation OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Name: entry_codes; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW entry_codes AS
    SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM codes WHERE (codes.closing_dt IS NULL);


ALTER TABLE apiis_admin.entry_codes OWNER TO apiis_admin;

--
-- Name: entry_transfer; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW entry_transfer AS
    SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM transfer WHERE (transfer.closing_dt IS NULL);


ALTER TABLE apiis_admin.entry_transfer OWNER TO apiis_admin;

--
-- Name: entry_unit; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW entry_unit AS
    SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM unit WHERE (unit.closing_dt IS NULL);


ALTER TABLE apiis_admin.entry_unit OWNER TO apiis_admin;

--
-- Name: seq_ar_constraints__cons_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_ar_constraints__cons_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_ar_constraints__cons_id OWNER TO apiis_admin;

--
-- Name: seq_ar_constraints__cons_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_ar_constraints__cons_id', 100, false);


--
-- Name: seq_ar_dbtdescriptor__descriptor_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_ar_dbtdescriptor__descriptor_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_ar_dbtdescriptor__descriptor_id OWNER TO apiis_admin;

--
-- Name: seq_ar_dbtdescriptor__descriptor_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_ar_dbtdescriptor__descriptor_id', 100, false);


--
-- Name: seq_ar_dbtpolicies__dbtpolicy_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_ar_dbtpolicies__dbtpolicy_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_ar_dbtpolicies__dbtpolicy_id OWNER TO apiis_admin;

--
-- Name: seq_ar_dbtpolicies__dbtpolicy_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_ar_dbtpolicies__dbtpolicy_id', 100, false);


--
-- Name: seq_ar_dbttabels__table_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_ar_dbttabels__table_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_ar_dbttabels__table_id OWNER TO apiis_admin;

--
-- Name: seq_ar_dbttabels__table_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_ar_dbttabels__table_id', 100, false);


--
-- Name: seq_ar_roles__role_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_ar_roles__role_id
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_ar_roles__role_id OWNER TO apiis_admin;

--
-- Name: seq_ar_roles__role_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_ar_roles__role_id', 133, true);


--
-- Name: seq_ar_stpolicies__stpolicy_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_ar_stpolicies__stpolicy_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_ar_stpolicies__stpolicy_id OWNER TO apiis_admin;

--
-- Name: seq_ar_stpolicies__stpolicy_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_ar_stpolicies__stpolicy_id', 100, false);


--
-- Name: seq_ar_users__user_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_ar_users__user_id
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_ar_users__user_id OWNER TO apiis_admin;

--
-- Name: seq_ar_users__user_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_ar_users__user_id', 108, true);


--
-- Name: seq_blobs__blob_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_blobs__blob_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_blobs__blob_id OWNER TO apiis_admin;

--
-- Name: seq_blobs__blob_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_blobs__blob_id', 100, false);


--
-- Name: seq_codes__db_code; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_codes__db_code
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_codes__db_code OWNER TO apiis_admin;

--
-- Name: seq_codes__db_code; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_codes__db_code', 242, true);


--
-- Name: seq_contacts__db_contact; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_contacts__db_contact
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_contacts__db_contact OWNER TO apiis_admin;

--
-- Name: seq_contacts__db_contact; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_contacts__db_contact', 101, true);


--
-- Name: seq_database__guid; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_database__guid
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_database__guid OWNER TO apiis_admin;

--
-- Name: seq_database__guid; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_database__guid', 1932, true);


--
-- Name: seq_electrophoresises__electrophoresis_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_electrophoresises__electrophoresis_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_electrophoresises__electrophoresis_id OWNER TO apiis_admin;

--
-- Name: seq_electrophoresises__electrophoresis_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_electrophoresises__electrophoresis_id', 100, false);


--
-- Name: seq_event__event_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_event__event_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_event__event_id OWNER TO apiis_admin;

--
-- Name: seq_event__event_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_event__event_id', 100, false);


--
-- Name: seq_inspool__record_seq; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_inspool__record_seq
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_inspool__record_seq OWNER TO apiis_admin;

--
-- Name: seq_inspool__record_seq; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_inspool__record_seq', 100, false);


--
-- Name: seq_languages__lang_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_languages__lang_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_languages__lang_id OWNER TO apiis_admin;

--
-- Name: seq_languages__lang_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_languages__lang_id', 100, false);


--
-- Name: seq_markers__marker_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_markers__marker_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_markers__marker_id OWNER TO apiis_admin;

--
-- Name: seq_markers__marker_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_markers__marker_id', 100, false);


--
-- Name: seq_microsatellites__microsatellite_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_microsatellites__microsatellite_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_microsatellites__microsatellite_id OWNER TO apiis_admin;

--
-- Name: seq_microsatellites__microsatellite_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_microsatellites__microsatellite_id', 100, false);


--
-- Name: seq_pcr_amplification__amplification_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_pcr_amplification__amplification_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_pcr_amplification__amplification_id OWNER TO apiis_admin;

--
-- Name: seq_pcr_amplification__amplification_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_pcr_amplification__amplification_id', 100, false);


--
-- Name: seq_projects__project_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_projects__project_id
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_projects__project_id OWNER TO apiis_admin;

--
-- Name: seq_projects__project_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_projects__project_id', 103, true);


--
-- Name: seq_samples__sample_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_samples__sample_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_samples__sample_id OWNER TO apiis_admin;

--
-- Name: seq_samples__sample_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_samples__sample_id', 100, false);


--
-- Name: seq_sequences__sequence_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_sequences__sequence_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_sequences__sequence_id OWNER TO apiis_admin;

--
-- Name: seq_sequences__sequence_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_sequences__sequence_id', 100, false);


--
-- Name: seq_storage__storage_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_storage__storage_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_storage__storage_id OWNER TO apiis_admin;

--
-- Name: seq_storage__storage_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_storage__storage_id', 100, false);


--
-- Name: seq_transfer__db_organism; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_transfer__db_organism
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_transfer__db_organism OWNER TO apiis_admin;

--
-- Name: seq_transfer__db_organism; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_transfer__db_organism', 100, false);


--
-- Name: seq_unit__db_unit; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_unit__db_unit
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_unit__db_unit OWNER TO apiis_admin;

--
-- Name: seq_unit__db_unit; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_unit__db_unit', 101, true);


--
-- Name: seq_validation__validation_id; Type: SEQUENCE; Schema: apiis_admin; Owner: apiis_admin
--

CREATE SEQUENCE seq_validation__validation_id
    START WITH 100
    INCREMENT BY 1
    MAXVALUE 100000000
    MINVALUE 100
    CACHE 1;


ALTER TABLE apiis_admin.seq_validation__validation_id OWNER TO apiis_admin;

--
-- Name: seq_validation__validation_id; Type: SEQUENCE SET; Schema: apiis_admin; Owner: apiis_admin
--

SELECT pg_catalog.setval('seq_validation__validation_id', 100, false);


--
-- Name: v_amplified_samples; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_amplified_samples AS
    SELECT a.guid AS v_guid, a.amplification_id, a.dna_id, a.validation_id, a."comment", a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM amplified_samples a;


ALTER TABLE apiis_admin.v_amplified_samples OWNER TO apiis_admin;

--
-- Name: v_analyzed_samples; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_analyzed_samples AS
    SELECT a.guid AS v_guid, a.electrophoresis_id, a.dna_id, a.marker_id, a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM analyzed_samples a;


ALTER TABLE apiis_admin.v_analyzed_samples OWNER TO apiis_admin;

--
-- Name: v_ar_constraints; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_constraints AS
    SELECT a.guid AS v_guid, a.cons_id, a.cons_name, a.cons_type, a.cons_desc, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ar_constraints a;


ALTER TABLE apiis_admin.v_ar_constraints OWNER TO apiis_admin;

--
-- Name: v_ar_dbtdescriptors; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_dbtdescriptors AS
    SELECT a.guid AS v_guid, a.descriptor_id, a.descriptor_name, a.descriptor_value, a.descriptor_desc, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ar_dbtdescriptors a;


ALTER TABLE apiis_admin.v_ar_dbtdescriptors OWNER TO apiis_admin;

--
-- Name: v_ar_dbtpolicies; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_dbtpolicies AS
    SELECT a.guid AS v_guid, a.dbtpolicy_id, a.action_id, b.ext_code AS ext_action_id, a.table_id, a.descriptor_id, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM (ar_dbtpolicies a LEFT JOIN codes b ON ((a.action_id = b.db_code)));


ALTER TABLE apiis_admin.v_ar_dbtpolicies OWNER TO apiis_admin;

--
-- Name: v_ar_dbttables; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_dbttables AS
    SELECT a.guid AS v_guid, a.table_id, a.table_name, a.table_columns, a.table_desc, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ar_dbttables a;


ALTER TABLE apiis_admin.v_ar_dbttables OWNER TO apiis_admin;

--
-- Name: v_ar_role_constraints; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_role_constraints AS
    SELECT a.guid AS v_guid, a.cons_id, a.first_role_id, a.second_role_id, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ar_role_constraints a;


ALTER TABLE apiis_admin.v_ar_role_constraints OWNER TO apiis_admin;

--
-- Name: v_ar_role_dbtpolicies; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_role_dbtpolicies AS
    SELECT a.guid AS v_guid, a.role_id, a.dbtpolicy_id, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ar_role_dbtpolicies a;


ALTER TABLE apiis_admin.v_ar_role_dbtpolicies OWNER TO apiis_admin;

--
-- Name: v_ar_role_stpolicies; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_role_stpolicies AS
    SELECT a.guid AS v_guid, a.role_id, a.stpolicy_id, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ar_role_stpolicies a;


ALTER TABLE apiis_admin.v_ar_role_stpolicies OWNER TO apiis_admin;

--
-- Name: v_ar_roles; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_roles AS
    SELECT a.guid AS v_guid, a.role_id, a.role_name, a.role_long_name, a.role_type, a.role_subset, a.role_descr, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ar_roles a;


ALTER TABLE apiis_admin.v_ar_roles OWNER TO apiis_admin;

--
-- Name: v_ar_stpolicies; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_stpolicies AS
    SELECT a.guid AS v_guid, a.stpolicy_id, a.stpolicy_name, a.stpolicy_type, a.stpolicy_desc, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ar_stpolicies a;


ALTER TABLE apiis_admin.v_ar_stpolicies OWNER TO apiis_admin;

--
-- Name: v_ar_user_roles; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_user_roles AS
    SELECT a.guid AS v_guid, a.user_id, a.role_id, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ar_user_roles a;


ALTER TABLE apiis_admin.v_ar_user_roles OWNER TO apiis_admin;

--
-- Name: v_ar_users; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_users AS
    SELECT a.guid AS v_guid, a.user_id, a.user_login, a.user_password, a.user_language_id, a.user_marker, a.user_disabled, a.user_status, a.user_last_login, a.user_last_activ_time, a.user_session_id, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ar_users a;


ALTER TABLE apiis_admin.v_ar_users OWNER TO apiis_admin;

--
-- Name: v_ar_users_data; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_ar_users_data AS
    SELECT a.guid AS v_guid, a.user_id, a.user_first_name, a.user_second_name, a.user_institution, a.user_email, a.user_country, a.user_street, a.user_town, a.user_zip, a.user_other_info, a.opening_dt, a.closing_dt, a.last_change_dt, a.last_change_user, a.creation_dt, a.creation_user, a.end_dt, a.end_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ar_users_data a;


ALTER TABLE apiis_admin.v_ar_users_data OWNER TO apiis_admin;

--
-- Name: v_blobs; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_blobs AS
    SELECT a.guid AS v_guid, a.blob_id, a.blob, a.db_mimetype, b.ext_code AS ext_mimetype, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM (blobs a LEFT JOIN codes b ON ((a.db_mimetype = b.db_code)));


ALTER TABLE apiis_admin.v_blobs OWNER TO apiis_admin;

--
-- Name: v_codes; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_codes AS
    SELECT a.guid AS v_guid, a.ext_code, a."class", a.db_code, a.short_name, a.long_name, a.description, a.opening_dt, a.closing_dt, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM codes a;


ALTER TABLE apiis_admin.v_codes OWNER TO apiis_admin;

--
-- Name: v_contacts; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_contacts AS
    SELECT a.guid AS v_guid, a.db_contact, a.title, a.salutation, a.first_name, a.second_name, a.third_name, a.birth_dt, a.db_language, b.ext_code AS ext_language, a.street, a.zip, a.town, a.db_country, c.ext_code AS ext_country, a.label, a.phone, a.phone2, a.fax, a.email, a.bank_name, a.bank_zip, a.account, a.opening_dt, a.closing_dt, a."comment", a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM ((contacts a LEFT JOIN codes b ON ((a.db_language = b.db_code))) LEFT JOIN codes c ON ((a.db_country = c.db_code)));


ALTER TABLE apiis_admin.v_contacts OWNER TO apiis_admin;

--
-- Name: v_dna_extraction; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_dna_extraction AS
    SELECT a.guid AS v_guid, a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version, a.dna_id, a.sample_id, a.project_id, a.validation_id, a.dna_concentration, a.dna_purity, a.reused FROM dna_extraction a;


ALTER TABLE apiis_admin.v_dna_extraction OWNER TO apiis_admin;

--
-- Name: v_electrophoresises; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_electrophoresises AS
    SELECT a.guid AS v_guid, a.electrophoresis_id, a.ext_electrophoresis, a.project_id, a.db_user, a.db_software, b.ext_code AS ext_software, a.product_id, a.protocol_id, c.protocol_id AS ext_protocol_id, a.electrophoresis_dt, a.db_method, d.ext_code AS ext_method, a.purpose, e.ext_code AS ext_purpose, a."comment", a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM ((((electrophoresises a LEFT JOIN codes b ON ((a.db_software = b.db_code))) LEFT JOIN protocols c ON ((a.protocol_id = c.protocol_id))) LEFT JOIN codes d ON ((a.db_method = d.db_code))) LEFT JOIN codes e ON ((a.purpose = e.db_code)));


ALTER TABLE apiis_admin.v_electrophoresises OWNER TO apiis_admin;

--
-- Name: v_event; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_event AS
    SELECT a.guid AS v_guid, a.event_id, a.db_event_type, b.ext_code AS ext_event_type, a.db_sampler, ((c.ext_unit || ':::'::text) || c.ext_id) AS ext_sampler, a.event_dt, a.db_location, ((d.ext_unit || ':::'::text) || d.ext_id) AS ext_location, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM (((event a LEFT JOIN codes b ON ((a.db_event_type = b.db_code))) LEFT JOIN unit c ON ((a.db_sampler = c.db_unit))) LEFT JOIN unit d ON ((a.db_location = d.db_unit)));


ALTER TABLE apiis_admin.v_event OWNER TO apiis_admin;

--
-- Name: v_gel_images; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_gel_images AS
    SELECT a.guid AS v_guid, a.gel_id, a.sample_id, a.lane, a."valid", a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM gel_images a;


ALTER TABLE apiis_admin.v_gel_images OWNER TO apiis_admin;

--
-- Name: v_inspool; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_inspool AS
    SELECT a.guid AS v_guid, a.ds, a.record_seq, a.in_date, a.ext_unit, a.proc_dt, a.status, a.record, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM inspool a;


ALTER TABLE apiis_admin.v_inspool OWNER TO apiis_admin;

--
-- Name: v_inspool_err; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_inspool_err AS
    SELECT a.guid AS v_guid, a.record_seq, a.err_type, a."action", a.dbtable, a.dbcol, a.err_source, a.short_msg, a.long_msg, a.ext_col, a.ext_val, a.mod_val, a.comp_val, a.target_col, a.ds, a.ext_unit, a.status, a.err_dt, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM inspool_err a;


ALTER TABLE apiis_admin.v_inspool_err OWNER TO apiis_admin;

--
-- Name: v_languages; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_languages AS
    SELECT a.guid AS v_guid, a.lang_id, a.iso_lang, a.lang, a.last_change_dt, a.last_change_user, a.creation_dt, a.creation_user, a.end_dt, a.end_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM languages a;


ALTER TABLE apiis_admin.v_languages OWNER TO apiis_admin;

--
-- Name: v_load_stat; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_load_stat AS
    SELECT a.guid AS v_guid, a.ds, a.job_start, a.job_end, a.status, a.rec_tot_no, a.rec_err_no, a.rec_ok_no, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM load_stat a;


ALTER TABLE apiis_admin.v_load_stat OWNER TO apiis_admin;

--
-- Name: v_locations; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_locations AS
    SELECT a.guid AS v_guid, a.db_organism, ((((c.ext_unit || ':::'::text) || c.ext_id) || ':::'::text) || b.ext_organism) AS ext_organism, a.db_location, ((d.ext_unit || ':::'::text) || d.ext_id) AS ext_location, a.entry_dt, a.db_entry_action, e.ext_code AS ext_entry_action, a.exit_dt, a.db_exit_action, f.ext_code AS ext_exit_action, a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM (((((locations a LEFT JOIN transfer b ON ((a.db_organism = b.db_organism))) LEFT JOIN unit c ON ((b.db_unit = c.db_unit))) LEFT JOIN unit d ON ((a.db_location = d.db_unit))) LEFT JOIN codes e ON ((a.db_entry_action = e.db_code))) LEFT JOIN codes f ON ((a.db_exit_action = f.db_code)));


ALTER TABLE apiis_admin.v_locations OWNER TO apiis_admin;

--
-- Name: v_markers; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_markers AS
    SELECT a.guid AS v_guid, a.marker_id, a.marker_name, a.db_marker_type, b.ext_code AS ext_marker_type, a.db_primer1, c.ext_code AS ext_primer1, a.db_primer2, d.ext_code AS ext_primer2, a."comment", a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM (((markers a LEFT JOIN codes b ON ((a.db_marker_type = b.db_code))) LEFT JOIN codes c ON ((a.db_primer1 = c.db_code))) LEFT JOIN codes d ON ((a.db_primer2 = d.db_code)));


ALTER TABLE apiis_admin.v_markers OWNER TO apiis_admin;

--
-- Name: v_microsatellites; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_microsatellites AS
    SELECT a.guid AS v_guid, a.microsatellite_id, a.dna_id, a.project_id, a.marker_id, a.allele1, a.allele2, a."comment", a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM microsatellites a;


ALTER TABLE apiis_admin.v_microsatellites OWNER TO apiis_admin;

--
-- Name: v_new_pest; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_new_pest AS
    SELECT a.guid AS v_guid, a."class", a."key", a.trait, a.estimator, a.pev, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM new_pest a;


ALTER TABLE apiis_admin.v_new_pest OWNER TO apiis_admin;

--
-- Name: v_nodes; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_nodes AS
    SELECT a.guid AS v_guid, a.nodename, a.address, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM nodes a;


ALTER TABLE apiis_admin.v_nodes OWNER TO apiis_admin;

--
-- Name: v_organisms; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_organisms AS
    SELECT a.guid AS v_guid, a.db_organism, ((((c.ext_unit || ':::'::text) || c.ext_id) || ':::'::text) || b.ext_organism) AS ext_organism, a.db_sire, ((((e.ext_unit || ':::'::text) || e.ext_id) || ':::'::text) || d.ext_organism) AS ext_sire, a.db_dam, ((((g.ext_unit || ':::'::text) || g.ext_id) || ':::'::text) || f.ext_organism) AS ext_dam, a.db_sex, h.ext_code AS ext_sex, a.birth_dt, a.birth_year, a.latitude, a.longitude, a.db_donor_type, i.ext_code AS ext_donor_type, a.db_species, j.ext_code AS ext_species, a.db_breed, k.ext_code AS ext_breed, a.db_photo, a."comment", a.la_rep, a.la_rep_dt, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch, a.db_hybrid, l.ext_code AS ext_hybrid FROM (((((((((((organisms a LEFT JOIN transfer b ON ((a.db_organism = b.db_organism))) LEFT JOIN unit c ON ((b.db_unit = c.db_unit))) LEFT JOIN transfer d ON ((a.db_sire = d.db_organism))) LEFT JOIN unit e ON ((d.db_unit = e.db_unit))) LEFT JOIN transfer f ON ((a.db_dam = f.db_organism))) LEFT JOIN unit g ON ((f.db_unit = g.db_unit))) LEFT JOIN codes h ON ((a.db_sex = h.db_code))) LEFT JOIN codes i ON ((a.db_donor_type = i.db_code))) LEFT JOIN codes j ON ((a.db_species = j.db_code))) LEFT JOIN codes k ON ((a.db_breed = k.db_code))) LEFT JOIN codes l ON ((a.db_hybrid = l.db_code)));


ALTER TABLE apiis_admin.v_organisms OWNER TO apiis_admin;

--
-- Name: v_pcr_amplification; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_pcr_amplification AS
    SELECT a.guid AS v_guid, a.amplification_id, a.ext_amplification, a.project_id, a.protocol_id, b.protocol_id AS ext_protocol_id, a."comment", a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM (pcr_amplification a LEFT JOIN protocols b ON ((a.protocol_id = b.protocol_id)));


ALTER TABLE apiis_admin.v_pcr_amplification OWNER TO apiis_admin;

--
-- Name: v_pcr_markers; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_pcr_markers AS
    SELECT a.guid AS v_guid, a.amplification_id, a.marker_id, a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM pcr_markers a;


ALTER TABLE apiis_admin.v_pcr_markers OWNER TO apiis_admin;

--
-- Name: v_projects; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_projects AS
    SELECT a.guid AS v_guid, a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version, a.project_id, a.project_name, a.keyword, a.begin_dt, a.finish_dt, a.description, a."comment" FROM projects a;


ALTER TABLE apiis_admin.v_projects OWNER TO apiis_admin;

--
-- Name: v_protocols; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_protocols AS
    SELECT a.guid AS v_guid, a.protocol_id, a.protocol_name, a."comment", a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version, a.db_protocol_type, b.ext_code AS ext_protocol_type FROM (protocols a LEFT JOIN codes b ON ((a.db_protocol_type = b.db_code)));


ALTER TABLE apiis_admin.v_protocols OWNER TO apiis_admin;

--
-- Name: v_sample_collection; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_sample_collection AS
    SELECT a.guid AS v_guid, a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version, a.sample_id, a.project_id, a.reused FROM sample_collection a;


ALTER TABLE apiis_admin.v_sample_collection OWNER TO apiis_admin;

--
-- Name: v_samples; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_samples AS
    SELECT a.guid AS v_guid, a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version, a.sample_id, a.ext_sample, a.db_organism, ((((c.ext_unit || ':::'::text) || c.ext_id) || ':::'::text) || b.ext_organism) AS ext_organism, a.db_vessel_type, d.ext_code AS ext_vessel_type, a.db_material_type, e.ext_code AS ext_material_type, a.db_user, a.protocol_id, f.protocol_id AS ext_protocol_id, a.production_dt, a.storage_dt, a."comment" FROM (((((samples a LEFT JOIN transfer b ON ((a.db_organism = b.db_organism))) LEFT JOIN unit c ON ((b.db_unit = c.db_unit))) LEFT JOIN codes d ON ((a.db_vessel_type = d.db_code))) LEFT JOIN codes e ON ((a.db_material_type = e.db_code))) LEFT JOIN protocols f ON ((a.protocol_id = f.protocol_id)));


ALTER TABLE apiis_admin.v_samples OWNER TO apiis_admin;

--
-- Name: v_sequences; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_sequences AS
    SELECT a.guid AS v_guid, a.sequence_id, a.dna_id, a.project_id, a.marker_id, a."sequence", a."comment", a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM sequences a;


ALTER TABLE apiis_admin.v_sequences OWNER TO apiis_admin;

--
-- Name: v_sources; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_sources AS
    SELECT a.guid AS v_guid, a.source, a.tablename, a."class", a.columnnames, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM sources a;


ALTER TABLE apiis_admin.v_sources OWNER TO apiis_admin;

--
-- Name: v_storage; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_storage AS
    SELECT a.guid AS v_guid, a.storage_id, a.storage_name, a.parent_id, a."comment", a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM "storage" a;


ALTER TABLE apiis_admin.v_storage OWNER TO apiis_admin;

--
-- Name: v_storage_samples; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_storage_samples AS
    SELECT a.guid AS v_guid, a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version, a.storage_id, a.sample_id, a.no_units FROM storage_samples a;


ALTER TABLE apiis_admin.v_storage_samples OWNER TO apiis_admin;

--
-- Name: v_targets; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_targets AS
    SELECT a.guid AS v_guid, a.target, a.tablename, a."class", a.columnnames, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM targets a;


ALTER TABLE apiis_admin.v_targets OWNER TO apiis_admin;

--
-- Name: v_transfer; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_transfer AS
    SELECT a.guid AS v_guid, a.db_organism, a.ext_organism, a.db_unit, ((b.ext_unit || ':::'::text) || b.ext_id) AS ext_unit, a.id_set, c.ext_code AS ext_id_set, a.opening_dt, a.closing_dt, a.last_change_dt, a.last_change_user, a.dirty, a.chk_lvl, a.guid, a."owner", a.version, a.synch FROM ((transfer a LEFT JOIN unit b ON ((a.db_unit = b.db_unit))) LEFT JOIN codes c ON ((a.id_set = c.db_code)));


ALTER TABLE apiis_admin.v_transfer OWNER TO apiis_admin;

--
-- Name: v_unit; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_unit AS
    SELECT a.guid AS v_guid, a.db_unit, a.ext_unit, a.ext_id, a.db_contact, a.db_member, ((b.ext_unit || ':::'::text) || b.ext_id) AS ext_member, b.opening_dt, b.closing_dt, b.last_change_dt, b.last_change_user, b.dirty, b.chk_lvl, b.guid, b."owner", b.version, b.synch FROM (unit a LEFT JOIN unit b ON ((b.db_member = b.db_unit)));


ALTER TABLE apiis_admin.v_unit OWNER TO apiis_admin;

--
-- Name: v_validation; Type: VIEW; Schema: apiis_admin; Owner: apiis_admin
--

CREATE VIEW v_validation AS
    SELECT a.guid AS v_guid, a.validation_id, a.gel_id, a.protocol_id, b.protocol_id AS ext_protocol_id, a."comment", a.chk_lvl, a.dirty, a.guid, a.last_change_dt, a.last_change_user, a."owner", a.synch, a.version FROM (validation a LEFT JOIN protocols b ON ((a.protocol_id = b.protocol_id)));


ALTER TABLE apiis_admin.v_validation OWNER TO apiis_admin;

SET search_path = cong, pg_catalog;

--
-- Name: amplified_samples; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW amplified_samples AS
    SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = NULL::text) UNION SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = 'SmallPop'::text);


ALTER TABLE cong.amplified_samples OWNER TO apiis_admin;

--
-- Name: analyzed_samples; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW analyzed_samples AS
    SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = NULL::text) UNION SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = 'SmallPop'::text);


ALTER TABLE cong.analyzed_samples OWNER TO apiis_admin;

--
-- Name: ar_constraints; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_constraints AS
    SELECT ar_constraints.cons_id, ar_constraints.cons_name, ar_constraints.cons_type, ar_constraints.cons_desc, ar_constraints.last_change_dt, ar_constraints.last_change_user, ar_constraints.dirty, ar_constraints.chk_lvl, ar_constraints.guid, ar_constraints."owner", ar_constraints.version, ar_constraints.synch FROM apiis_admin.ar_constraints WHERE (ar_constraints."owner" = NULL::text) UNION SELECT ar_constraints.cons_id, ar_constraints.cons_name, ar_constraints.cons_type, ar_constraints.cons_desc, ar_constraints.last_change_dt, ar_constraints.last_change_user, ar_constraints.dirty, ar_constraints.chk_lvl, ar_constraints.guid, ar_constraints."owner", ar_constraints.version, ar_constraints.synch FROM apiis_admin.ar_constraints WHERE (ar_constraints."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_constraints OWNER TO apiis_admin;

--
-- Name: ar_dbtdescriptors; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_dbtdescriptors AS
    SELECT ar_dbtdescriptors.descriptor_id, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value, ar_dbtdescriptors.descriptor_desc, ar_dbtdescriptors.last_change_dt, ar_dbtdescriptors.last_change_user, ar_dbtdescriptors.dirty, ar_dbtdescriptors.chk_lvl, ar_dbtdescriptors.guid, ar_dbtdescriptors."owner", ar_dbtdescriptors.version, ar_dbtdescriptors.synch FROM apiis_admin.ar_dbtdescriptors WHERE (ar_dbtdescriptors."owner" = NULL::text) UNION SELECT ar_dbtdescriptors.descriptor_id, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value, ar_dbtdescriptors.descriptor_desc, ar_dbtdescriptors.last_change_dt, ar_dbtdescriptors.last_change_user, ar_dbtdescriptors.dirty, ar_dbtdescriptors.chk_lvl, ar_dbtdescriptors.guid, ar_dbtdescriptors."owner", ar_dbtdescriptors.version, ar_dbtdescriptors.synch FROM apiis_admin.ar_dbtdescriptors WHERE (ar_dbtdescriptors."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_dbtdescriptors OWNER TO apiis_admin;

--
-- Name: ar_dbtpolicies; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_dbtpolicies AS
    SELECT ar_dbtpolicies.dbtpolicy_id, ar_dbtpolicies.action_id, ar_dbtpolicies.table_id, ar_dbtpolicies.descriptor_id, ar_dbtpolicies.last_change_dt, ar_dbtpolicies.last_change_user, ar_dbtpolicies.dirty, ar_dbtpolicies.chk_lvl, ar_dbtpolicies.guid, ar_dbtpolicies."owner", ar_dbtpolicies.version, ar_dbtpolicies.synch FROM apiis_admin.ar_dbtpolicies WHERE (ar_dbtpolicies."owner" = NULL::text) UNION SELECT ar_dbtpolicies.dbtpolicy_id, ar_dbtpolicies.action_id, ar_dbtpolicies.table_id, ar_dbtpolicies.descriptor_id, ar_dbtpolicies.last_change_dt, ar_dbtpolicies.last_change_user, ar_dbtpolicies.dirty, ar_dbtpolicies.chk_lvl, ar_dbtpolicies.guid, ar_dbtpolicies."owner", ar_dbtpolicies.version, ar_dbtpolicies.synch FROM apiis_admin.ar_dbtpolicies WHERE (ar_dbtpolicies."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_dbtpolicies OWNER TO apiis_admin;

--
-- Name: ar_dbttables; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_dbttables AS
    SELECT ar_dbttables.table_id, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbttables.table_desc, ar_dbttables.last_change_dt, ar_dbttables.last_change_user, ar_dbttables.dirty, ar_dbttables.chk_lvl, ar_dbttables.guid, ar_dbttables."owner", ar_dbttables.version, ar_dbttables.synch FROM apiis_admin.ar_dbttables WHERE (ar_dbttables."owner" = NULL::text) UNION SELECT ar_dbttables.table_id, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbttables.table_desc, ar_dbttables.last_change_dt, ar_dbttables.last_change_user, ar_dbttables.dirty, ar_dbttables.chk_lvl, ar_dbttables.guid, ar_dbttables."owner", ar_dbttables.version, ar_dbttables.synch FROM apiis_admin.ar_dbttables WHERE (ar_dbttables."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_dbttables OWNER TO apiis_admin;

--
-- Name: ar_role_constraints; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_role_constraints AS
    SELECT ar_role_constraints.cons_id, ar_role_constraints.first_role_id, ar_role_constraints.second_role_id, ar_role_constraints.last_change_dt, ar_role_constraints.last_change_user, ar_role_constraints.dirty, ar_role_constraints.chk_lvl, ar_role_constraints.guid, ar_role_constraints."owner", ar_role_constraints.version, ar_role_constraints.synch FROM apiis_admin.ar_role_constraints WHERE (ar_role_constraints."owner" = NULL::text) UNION SELECT ar_role_constraints.cons_id, ar_role_constraints.first_role_id, ar_role_constraints.second_role_id, ar_role_constraints.last_change_dt, ar_role_constraints.last_change_user, ar_role_constraints.dirty, ar_role_constraints.chk_lvl, ar_role_constraints.guid, ar_role_constraints."owner", ar_role_constraints.version, ar_role_constraints.synch FROM apiis_admin.ar_role_constraints WHERE (ar_role_constraints."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_role_constraints OWNER TO apiis_admin;

--
-- Name: ar_role_dbtpolicies; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_role_dbtpolicies AS
    SELECT ar_role_dbtpolicies.role_id, ar_role_dbtpolicies.dbtpolicy_id, ar_role_dbtpolicies.last_change_dt, ar_role_dbtpolicies.last_change_user, ar_role_dbtpolicies.dirty, ar_role_dbtpolicies.chk_lvl, ar_role_dbtpolicies.guid, ar_role_dbtpolicies."owner", ar_role_dbtpolicies.version, ar_role_dbtpolicies.synch FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies."owner" = NULL::text) UNION SELECT ar_role_dbtpolicies.role_id, ar_role_dbtpolicies.dbtpolicy_id, ar_role_dbtpolicies.last_change_dt, ar_role_dbtpolicies.last_change_user, ar_role_dbtpolicies.dirty, ar_role_dbtpolicies.chk_lvl, ar_role_dbtpolicies.guid, ar_role_dbtpolicies."owner", ar_role_dbtpolicies.version, ar_role_dbtpolicies.synch FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_role_dbtpolicies OWNER TO apiis_admin;

--
-- Name: ar_role_stpolicies; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_role_stpolicies AS
    SELECT ar_role_stpolicies.role_id, ar_role_stpolicies.stpolicy_id, ar_role_stpolicies.last_change_dt, ar_role_stpolicies.last_change_user, ar_role_stpolicies.dirty, ar_role_stpolicies.chk_lvl, ar_role_stpolicies.guid, ar_role_stpolicies."owner", ar_role_stpolicies.version, ar_role_stpolicies.synch FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies."owner" = NULL::text) UNION SELECT ar_role_stpolicies.role_id, ar_role_stpolicies.stpolicy_id, ar_role_stpolicies.last_change_dt, ar_role_stpolicies.last_change_user, ar_role_stpolicies.dirty, ar_role_stpolicies.chk_lvl, ar_role_stpolicies.guid, ar_role_stpolicies."owner", ar_role_stpolicies.version, ar_role_stpolicies.synch FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_role_stpolicies OWNER TO apiis_admin;

--
-- Name: ar_roles; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_roles AS
    SELECT ar_roles.role_id, ar_roles.role_name, ar_roles.role_long_name, ar_roles.role_type, ar_roles.role_subset, ar_roles.role_descr, ar_roles.last_change_dt, ar_roles.last_change_user, ar_roles.dirty, ar_roles.chk_lvl, ar_roles.guid, ar_roles."owner", ar_roles.version, ar_roles.synch FROM apiis_admin.ar_roles WHERE (ar_roles."owner" = NULL::text) UNION SELECT ar_roles.role_id, ar_roles.role_name, ar_roles.role_long_name, ar_roles.role_type, ar_roles.role_subset, ar_roles.role_descr, ar_roles.last_change_dt, ar_roles.last_change_user, ar_roles.dirty, ar_roles.chk_lvl, ar_roles.guid, ar_roles."owner", ar_roles.version, ar_roles.synch FROM apiis_admin.ar_roles WHERE (ar_roles."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_roles OWNER TO apiis_admin;

--
-- Name: ar_stpolicies; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_stpolicies AS
    SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc, ar_stpolicies.last_change_dt, ar_stpolicies.last_change_user, ar_stpolicies.dirty, ar_stpolicies.chk_lvl, ar_stpolicies.guid, ar_stpolicies."owner", ar_stpolicies.version, ar_stpolicies.synch FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies."owner" = NULL::text) UNION SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc, ar_stpolicies.last_change_dt, ar_stpolicies.last_change_user, ar_stpolicies.dirty, ar_stpolicies.chk_lvl, ar_stpolicies.guid, ar_stpolicies."owner", ar_stpolicies.version, ar_stpolicies.synch FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_stpolicies OWNER TO apiis_admin;

--
-- Name: ar_user_roles; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_user_roles AS
    SELECT ar_user_roles.user_id, ar_user_roles.role_id, ar_user_roles.last_change_dt, ar_user_roles.last_change_user, ar_user_roles.dirty, ar_user_roles.chk_lvl, ar_user_roles.guid, ar_user_roles."owner", ar_user_roles.version, ar_user_roles.synch FROM apiis_admin.ar_user_roles WHERE (ar_user_roles."owner" = NULL::text) UNION SELECT ar_user_roles.user_id, ar_user_roles.role_id, ar_user_roles.last_change_dt, ar_user_roles.last_change_user, ar_user_roles.dirty, ar_user_roles.chk_lvl, ar_user_roles.guid, ar_user_roles."owner", ar_user_roles.version, ar_user_roles.synch FROM apiis_admin.ar_user_roles WHERE (ar_user_roles."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_user_roles OWNER TO apiis_admin;

--
-- Name: ar_users; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_users AS
    SELECT ar_users.user_id, ar_users.user_login, ar_users.user_password, ar_users.user_language_id, ar_users.user_marker, ar_users.user_disabled, ar_users.user_status, ar_users.user_last_login, ar_users.user_last_activ_time, ar_users.user_session_id, ar_users.last_change_dt, ar_users.last_change_user, ar_users.dirty, ar_users.chk_lvl, ar_users.guid, ar_users."owner", ar_users.version, ar_users.synch FROM apiis_admin.ar_users WHERE (ar_users."owner" = NULL::text) UNION SELECT ar_users.user_id, ar_users.user_login, ar_users.user_password, ar_users.user_language_id, ar_users.user_marker, ar_users.user_disabled, ar_users.user_status, ar_users.user_last_login, ar_users.user_last_activ_time, ar_users.user_session_id, ar_users.last_change_dt, ar_users.last_change_user, ar_users.dirty, ar_users.chk_lvl, ar_users.guid, ar_users."owner", ar_users.version, ar_users.synch FROM apiis_admin.ar_users WHERE (ar_users."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_users OWNER TO apiis_admin;

--
-- Name: ar_users_data; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW ar_users_data AS
    SELECT ar_users_data.user_id, ar_users_data.user_first_name, ar_users_data.user_second_name, ar_users_data.user_institution, ar_users_data.user_email, ar_users_data.user_country, ar_users_data.user_street, ar_users_data.user_town, ar_users_data.user_zip, ar_users_data.user_other_info, ar_users_data.opening_dt, ar_users_data.closing_dt, ar_users_data.last_change_dt, ar_users_data.last_change_user, ar_users_data.creation_dt, ar_users_data.creation_user, ar_users_data.end_dt, ar_users_data.end_user, ar_users_data.dirty, ar_users_data.chk_lvl, ar_users_data.guid, ar_users_data."owner", ar_users_data.version, ar_users_data.synch FROM apiis_admin.ar_users_data WHERE (ar_users_data."owner" = NULL::text) UNION SELECT ar_users_data.user_id, ar_users_data.user_first_name, ar_users_data.user_second_name, ar_users_data.user_institution, ar_users_data.user_email, ar_users_data.user_country, ar_users_data.user_street, ar_users_data.user_town, ar_users_data.user_zip, ar_users_data.user_other_info, ar_users_data.opening_dt, ar_users_data.closing_dt, ar_users_data.last_change_dt, ar_users_data.last_change_user, ar_users_data.creation_dt, ar_users_data.creation_user, ar_users_data.end_dt, ar_users_data.end_user, ar_users_data.dirty, ar_users_data.chk_lvl, ar_users_data.guid, ar_users_data."owner", ar_users_data.version, ar_users_data.synch FROM apiis_admin.ar_users_data WHERE (ar_users_data."owner" = 'SmallPop'::text);


ALTER TABLE cong.ar_users_data OWNER TO apiis_admin;

--
-- Name: blobs; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW blobs AS
    SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = NULL::text) UNION SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = 'SmallPop'::text);


ALTER TABLE cong.blobs OWNER TO apiis_admin;

--
-- Name: codes; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW codes AS
    SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = NULL::text) UNION SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = 'SmallPop'::text);


ALTER TABLE cong.codes OWNER TO apiis_admin;

--
-- Name: contacts; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW contacts AS
    SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = NULL::text) UNION SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = 'SmallPop'::text);


ALTER TABLE cong.contacts OWNER TO apiis_admin;

--
-- Name: dna_extraction; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW dna_extraction AS
    SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = NULL::text) UNION SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = 'SmallPop'::text);


ALTER TABLE cong.dna_extraction OWNER TO apiis_admin;

--
-- Name: electrophoresises; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW electrophoresises AS
    SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = NULL::text) UNION SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = 'SmallPop'::text);


ALTER TABLE cong.electrophoresises OWNER TO apiis_admin;

--
-- Name: event; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW event AS
    SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = NULL::text) UNION SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = 'SmallPop'::text);


ALTER TABLE cong.event OWNER TO apiis_admin;

--
-- Name: gel_images; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW gel_images AS
    SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = NULL::text) UNION SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = 'SmallPop'::text);


ALTER TABLE cong.gel_images OWNER TO apiis_admin;

--
-- Name: inspool; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW inspool AS
    SELECT inspool.ds, inspool.record_seq, inspool.in_date, inspool.ext_unit, inspool.proc_dt, inspool.status, inspool.record, inspool.last_change_dt, inspool.last_change_user, inspool.dirty, inspool.chk_lvl, inspool.guid, inspool."owner", inspool.version, inspool.synch FROM apiis_admin.inspool WHERE (inspool."owner" = NULL::text) UNION SELECT inspool.ds, inspool.record_seq, inspool.in_date, inspool.ext_unit, inspool.proc_dt, inspool.status, inspool.record, inspool.last_change_dt, inspool.last_change_user, inspool.dirty, inspool.chk_lvl, inspool.guid, inspool."owner", inspool.version, inspool.synch FROM apiis_admin.inspool WHERE (inspool."owner" = 'SmallPop'::text);


ALTER TABLE cong.inspool OWNER TO apiis_admin;

--
-- Name: inspool_err; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW inspool_err AS
    SELECT inspool_err.record_seq, inspool_err.err_type, inspool_err."action", inspool_err.dbtable, inspool_err.dbcol, inspool_err.err_source, inspool_err.short_msg, inspool_err.long_msg, inspool_err.ext_col, inspool_err.ext_val, inspool_err.mod_val, inspool_err.comp_val, inspool_err.target_col, inspool_err.ds, inspool_err.ext_unit, inspool_err.status, inspool_err.err_dt, inspool_err.last_change_dt, inspool_err.last_change_user, inspool_err.dirty, inspool_err.chk_lvl, inspool_err.guid, inspool_err."owner", inspool_err.version, inspool_err.synch FROM apiis_admin.inspool_err WHERE (inspool_err."owner" = NULL::text) UNION SELECT inspool_err.record_seq, inspool_err.err_type, inspool_err."action", inspool_err.dbtable, inspool_err.dbcol, inspool_err.err_source, inspool_err.short_msg, inspool_err.long_msg, inspool_err.ext_col, inspool_err.ext_val, inspool_err.mod_val, inspool_err.comp_val, inspool_err.target_col, inspool_err.ds, inspool_err.ext_unit, inspool_err.status, inspool_err.err_dt, inspool_err.last_change_dt, inspool_err.last_change_user, inspool_err.dirty, inspool_err.chk_lvl, inspool_err.guid, inspool_err."owner", inspool_err.version, inspool_err.synch FROM apiis_admin.inspool_err WHERE (inspool_err."owner" = 'SmallPop'::text);


ALTER TABLE cong.inspool_err OWNER TO apiis_admin;

--
-- Name: languages; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW languages AS
    SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = NULL::text) UNION SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = 'SmallPop'::text);


ALTER TABLE cong.languages OWNER TO apiis_admin;

--
-- Name: load_stat; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW load_stat AS
    SELECT load_stat.ds, load_stat.job_start, load_stat.job_end, load_stat.status, load_stat.rec_tot_no, load_stat.rec_err_no, load_stat.rec_ok_no, load_stat.last_change_dt, load_stat.last_change_user, load_stat.dirty, load_stat.chk_lvl, load_stat.guid, load_stat."owner", load_stat.version, load_stat.synch FROM apiis_admin.load_stat WHERE (load_stat."owner" = NULL::text) UNION SELECT load_stat.ds, load_stat.job_start, load_stat.job_end, load_stat.status, load_stat.rec_tot_no, load_stat.rec_err_no, load_stat.rec_ok_no, load_stat.last_change_dt, load_stat.last_change_user, load_stat.dirty, load_stat.chk_lvl, load_stat.guid, load_stat."owner", load_stat.version, load_stat.synch FROM apiis_admin.load_stat WHERE (load_stat."owner" = 'SmallPop'::text);


ALTER TABLE cong.load_stat OWNER TO apiis_admin;

--
-- Name: locations; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW locations AS
    SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = NULL::text) UNION SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = 'SmallPop'::text);


ALTER TABLE cong.locations OWNER TO apiis_admin;

--
-- Name: markers; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW markers AS
    SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = NULL::text) UNION SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = 'SmallPop'::text);


ALTER TABLE cong.markers OWNER TO apiis_admin;

--
-- Name: microsatellites; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW microsatellites AS
    SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = NULL::text) UNION SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = 'SmallPop'::text);


ALTER TABLE cong.microsatellites OWNER TO apiis_admin;

--
-- Name: new_pest; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW new_pest AS
    SELECT new_pest."class", new_pest."key", new_pest.trait, new_pest.estimator, new_pest.pev, new_pest.last_change_dt, new_pest.last_change_user, new_pest.dirty, new_pest.chk_lvl, new_pest.guid, new_pest."owner", new_pest.version, new_pest.synch FROM apiis_admin.new_pest WHERE (new_pest."owner" = NULL::text) UNION SELECT new_pest."class", new_pest."key", new_pest.trait, new_pest.estimator, new_pest.pev, new_pest.last_change_dt, new_pest.last_change_user, new_pest.dirty, new_pest.chk_lvl, new_pest.guid, new_pest."owner", new_pest.version, new_pest.synch FROM apiis_admin.new_pest WHERE (new_pest."owner" = 'SmallPop'::text);


ALTER TABLE cong.new_pest OWNER TO apiis_admin;

--
-- Name: nodes; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW nodes AS
    SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = NULL::text) UNION SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = 'SmallPop'::text);


ALTER TABLE cong.nodes OWNER TO apiis_admin;

--
-- Name: organisms; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW organisms AS
    SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = NULL::text) UNION SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = 'SmallPop'::text);


ALTER TABLE cong.organisms OWNER TO apiis_admin;

--
-- Name: pcr_amplification; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW pcr_amplification AS
    SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = NULL::text) UNION SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = 'SmallPop'::text);


ALTER TABLE cong.pcr_amplification OWNER TO apiis_admin;

--
-- Name: pcr_markers; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW pcr_markers AS
    SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = NULL::text) UNION SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = 'SmallPop'::text);


ALTER TABLE cong.pcr_markers OWNER TO apiis_admin;

--
-- Name: projects; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW projects AS
    SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = NULL::text) UNION SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = 'SmallPop'::text);


ALTER TABLE cong.projects OWNER TO apiis_admin;

--
-- Name: protocols; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW protocols AS
    SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = NULL::text) UNION SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = 'SmallPop'::text);


ALTER TABLE cong.protocols OWNER TO apiis_admin;

--
-- Name: sample_collection; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW sample_collection AS
    SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = NULL::text) UNION SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = 'SmallPop'::text);


ALTER TABLE cong.sample_collection OWNER TO apiis_admin;

--
-- Name: samples; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW samples AS
    SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = NULL::text) UNION SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = 'SmallPop'::text);


ALTER TABLE cong.samples OWNER TO apiis_admin;

--
-- Name: sequences; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW sequences AS
    SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = NULL::text) UNION SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = 'SmallPop'::text);


ALTER TABLE cong.sequences OWNER TO apiis_admin;

--
-- Name: sources; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW sources AS
    SELECT sources.source, sources.tablename, sources."class", sources.columnnames, sources.last_change_dt, sources.last_change_user, sources.dirty, sources.chk_lvl, sources.guid, sources."owner", sources.version, sources.synch FROM apiis_admin.sources WHERE (sources."owner" = NULL::text) UNION SELECT sources.source, sources.tablename, sources."class", sources.columnnames, sources.last_change_dt, sources.last_change_user, sources.dirty, sources.chk_lvl, sources.guid, sources."owner", sources.version, sources.synch FROM apiis_admin.sources WHERE (sources."owner" = 'SmallPop'::text);


ALTER TABLE cong.sources OWNER TO apiis_admin;

--
-- Name: storage; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW "storage" AS
    SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = NULL::text) UNION SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = 'SmallPop'::text);


ALTER TABLE cong."storage" OWNER TO apiis_admin;

--
-- Name: storage_samples; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW storage_samples AS
    SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = NULL::text) UNION SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = 'SmallPop'::text);


ALTER TABLE cong.storage_samples OWNER TO apiis_admin;

--
-- Name: targets; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW targets AS
    SELECT targets.target, targets.tablename, targets."class", targets.columnnames, targets.last_change_dt, targets.last_change_user, targets.dirty, targets.chk_lvl, targets.guid, targets."owner", targets.version, targets.synch FROM apiis_admin.targets WHERE (targets."owner" = NULL::text) UNION SELECT targets.target, targets.tablename, targets."class", targets.columnnames, targets.last_change_dt, targets.last_change_user, targets.dirty, targets.chk_lvl, targets.guid, targets."owner", targets.version, targets.synch FROM apiis_admin.targets WHERE (targets."owner" = 'SmallPop'::text);


ALTER TABLE cong.targets OWNER TO apiis_admin;

--
-- Name: transfer; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW transfer AS
    SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = NULL::text) UNION SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = 'SmallPop'::text);


ALTER TABLE cong.transfer OWNER TO apiis_admin;

--
-- Name: unit; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW unit AS
    SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = NULL::text) UNION SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = 'SmallPop'::text);


ALTER TABLE cong.unit OWNER TO apiis_admin;

--
-- Name: v_dbtar_cong; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW v_dbtar_cong AS
    SELECT ar_dbtpolicies.dbtpolicy_id, codes.ext_code AS sqlaction, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value FROM apiis_admin.codes, apiis_admin.ar_dbtpolicies, apiis_admin.ar_dbttables, apiis_admin.ar_dbtdescriptors WHERE ((((ar_dbtpolicies.table_id = ar_dbttables.table_id) AND (ar_dbtpolicies.descriptor_id = ar_dbtdescriptors.descriptor_id)) AND (ar_dbtpolicies.action_id = codes.db_code)) AND (ar_dbtpolicies.dbtpolicy_id IN (SELECT ar_role_dbtpolicies.dbtpolicy_id FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies.role_id = ANY (ARRAY[112, 111])))));


ALTER TABLE cong.v_dbtar_cong OWNER TO apiis_admin;

--
-- Name: v_star_cong; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW v_star_cong AS
    SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies.stpolicy_id IN (SELECT ar_role_stpolicies.stpolicy_id FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies.role_id = ANY (ARRAY[112, 111]))));


ALTER TABLE cong.v_star_cong OWNER TO apiis_admin;

--
-- Name: validation; Type: VIEW; Schema: cong; Owner: apiis_admin
--

CREATE VIEW validation AS
    SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = NULL::text) UNION SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = 'SmallPop'::text);


ALTER TABLE cong.validation OWNER TO apiis_admin;

SET search_path = manager, pg_catalog;

--
-- Name: amplified_samples; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW amplified_samples AS
    SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = NULL::text) UNION SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = 'SmallPop'::text);


ALTER TABLE manager.amplified_samples OWNER TO apiis_admin;

--
-- Name: analyzed_samples; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW analyzed_samples AS
    SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = NULL::text) UNION SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = 'SmallPop'::text);


ALTER TABLE manager.analyzed_samples OWNER TO apiis_admin;

--
-- Name: blobs; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW blobs AS
    SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = NULL::text) UNION SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = 'SmallPop'::text);


ALTER TABLE manager.blobs OWNER TO apiis_admin;

--
-- Name: codes; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW codes AS
    SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = NULL::text) UNION SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = 'SmallPop'::text);


ALTER TABLE manager.codes OWNER TO apiis_admin;

--
-- Name: contacts; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW contacts AS
    SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = NULL::text) UNION SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = 'SmallPop'::text);


ALTER TABLE manager.contacts OWNER TO apiis_admin;

--
-- Name: dna_extraction; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW dna_extraction AS
    SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = NULL::text) UNION SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = 'SmallPop'::text);


ALTER TABLE manager.dna_extraction OWNER TO apiis_admin;

--
-- Name: electrophoresises; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW electrophoresises AS
    SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = NULL::text) UNION SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = 'SmallPop'::text);


ALTER TABLE manager.electrophoresises OWNER TO apiis_admin;

--
-- Name: event; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW event AS
    SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = NULL::text) UNION SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = 'SmallPop'::text);


ALTER TABLE manager.event OWNER TO apiis_admin;

--
-- Name: gel_images; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW gel_images AS
    SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = NULL::text) UNION SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = 'SmallPop'::text);


ALTER TABLE manager.gel_images OWNER TO apiis_admin;

--
-- Name: languages; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW languages AS
    SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = NULL::text) UNION SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = 'SmallPop'::text);


ALTER TABLE manager.languages OWNER TO apiis_admin;

--
-- Name: locations; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW locations AS
    SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = NULL::text) UNION SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = 'SmallPop'::text);


ALTER TABLE manager.locations OWNER TO apiis_admin;

--
-- Name: markers; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW markers AS
    SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = NULL::text) UNION SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = 'SmallPop'::text);


ALTER TABLE manager.markers OWNER TO apiis_admin;

--
-- Name: microsatellites; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW microsatellites AS
    SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = NULL::text) UNION SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = 'SmallPop'::text);


ALTER TABLE manager.microsatellites OWNER TO apiis_admin;

--
-- Name: nodes; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW nodes AS
    SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = NULL::text) UNION SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = 'SmallPop'::text);


ALTER TABLE manager.nodes OWNER TO apiis_admin;

--
-- Name: organisms; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW organisms AS
    SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = NULL::text) UNION SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = 'SmallPop'::text);


ALTER TABLE manager.organisms OWNER TO apiis_admin;

--
-- Name: pcr_amplification; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW pcr_amplification AS
    SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = NULL::text) UNION SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = 'SmallPop'::text);


ALTER TABLE manager.pcr_amplification OWNER TO apiis_admin;

--
-- Name: pcr_markers; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW pcr_markers AS
    SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = NULL::text) UNION SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = 'SmallPop'::text);


ALTER TABLE manager.pcr_markers OWNER TO apiis_admin;

--
-- Name: projects; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW projects AS
    SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = NULL::text) UNION SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = 'SmallPop'::text);


ALTER TABLE manager.projects OWNER TO apiis_admin;

--
-- Name: protocols; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW protocols AS
    SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = NULL::text) UNION SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = 'SmallPop'::text);


ALTER TABLE manager.protocols OWNER TO apiis_admin;

--
-- Name: sample_collection; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW sample_collection AS
    SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = NULL::text) UNION SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = 'SmallPop'::text);


ALTER TABLE manager.sample_collection OWNER TO apiis_admin;

--
-- Name: samples; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW samples AS
    SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = NULL::text) UNION SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = 'SmallPop'::text);


ALTER TABLE manager.samples OWNER TO apiis_admin;

--
-- Name: sequences; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW sequences AS
    SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = NULL::text) UNION SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = 'SmallPop'::text);


ALTER TABLE manager.sequences OWNER TO apiis_admin;

--
-- Name: storage; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW "storage" AS
    SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = NULL::text) UNION SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = 'SmallPop'::text);


ALTER TABLE manager."storage" OWNER TO apiis_admin;

--
-- Name: storage_samples; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW storage_samples AS
    SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = NULL::text) UNION SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = 'SmallPop'::text);


ALTER TABLE manager.storage_samples OWNER TO apiis_admin;

--
-- Name: transfer; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW transfer AS
    SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = NULL::text) UNION SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = 'SmallPop'::text);


ALTER TABLE manager.transfer OWNER TO apiis_admin;

--
-- Name: unit; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW unit AS
    SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = NULL::text) UNION SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = 'SmallPop'::text);


ALTER TABLE manager.unit OWNER TO apiis_admin;

--
-- Name: v_dbtar_manager; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW v_dbtar_manager AS
    SELECT ar_dbtpolicies.dbtpolicy_id, codes.ext_code AS sqlaction, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value FROM apiis_admin.codes, apiis_admin.ar_dbtpolicies, apiis_admin.ar_dbttables, apiis_admin.ar_dbtdescriptors WHERE ((((ar_dbtpolicies.table_id = ar_dbttables.table_id) AND (ar_dbtpolicies.descriptor_id = ar_dbtdescriptors.descriptor_id)) AND (ar_dbtpolicies.action_id = codes.db_code)) AND (ar_dbtpolicies.dbtpolicy_id IN (SELECT ar_role_dbtpolicies.dbtpolicy_id FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies.role_id = ANY (ARRAY[113, 129, 130, 131])))));


ALTER TABLE manager.v_dbtar_manager OWNER TO apiis_admin;

--
-- Name: v_star_manager; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW v_star_manager AS
    SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies.stpolicy_id IN (SELECT ar_role_stpolicies.stpolicy_id FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies.role_id = ANY (ARRAY[113, 129, 130, 131]))));


ALTER TABLE manager.v_star_manager OWNER TO apiis_admin;

--
-- Name: validation; Type: VIEW; Schema: manager; Owner: apiis_admin
--

CREATE VIEW validation AS
    SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = NULL::text) UNION SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = 'SmallPop'::text);


ALTER TABLE manager.validation OWNER TO apiis_admin;

SET search_path = molabis, pg_catalog;

--
-- Name: amplified_samples; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW amplified_samples AS
    SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = NULL::text) UNION SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = 'SmallPop'::text);


ALTER TABLE molabis.amplified_samples OWNER TO apiis_admin;

--
-- Name: analyzed_samples; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW analyzed_samples AS
    SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = NULL::text) UNION SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = 'SmallPop'::text);


ALTER TABLE molabis.analyzed_samples OWNER TO apiis_admin;

--
-- Name: ar_constraints; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_constraints AS
    SELECT ar_constraints.cons_id, ar_constraints.cons_name, ar_constraints.cons_type, ar_constraints.cons_desc, ar_constraints.last_change_dt, ar_constraints.last_change_user, ar_constraints.dirty, ar_constraints.chk_lvl, ar_constraints.guid, ar_constraints."owner", ar_constraints.version, ar_constraints.synch FROM apiis_admin.ar_constraints WHERE (ar_constraints."owner" = NULL::text) UNION SELECT ar_constraints.cons_id, ar_constraints.cons_name, ar_constraints.cons_type, ar_constraints.cons_desc, ar_constraints.last_change_dt, ar_constraints.last_change_user, ar_constraints.dirty, ar_constraints.chk_lvl, ar_constraints.guid, ar_constraints."owner", ar_constraints.version, ar_constraints.synch FROM apiis_admin.ar_constraints WHERE (ar_constraints."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_constraints OWNER TO apiis_admin;

--
-- Name: ar_dbtdescriptors; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_dbtdescriptors AS
    SELECT ar_dbtdescriptors.descriptor_id, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value, ar_dbtdescriptors.descriptor_desc, ar_dbtdescriptors.last_change_dt, ar_dbtdescriptors.last_change_user, ar_dbtdescriptors.dirty, ar_dbtdescriptors.chk_lvl, ar_dbtdescriptors.guid, ar_dbtdescriptors."owner", ar_dbtdescriptors.version, ar_dbtdescriptors.synch FROM apiis_admin.ar_dbtdescriptors WHERE (ar_dbtdescriptors."owner" = NULL::text) UNION SELECT ar_dbtdescriptors.descriptor_id, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value, ar_dbtdescriptors.descriptor_desc, ar_dbtdescriptors.last_change_dt, ar_dbtdescriptors.last_change_user, ar_dbtdescriptors.dirty, ar_dbtdescriptors.chk_lvl, ar_dbtdescriptors.guid, ar_dbtdescriptors."owner", ar_dbtdescriptors.version, ar_dbtdescriptors.synch FROM apiis_admin.ar_dbtdescriptors WHERE (ar_dbtdescriptors."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_dbtdescriptors OWNER TO apiis_admin;

--
-- Name: ar_dbtpolicies; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_dbtpolicies AS
    SELECT ar_dbtpolicies.dbtpolicy_id, ar_dbtpolicies.action_id, ar_dbtpolicies.table_id, ar_dbtpolicies.descriptor_id, ar_dbtpolicies.last_change_dt, ar_dbtpolicies.last_change_user, ar_dbtpolicies.dirty, ar_dbtpolicies.chk_lvl, ar_dbtpolicies.guid, ar_dbtpolicies."owner", ar_dbtpolicies.version, ar_dbtpolicies.synch FROM apiis_admin.ar_dbtpolicies WHERE (ar_dbtpolicies."owner" = NULL::text) UNION SELECT ar_dbtpolicies.dbtpolicy_id, ar_dbtpolicies.action_id, ar_dbtpolicies.table_id, ar_dbtpolicies.descriptor_id, ar_dbtpolicies.last_change_dt, ar_dbtpolicies.last_change_user, ar_dbtpolicies.dirty, ar_dbtpolicies.chk_lvl, ar_dbtpolicies.guid, ar_dbtpolicies."owner", ar_dbtpolicies.version, ar_dbtpolicies.synch FROM apiis_admin.ar_dbtpolicies WHERE (ar_dbtpolicies."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_dbtpolicies OWNER TO apiis_admin;

--
-- Name: ar_dbttables; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_dbttables AS
    SELECT ar_dbttables.table_id, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbttables.table_desc, ar_dbttables.last_change_dt, ar_dbttables.last_change_user, ar_dbttables.dirty, ar_dbttables.chk_lvl, ar_dbttables.guid, ar_dbttables."owner", ar_dbttables.version, ar_dbttables.synch FROM apiis_admin.ar_dbttables WHERE (ar_dbttables."owner" = NULL::text) UNION SELECT ar_dbttables.table_id, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbttables.table_desc, ar_dbttables.last_change_dt, ar_dbttables.last_change_user, ar_dbttables.dirty, ar_dbttables.chk_lvl, ar_dbttables.guid, ar_dbttables."owner", ar_dbttables.version, ar_dbttables.synch FROM apiis_admin.ar_dbttables WHERE (ar_dbttables."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_dbttables OWNER TO apiis_admin;

--
-- Name: ar_role_constraints; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_role_constraints AS
    SELECT ar_role_constraints.cons_id, ar_role_constraints.first_role_id, ar_role_constraints.second_role_id, ar_role_constraints.last_change_dt, ar_role_constraints.last_change_user, ar_role_constraints.dirty, ar_role_constraints.chk_lvl, ar_role_constraints.guid, ar_role_constraints."owner", ar_role_constraints.version, ar_role_constraints.synch FROM apiis_admin.ar_role_constraints WHERE (ar_role_constraints."owner" = NULL::text) UNION SELECT ar_role_constraints.cons_id, ar_role_constraints.first_role_id, ar_role_constraints.second_role_id, ar_role_constraints.last_change_dt, ar_role_constraints.last_change_user, ar_role_constraints.dirty, ar_role_constraints.chk_lvl, ar_role_constraints.guid, ar_role_constraints."owner", ar_role_constraints.version, ar_role_constraints.synch FROM apiis_admin.ar_role_constraints WHERE (ar_role_constraints."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_role_constraints OWNER TO apiis_admin;

--
-- Name: ar_role_dbtpolicies; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_role_dbtpolicies AS
    SELECT ar_role_dbtpolicies.role_id, ar_role_dbtpolicies.dbtpolicy_id, ar_role_dbtpolicies.last_change_dt, ar_role_dbtpolicies.last_change_user, ar_role_dbtpolicies.dirty, ar_role_dbtpolicies.chk_lvl, ar_role_dbtpolicies.guid, ar_role_dbtpolicies."owner", ar_role_dbtpolicies.version, ar_role_dbtpolicies.synch FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies."owner" = NULL::text) UNION SELECT ar_role_dbtpolicies.role_id, ar_role_dbtpolicies.dbtpolicy_id, ar_role_dbtpolicies.last_change_dt, ar_role_dbtpolicies.last_change_user, ar_role_dbtpolicies.dirty, ar_role_dbtpolicies.chk_lvl, ar_role_dbtpolicies.guid, ar_role_dbtpolicies."owner", ar_role_dbtpolicies.version, ar_role_dbtpolicies.synch FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_role_dbtpolicies OWNER TO apiis_admin;

--
-- Name: ar_role_stpolicies; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_role_stpolicies AS
    SELECT ar_role_stpolicies.role_id, ar_role_stpolicies.stpolicy_id, ar_role_stpolicies.last_change_dt, ar_role_stpolicies.last_change_user, ar_role_stpolicies.dirty, ar_role_stpolicies.chk_lvl, ar_role_stpolicies.guid, ar_role_stpolicies."owner", ar_role_stpolicies.version, ar_role_stpolicies.synch FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies."owner" = NULL::text) UNION SELECT ar_role_stpolicies.role_id, ar_role_stpolicies.stpolicy_id, ar_role_stpolicies.last_change_dt, ar_role_stpolicies.last_change_user, ar_role_stpolicies.dirty, ar_role_stpolicies.chk_lvl, ar_role_stpolicies.guid, ar_role_stpolicies."owner", ar_role_stpolicies.version, ar_role_stpolicies.synch FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_role_stpolicies OWNER TO apiis_admin;

--
-- Name: ar_roles; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_roles AS
    SELECT ar_roles.role_id, ar_roles.role_name, ar_roles.role_long_name, ar_roles.role_type, ar_roles.role_subset, ar_roles.role_descr, ar_roles.last_change_dt, ar_roles.last_change_user, ar_roles.dirty, ar_roles.chk_lvl, ar_roles.guid, ar_roles."owner", ar_roles.version, ar_roles.synch FROM apiis_admin.ar_roles WHERE (ar_roles."owner" = NULL::text) UNION SELECT ar_roles.role_id, ar_roles.role_name, ar_roles.role_long_name, ar_roles.role_type, ar_roles.role_subset, ar_roles.role_descr, ar_roles.last_change_dt, ar_roles.last_change_user, ar_roles.dirty, ar_roles.chk_lvl, ar_roles.guid, ar_roles."owner", ar_roles.version, ar_roles.synch FROM apiis_admin.ar_roles WHERE (ar_roles."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_roles OWNER TO apiis_admin;

--
-- Name: ar_stpolicies; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_stpolicies AS
    SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc, ar_stpolicies.last_change_dt, ar_stpolicies.last_change_user, ar_stpolicies.dirty, ar_stpolicies.chk_lvl, ar_stpolicies.guid, ar_stpolicies."owner", ar_stpolicies.version, ar_stpolicies.synch FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies."owner" = NULL::text) UNION SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc, ar_stpolicies.last_change_dt, ar_stpolicies.last_change_user, ar_stpolicies.dirty, ar_stpolicies.chk_lvl, ar_stpolicies.guid, ar_stpolicies."owner", ar_stpolicies.version, ar_stpolicies.synch FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_stpolicies OWNER TO apiis_admin;

--
-- Name: ar_user_roles; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_user_roles AS
    SELECT ar_user_roles.user_id, ar_user_roles.role_id, ar_user_roles.last_change_dt, ar_user_roles.last_change_user, ar_user_roles.dirty, ar_user_roles.chk_lvl, ar_user_roles.guid, ar_user_roles."owner", ar_user_roles.version, ar_user_roles.synch FROM apiis_admin.ar_user_roles WHERE (ar_user_roles."owner" = NULL::text) UNION SELECT ar_user_roles.user_id, ar_user_roles.role_id, ar_user_roles.last_change_dt, ar_user_roles.last_change_user, ar_user_roles.dirty, ar_user_roles.chk_lvl, ar_user_roles.guid, ar_user_roles."owner", ar_user_roles.version, ar_user_roles.synch FROM apiis_admin.ar_user_roles WHERE (ar_user_roles."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_user_roles OWNER TO apiis_admin;

--
-- Name: ar_users; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_users AS
    SELECT ar_users.user_id, ar_users.user_login, ar_users.user_password, ar_users.user_language_id, ar_users.user_marker, ar_users.user_disabled, ar_users.user_status, ar_users.user_last_login, ar_users.user_last_activ_time, ar_users.user_session_id, ar_users.last_change_dt, ar_users.last_change_user, ar_users.dirty, ar_users.chk_lvl, ar_users.guid, ar_users."owner", ar_users.version, ar_users.synch FROM apiis_admin.ar_users WHERE (ar_users."owner" = NULL::text) UNION SELECT ar_users.user_id, ar_users.user_login, ar_users.user_password, ar_users.user_language_id, ar_users.user_marker, ar_users.user_disabled, ar_users.user_status, ar_users.user_last_login, ar_users.user_last_activ_time, ar_users.user_session_id, ar_users.last_change_dt, ar_users.last_change_user, ar_users.dirty, ar_users.chk_lvl, ar_users.guid, ar_users."owner", ar_users.version, ar_users.synch FROM apiis_admin.ar_users WHERE (ar_users."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_users OWNER TO apiis_admin;

--
-- Name: ar_users_data; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW ar_users_data AS
    SELECT ar_users_data.user_id, ar_users_data.user_first_name, ar_users_data.user_second_name, ar_users_data.user_institution, ar_users_data.user_email, ar_users_data.user_country, ar_users_data.user_street, ar_users_data.user_town, ar_users_data.user_zip, ar_users_data.user_other_info, ar_users_data.opening_dt, ar_users_data.closing_dt, ar_users_data.last_change_dt, ar_users_data.last_change_user, ar_users_data.creation_dt, ar_users_data.creation_user, ar_users_data.end_dt, ar_users_data.end_user, ar_users_data.dirty, ar_users_data.chk_lvl, ar_users_data.guid, ar_users_data."owner", ar_users_data.version, ar_users_data.synch FROM apiis_admin.ar_users_data WHERE (ar_users_data."owner" = NULL::text) UNION SELECT ar_users_data.user_id, ar_users_data.user_first_name, ar_users_data.user_second_name, ar_users_data.user_institution, ar_users_data.user_email, ar_users_data.user_country, ar_users_data.user_street, ar_users_data.user_town, ar_users_data.user_zip, ar_users_data.user_other_info, ar_users_data.opening_dt, ar_users_data.closing_dt, ar_users_data.last_change_dt, ar_users_data.last_change_user, ar_users_data.creation_dt, ar_users_data.creation_user, ar_users_data.end_dt, ar_users_data.end_user, ar_users_data.dirty, ar_users_data.chk_lvl, ar_users_data.guid, ar_users_data."owner", ar_users_data.version, ar_users_data.synch FROM apiis_admin.ar_users_data WHERE (ar_users_data."owner" = 'SmallPop'::text);


ALTER TABLE molabis.ar_users_data OWNER TO apiis_admin;

--
-- Name: blobs; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW blobs AS
    SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = NULL::text) UNION SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = 'SmallPop'::text);


ALTER TABLE molabis.blobs OWNER TO apiis_admin;

--
-- Name: codes; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW codes AS
    SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = NULL::text) UNION SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = 'SmallPop'::text);


ALTER TABLE molabis.codes OWNER TO apiis_admin;

--
-- Name: contacts; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW contacts AS
    SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = NULL::text) UNION SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = 'SmallPop'::text);


ALTER TABLE molabis.contacts OWNER TO apiis_admin;

--
-- Name: dna_extraction; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW dna_extraction AS
    SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = NULL::text) UNION SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = 'SmallPop'::text);


ALTER TABLE molabis.dna_extraction OWNER TO apiis_admin;

--
-- Name: electrophoresises; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW electrophoresises AS
    SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = NULL::text) UNION SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = 'SmallPop'::text);


ALTER TABLE molabis.electrophoresises OWNER TO apiis_admin;

--
-- Name: event; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW event AS
    SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = NULL::text) UNION SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = 'SmallPop'::text);


ALTER TABLE molabis.event OWNER TO apiis_admin;

--
-- Name: gel_images; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW gel_images AS
    SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = NULL::text) UNION SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = 'SmallPop'::text);


ALTER TABLE molabis.gel_images OWNER TO apiis_admin;

--
-- Name: inspool; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW inspool AS
    SELECT inspool.ds, inspool.record_seq, inspool.in_date, inspool.ext_unit, inspool.proc_dt, inspool.status, inspool.record, inspool.last_change_dt, inspool.last_change_user, inspool.dirty, inspool.chk_lvl, inspool.guid, inspool."owner", inspool.version, inspool.synch FROM apiis_admin.inspool WHERE (inspool."owner" = NULL::text) UNION SELECT inspool.ds, inspool.record_seq, inspool.in_date, inspool.ext_unit, inspool.proc_dt, inspool.status, inspool.record, inspool.last_change_dt, inspool.last_change_user, inspool.dirty, inspool.chk_lvl, inspool.guid, inspool."owner", inspool.version, inspool.synch FROM apiis_admin.inspool WHERE (inspool."owner" = 'SmallPop'::text);


ALTER TABLE molabis.inspool OWNER TO apiis_admin;

--
-- Name: inspool_err; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW inspool_err AS
    SELECT inspool_err.record_seq, inspool_err.err_type, inspool_err."action", inspool_err.dbtable, inspool_err.dbcol, inspool_err.err_source, inspool_err.short_msg, inspool_err.long_msg, inspool_err.ext_col, inspool_err.ext_val, inspool_err.mod_val, inspool_err.comp_val, inspool_err.target_col, inspool_err.ds, inspool_err.ext_unit, inspool_err.status, inspool_err.err_dt, inspool_err.last_change_dt, inspool_err.last_change_user, inspool_err.dirty, inspool_err.chk_lvl, inspool_err.guid, inspool_err."owner", inspool_err.version, inspool_err.synch FROM apiis_admin.inspool_err WHERE (inspool_err."owner" = NULL::text) UNION SELECT inspool_err.record_seq, inspool_err.err_type, inspool_err."action", inspool_err.dbtable, inspool_err.dbcol, inspool_err.err_source, inspool_err.short_msg, inspool_err.long_msg, inspool_err.ext_col, inspool_err.ext_val, inspool_err.mod_val, inspool_err.comp_val, inspool_err.target_col, inspool_err.ds, inspool_err.ext_unit, inspool_err.status, inspool_err.err_dt, inspool_err.last_change_dt, inspool_err.last_change_user, inspool_err.dirty, inspool_err.chk_lvl, inspool_err.guid, inspool_err."owner", inspool_err.version, inspool_err.synch FROM apiis_admin.inspool_err WHERE (inspool_err."owner" = 'SmallPop'::text);


ALTER TABLE molabis.inspool_err OWNER TO apiis_admin;

--
-- Name: languages; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW languages AS
    SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = NULL::text) UNION SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = 'SmallPop'::text);


ALTER TABLE molabis.languages OWNER TO apiis_admin;

--
-- Name: load_stat; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW load_stat AS
    SELECT load_stat.ds, load_stat.job_start, load_stat.job_end, load_stat.status, load_stat.rec_tot_no, load_stat.rec_err_no, load_stat.rec_ok_no, load_stat.last_change_dt, load_stat.last_change_user, load_stat.dirty, load_stat.chk_lvl, load_stat.guid, load_stat."owner", load_stat.version, load_stat.synch FROM apiis_admin.load_stat WHERE (load_stat."owner" = NULL::text) UNION SELECT load_stat.ds, load_stat.job_start, load_stat.job_end, load_stat.status, load_stat.rec_tot_no, load_stat.rec_err_no, load_stat.rec_ok_no, load_stat.last_change_dt, load_stat.last_change_user, load_stat.dirty, load_stat.chk_lvl, load_stat.guid, load_stat."owner", load_stat.version, load_stat.synch FROM apiis_admin.load_stat WHERE (load_stat."owner" = 'SmallPop'::text);


ALTER TABLE molabis.load_stat OWNER TO apiis_admin;

--
-- Name: locations; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW locations AS
    SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = NULL::text) UNION SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = 'SmallPop'::text);


ALTER TABLE molabis.locations OWNER TO apiis_admin;

--
-- Name: markers; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW markers AS
    SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = NULL::text) UNION SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = 'SmallPop'::text);


ALTER TABLE molabis.markers OWNER TO apiis_admin;

--
-- Name: microsatellites; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW microsatellites AS
    SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = NULL::text) UNION SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = 'SmallPop'::text);


ALTER TABLE molabis.microsatellites OWNER TO apiis_admin;

--
-- Name: new_pest; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW new_pest AS
    SELECT new_pest."class", new_pest."key", new_pest.trait, new_pest.estimator, new_pest.pev, new_pest.last_change_dt, new_pest.last_change_user, new_pest.dirty, new_pest.chk_lvl, new_pest.guid, new_pest."owner", new_pest.version, new_pest.synch FROM apiis_admin.new_pest WHERE (new_pest."owner" = NULL::text) UNION SELECT new_pest."class", new_pest."key", new_pest.trait, new_pest.estimator, new_pest.pev, new_pest.last_change_dt, new_pest.last_change_user, new_pest.dirty, new_pest.chk_lvl, new_pest.guid, new_pest."owner", new_pest.version, new_pest.synch FROM apiis_admin.new_pest WHERE (new_pest."owner" = 'SmallPop'::text);


ALTER TABLE molabis.new_pest OWNER TO apiis_admin;

--
-- Name: nodes; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW nodes AS
    SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = NULL::text) UNION SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = 'SmallPop'::text);


ALTER TABLE molabis.nodes OWNER TO apiis_admin;

--
-- Name: organisms; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW organisms AS
    SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = NULL::text) UNION SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = 'SmallPop'::text);


ALTER TABLE molabis.organisms OWNER TO apiis_admin;

--
-- Name: pcr_amplification; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW pcr_amplification AS
    SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = NULL::text) UNION SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = 'SmallPop'::text);


ALTER TABLE molabis.pcr_amplification OWNER TO apiis_admin;

--
-- Name: pcr_markers; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW pcr_markers AS
    SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = NULL::text) UNION SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = 'SmallPop'::text);


ALTER TABLE molabis.pcr_markers OWNER TO apiis_admin;

--
-- Name: projects; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW projects AS
    SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = NULL::text) UNION SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = 'SmallPop'::text);


ALTER TABLE molabis.projects OWNER TO apiis_admin;

--
-- Name: protocols; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW protocols AS
    SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = NULL::text) UNION SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = 'SmallPop'::text);


ALTER TABLE molabis.protocols OWNER TO apiis_admin;

--
-- Name: sample_collection; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW sample_collection AS
    SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = NULL::text) UNION SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = 'SmallPop'::text);


ALTER TABLE molabis.sample_collection OWNER TO apiis_admin;

--
-- Name: samples; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW samples AS
    SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = NULL::text) UNION SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = 'SmallPop'::text);


ALTER TABLE molabis.samples OWNER TO apiis_admin;

--
-- Name: sequences; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW sequences AS
    SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = NULL::text) UNION SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = 'SmallPop'::text);


ALTER TABLE molabis.sequences OWNER TO apiis_admin;

--
-- Name: sources; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW sources AS
    SELECT sources.source, sources.tablename, sources."class", sources.columnnames, sources.last_change_dt, sources.last_change_user, sources.dirty, sources.chk_lvl, sources.guid, sources."owner", sources.version, sources.synch FROM apiis_admin.sources WHERE (sources."owner" = NULL::text) UNION SELECT sources.source, sources.tablename, sources."class", sources.columnnames, sources.last_change_dt, sources.last_change_user, sources.dirty, sources.chk_lvl, sources.guid, sources."owner", sources.version, sources.synch FROM apiis_admin.sources WHERE (sources."owner" = 'SmallPop'::text);


ALTER TABLE molabis.sources OWNER TO apiis_admin;

--
-- Name: storage; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW "storage" AS
    SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = NULL::text) UNION SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = 'SmallPop'::text);


ALTER TABLE molabis."storage" OWNER TO apiis_admin;

--
-- Name: storage_samples; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW storage_samples AS
    SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = NULL::text) UNION SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = 'SmallPop'::text);


ALTER TABLE molabis.storage_samples OWNER TO apiis_admin;

--
-- Name: targets; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW targets AS
    SELECT targets.target, targets.tablename, targets."class", targets.columnnames, targets.last_change_dt, targets.last_change_user, targets.dirty, targets.chk_lvl, targets.guid, targets."owner", targets.version, targets.synch FROM apiis_admin.targets WHERE (targets."owner" = NULL::text) UNION SELECT targets.target, targets.tablename, targets."class", targets.columnnames, targets.last_change_dt, targets.last_change_user, targets.dirty, targets.chk_lvl, targets.guid, targets."owner", targets.version, targets.synch FROM apiis_admin.targets WHERE (targets."owner" = 'SmallPop'::text);


ALTER TABLE molabis.targets OWNER TO apiis_admin;

--
-- Name: transfer; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW transfer AS
    SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = NULL::text) UNION SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = 'SmallPop'::text);


ALTER TABLE molabis.transfer OWNER TO apiis_admin;

--
-- Name: unit; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW unit AS
    SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = NULL::text) UNION SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = 'SmallPop'::text);


ALTER TABLE molabis.unit OWNER TO apiis_admin;

--
-- Name: v_dbtar_molabis; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW v_dbtar_molabis AS
    SELECT ar_dbtpolicies.dbtpolicy_id, codes.ext_code AS sqlaction, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value FROM apiis_admin.codes, apiis_admin.ar_dbtpolicies, apiis_admin.ar_dbttables, apiis_admin.ar_dbtdescriptors WHERE ((((ar_dbtpolicies.table_id = ar_dbttables.table_id) AND (ar_dbtpolicies.descriptor_id = ar_dbtdescriptors.descriptor_id)) AND (ar_dbtpolicies.action_id = codes.db_code)) AND (ar_dbtpolicies.dbtpolicy_id IN (SELECT ar_role_dbtpolicies.dbtpolicy_id FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies.role_id = ANY (ARRAY[111, 133, 129, 130, 131, 132])))));


ALTER TABLE molabis.v_dbtar_molabis OWNER TO apiis_admin;

--
-- Name: v_star_molabis; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW v_star_molabis AS
    SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies.stpolicy_id IN (SELECT ar_role_stpolicies.stpolicy_id FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies.role_id = ANY (ARRAY[111, 133, 129, 130, 131, 132]))));


ALTER TABLE molabis.v_star_molabis OWNER TO apiis_admin;

--
-- Name: validation; Type: VIEW; Schema: molabis; Owner: apiis_admin
--

CREATE VIEW validation AS
    SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = NULL::text) UNION SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = 'SmallPop'::text);


ALTER TABLE molabis.validation OWNER TO apiis_admin;

SET search_path = scientist, pg_catalog;

--
-- Name: amplified_samples; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW amplified_samples AS
    SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = NULL::text) UNION SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = 'SmallPop'::text);


ALTER TABLE scientist.amplified_samples OWNER TO apiis_admin;

--
-- Name: analyzed_samples; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW analyzed_samples AS
    SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = NULL::text) UNION SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = 'SmallPop'::text);


ALTER TABLE scientist.analyzed_samples OWNER TO apiis_admin;

--
-- Name: blobs; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW blobs AS
    SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = NULL::text) UNION SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = 'SmallPop'::text);


ALTER TABLE scientist.blobs OWNER TO apiis_admin;

--
-- Name: codes; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW codes AS
    SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = NULL::text) UNION SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = 'SmallPop'::text);


ALTER TABLE scientist.codes OWNER TO apiis_admin;

--
-- Name: contacts; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW contacts AS
    SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = NULL::text) UNION SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = 'SmallPop'::text);


ALTER TABLE scientist.contacts OWNER TO apiis_admin;

--
-- Name: dna_extraction; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW dna_extraction AS
    SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = NULL::text) UNION SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = 'SmallPop'::text);


ALTER TABLE scientist.dna_extraction OWNER TO apiis_admin;

--
-- Name: electrophoresises; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW electrophoresises AS
    SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = NULL::text) UNION SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = 'SmallPop'::text);


ALTER TABLE scientist.electrophoresises OWNER TO apiis_admin;

--
-- Name: gel_images; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW gel_images AS
    SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = NULL::text) UNION SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = 'SmallPop'::text);


ALTER TABLE scientist.gel_images OWNER TO apiis_admin;

--
-- Name: markers; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW markers AS
    SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = NULL::text) UNION SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = 'SmallPop'::text);


ALTER TABLE scientist.markers OWNER TO apiis_admin;

--
-- Name: microsatellites; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW microsatellites AS
    SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = NULL::text) UNION SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = 'SmallPop'::text);


ALTER TABLE scientist.microsatellites OWNER TO apiis_admin;

--
-- Name: organisms; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW organisms AS
    SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = NULL::text) UNION SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = 'SmallPop'::text);


ALTER TABLE scientist.organisms OWNER TO apiis_admin;

--
-- Name: pcr_amplification; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW pcr_amplification AS
    SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = NULL::text) UNION SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = 'SmallPop'::text);


ALTER TABLE scientist.pcr_amplification OWNER TO apiis_admin;

--
-- Name: pcr_markers; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW pcr_markers AS
    SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = NULL::text) UNION SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = 'SmallPop'::text);


ALTER TABLE scientist.pcr_markers OWNER TO apiis_admin;

--
-- Name: projects; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW projects AS
    SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = NULL::text) UNION SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = 'SmallPop'::text);


ALTER TABLE scientist.projects OWNER TO apiis_admin;

--
-- Name: protocols; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW protocols AS
    SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = NULL::text) UNION SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = 'SmallPop'::text);


ALTER TABLE scientist.protocols OWNER TO apiis_admin;

--
-- Name: sample_collection; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW sample_collection AS
    SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = NULL::text) UNION SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = 'SmallPop'::text);


ALTER TABLE scientist.sample_collection OWNER TO apiis_admin;

--
-- Name: samples; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW samples AS
    SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = NULL::text) UNION SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = 'SmallPop'::text);


ALTER TABLE scientist.samples OWNER TO apiis_admin;

--
-- Name: sequences; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW sequences AS
    SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = NULL::text) UNION SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = 'SmallPop'::text);


ALTER TABLE scientist.sequences OWNER TO apiis_admin;

--
-- Name: storage; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW "storage" AS
    SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = NULL::text) UNION SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = 'SmallPop'::text);


ALTER TABLE scientist."storage" OWNER TO apiis_admin;

--
-- Name: storage_samples; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW storage_samples AS
    SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = NULL::text) UNION SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = 'SmallPop'::text);


ALTER TABLE scientist.storage_samples OWNER TO apiis_admin;

--
-- Name: transfer; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW transfer AS
    SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = NULL::text) UNION SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = 'SmallPop'::text);


ALTER TABLE scientist.transfer OWNER TO apiis_admin;

--
-- Name: unit; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW unit AS
    SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = NULL::text) UNION SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = 'SmallPop'::text);


ALTER TABLE scientist.unit OWNER TO apiis_admin;

--
-- Name: v_dbtar_scientist; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW v_dbtar_scientist AS
    SELECT ar_dbtpolicies.dbtpolicy_id, codes.ext_code AS sqlaction, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value FROM apiis_admin.codes, apiis_admin.ar_dbtpolicies, apiis_admin.ar_dbttables, apiis_admin.ar_dbtdescriptors WHERE ((((ar_dbtpolicies.table_id = ar_dbttables.table_id) AND (ar_dbtpolicies.descriptor_id = ar_dbtdescriptors.descriptor_id)) AND (ar_dbtpolicies.action_id = codes.db_code)) AND (ar_dbtpolicies.dbtpolicy_id IN (SELECT ar_role_dbtpolicies.dbtpolicy_id FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies.role_id = ANY (ARRAY[124, 129, 130, 131])))));


ALTER TABLE scientist.v_dbtar_scientist OWNER TO apiis_admin;

--
-- Name: v_star_scientist; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW v_star_scientist AS
    SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies.stpolicy_id IN (SELECT ar_role_stpolicies.stpolicy_id FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies.role_id = ANY (ARRAY[124, 129, 130, 131]))));


ALTER TABLE scientist.v_star_scientist OWNER TO apiis_admin;

--
-- Name: validation; Type: VIEW; Schema: scientist; Owner: apiis_admin
--

CREATE VIEW validation AS
    SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = NULL::text) UNION SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = 'SmallPop'::text);


ALTER TABLE scientist.validation OWNER TO apiis_admin;

SET search_path = staff, pg_catalog;

--
-- Name: amplified_samples; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW amplified_samples AS
    SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = NULL::text) UNION SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = 'SmallPop'::text);


ALTER TABLE staff.amplified_samples OWNER TO apiis_admin;

--
-- Name: analyzed_samples; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW analyzed_samples AS
    SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = NULL::text) UNION SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = 'SmallPop'::text);


ALTER TABLE staff.analyzed_samples OWNER TO apiis_admin;

--
-- Name: blobs; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW blobs AS
    SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = NULL::text) UNION SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = 'SmallPop'::text);


ALTER TABLE staff.blobs OWNER TO apiis_admin;

--
-- Name: codes; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW codes AS
    SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = NULL::text) UNION SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = 'SmallPop'::text);


ALTER TABLE staff.codes OWNER TO apiis_admin;

--
-- Name: contacts; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW contacts AS
    SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = NULL::text) UNION SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = 'SmallPop'::text);


ALTER TABLE staff.contacts OWNER TO apiis_admin;

--
-- Name: dna_extraction; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW dna_extraction AS
    SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = NULL::text) UNION SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = 'SmallPop'::text);


ALTER TABLE staff.dna_extraction OWNER TO apiis_admin;

--
-- Name: electrophoresises; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW electrophoresises AS
    SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = NULL::text) UNION SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = 'SmallPop'::text);


ALTER TABLE staff.electrophoresises OWNER TO apiis_admin;

--
-- Name: event; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW event AS
    SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = NULL::text) UNION SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = 'SmallPop'::text);


ALTER TABLE staff.event OWNER TO apiis_admin;

--
-- Name: gel_images; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW gel_images AS
    SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = NULL::text) UNION SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = 'SmallPop'::text);


ALTER TABLE staff.gel_images OWNER TO apiis_admin;

--
-- Name: languages; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW languages AS
    SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = NULL::text) UNION SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = 'SmallPop'::text);


ALTER TABLE staff.languages OWNER TO apiis_admin;

--
-- Name: locations; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW locations AS
    SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = NULL::text) UNION SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = 'SmallPop'::text);


ALTER TABLE staff.locations OWNER TO apiis_admin;

--
-- Name: markers; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW markers AS
    SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = NULL::text) UNION SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = 'SmallPop'::text);


ALTER TABLE staff.markers OWNER TO apiis_admin;

--
-- Name: microsatellites; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW microsatellites AS
    SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = NULL::text) UNION SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = 'SmallPop'::text);


ALTER TABLE staff.microsatellites OWNER TO apiis_admin;

--
-- Name: nodes; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW nodes AS
    SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = NULL::text) UNION SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = 'SmallPop'::text);


ALTER TABLE staff.nodes OWNER TO apiis_admin;

--
-- Name: organisms; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW organisms AS
    SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = NULL::text) UNION SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = 'SmallPop'::text);


ALTER TABLE staff.organisms OWNER TO apiis_admin;

--
-- Name: pcr_amplification; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW pcr_amplification AS
    SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = NULL::text) UNION SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = 'SmallPop'::text);


ALTER TABLE staff.pcr_amplification OWNER TO apiis_admin;

--
-- Name: pcr_markers; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW pcr_markers AS
    SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = NULL::text) UNION SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = 'SmallPop'::text);


ALTER TABLE staff.pcr_markers OWNER TO apiis_admin;

--
-- Name: projects; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW projects AS
    SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = NULL::text) UNION SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = 'SmallPop'::text);


ALTER TABLE staff.projects OWNER TO apiis_admin;

--
-- Name: protocols; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW protocols AS
    SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = NULL::text) UNION SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = 'SmallPop'::text);


ALTER TABLE staff.protocols OWNER TO apiis_admin;

--
-- Name: sample_collection; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW sample_collection AS
    SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = NULL::text) UNION SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = 'SmallPop'::text);


ALTER TABLE staff.sample_collection OWNER TO apiis_admin;

--
-- Name: samples; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW samples AS
    SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = NULL::text) UNION SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = 'SmallPop'::text);


ALTER TABLE staff.samples OWNER TO apiis_admin;

--
-- Name: sequences; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW sequences AS
    SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = NULL::text) UNION SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = 'SmallPop'::text);


ALTER TABLE staff.sequences OWNER TO apiis_admin;

--
-- Name: storage; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW "storage" AS
    SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = NULL::text) UNION SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = 'SmallPop'::text);


ALTER TABLE staff."storage" OWNER TO apiis_admin;

--
-- Name: storage_samples; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW storage_samples AS
    SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = NULL::text) UNION SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = 'SmallPop'::text);


ALTER TABLE staff.storage_samples OWNER TO apiis_admin;

--
-- Name: transfer; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW transfer AS
    SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = NULL::text) UNION SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = 'SmallPop'::text);


ALTER TABLE staff.transfer OWNER TO apiis_admin;

--
-- Name: unit; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW unit AS
    SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = NULL::text) UNION SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = 'SmallPop'::text);


ALTER TABLE staff.unit OWNER TO apiis_admin;

--
-- Name: v_dbtar_staff; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW v_dbtar_staff AS
    SELECT ar_dbtpolicies.dbtpolicy_id, codes.ext_code AS sqlaction, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value FROM apiis_admin.codes, apiis_admin.ar_dbtpolicies, apiis_admin.ar_dbttables, apiis_admin.ar_dbtdescriptors WHERE ((((ar_dbtpolicies.table_id = ar_dbttables.table_id) AND (ar_dbtpolicies.descriptor_id = ar_dbtdescriptors.descriptor_id)) AND (ar_dbtpolicies.action_id = codes.db_code)) AND (ar_dbtpolicies.dbtpolicy_id IN (SELECT ar_role_dbtpolicies.dbtpolicy_id FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies.role_id = ANY (ARRAY[113, 124, 129, 130, 131])))));


ALTER TABLE staff.v_dbtar_staff OWNER TO apiis_admin;

--
-- Name: v_star_staff; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW v_star_staff AS
    SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies.stpolicy_id IN (SELECT ar_role_stpolicies.stpolicy_id FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies.role_id = ANY (ARRAY[113, 124, 129, 130, 131]))));


ALTER TABLE staff.v_star_staff OWNER TO apiis_admin;

--
-- Name: validation; Type: VIEW; Schema: staff; Owner: apiis_admin
--

CREATE VIEW validation AS
    SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = NULL::text) UNION SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = 'SmallPop'::text);


ALTER TABLE staff.validation OWNER TO apiis_admin;

SET search_path = super_staff, pg_catalog;

--
-- Name: amplified_samples; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW amplified_samples AS
    SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = NULL::text) UNION SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.amplified_samples OWNER TO apiis_admin;

--
-- Name: analyzed_samples; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW analyzed_samples AS
    SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = NULL::text) UNION SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.analyzed_samples OWNER TO apiis_admin;

--
-- Name: blobs; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW blobs AS
    SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = NULL::text) UNION SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.blobs OWNER TO apiis_admin;

--
-- Name: codes; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW codes AS
    SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = NULL::text) UNION SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.codes OWNER TO apiis_admin;

--
-- Name: contacts; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW contacts AS
    SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = NULL::text) UNION SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.contacts OWNER TO apiis_admin;

--
-- Name: dna_extraction; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW dna_extraction AS
    SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = NULL::text) UNION SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.dna_extraction OWNER TO apiis_admin;

--
-- Name: electrophoresises; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW electrophoresises AS
    SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = NULL::text) UNION SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.electrophoresises OWNER TO apiis_admin;

--
-- Name: event; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW event AS
    SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = NULL::text) UNION SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.event OWNER TO apiis_admin;

--
-- Name: gel_images; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW gel_images AS
    SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = NULL::text) UNION SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.gel_images OWNER TO apiis_admin;

--
-- Name: languages; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW languages AS
    SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = NULL::text) UNION SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.languages OWNER TO apiis_admin;

--
-- Name: locations; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW locations AS
    SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = NULL::text) UNION SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.locations OWNER TO apiis_admin;

--
-- Name: markers; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW markers AS
    SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = NULL::text) UNION SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.markers OWNER TO apiis_admin;

--
-- Name: microsatellites; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW microsatellites AS
    SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = NULL::text) UNION SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.microsatellites OWNER TO apiis_admin;

--
-- Name: nodes; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW nodes AS
    SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = NULL::text) UNION SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.nodes OWNER TO apiis_admin;

--
-- Name: organisms; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW organisms AS
    SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = NULL::text) UNION SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.organisms OWNER TO apiis_admin;

--
-- Name: pcr_amplification; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW pcr_amplification AS
    SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = NULL::text) UNION SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.pcr_amplification OWNER TO apiis_admin;

--
-- Name: pcr_markers; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW pcr_markers AS
    SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = NULL::text) UNION SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.pcr_markers OWNER TO apiis_admin;

--
-- Name: projects; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW projects AS
    SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = NULL::text) UNION SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.projects OWNER TO apiis_admin;

--
-- Name: protocols; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW protocols AS
    SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = NULL::text) UNION SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.protocols OWNER TO apiis_admin;

--
-- Name: sample_collection; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW sample_collection AS
    SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = NULL::text) UNION SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.sample_collection OWNER TO apiis_admin;

--
-- Name: samples; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW samples AS
    SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = NULL::text) UNION SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.samples OWNER TO apiis_admin;

--
-- Name: sequences; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW sequences AS
    SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = NULL::text) UNION SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.sequences OWNER TO apiis_admin;

--
-- Name: storage; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW "storage" AS
    SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = NULL::text) UNION SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = 'SmallPop'::text);


ALTER TABLE super_staff."storage" OWNER TO apiis_admin;

--
-- Name: storage_samples; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW storage_samples AS
    SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = NULL::text) UNION SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.storage_samples OWNER TO apiis_admin;

--
-- Name: transfer; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW transfer AS
    SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = NULL::text) UNION SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.transfer OWNER TO apiis_admin;

--
-- Name: unit; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW unit AS
    SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = NULL::text) UNION SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.unit OWNER TO apiis_admin;

--
-- Name: v_dbtar_super_staff; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW v_dbtar_super_staff AS
    SELECT ar_dbtpolicies.dbtpolicy_id, codes.ext_code AS sqlaction, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value FROM apiis_admin.codes, apiis_admin.ar_dbtpolicies, apiis_admin.ar_dbttables, apiis_admin.ar_dbtdescriptors WHERE ((((ar_dbtpolicies.table_id = ar_dbttables.table_id) AND (ar_dbtpolicies.descriptor_id = ar_dbtdescriptors.descriptor_id)) AND (ar_dbtpolicies.action_id = codes.db_code)) AND (ar_dbtpolicies.dbtpolicy_id IN (SELECT ar_role_dbtpolicies.dbtpolicy_id FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies.role_id = ANY (ARRAY[113, 124, 129, 130, 131])))));


ALTER TABLE super_staff.v_dbtar_super_staff OWNER TO apiis_admin;

--
-- Name: v_star_super_staff; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW v_star_super_staff AS
    SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies.stpolicy_id IN (SELECT ar_role_stpolicies.stpolicy_id FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies.role_id = ANY (ARRAY[113, 124, 129, 130, 131]))));


ALTER TABLE super_staff.v_star_super_staff OWNER TO apiis_admin;

--
-- Name: validation; Type: VIEW; Schema: super_staff; Owner: apiis_admin
--

CREATE VIEW validation AS
    SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = NULL::text) UNION SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = 'SmallPop'::text);


ALTER TABLE super_staff.validation OWNER TO apiis_admin;

SET search_path = visitor, pg_catalog;

--
-- Name: amplified_samples; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW amplified_samples AS
    SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = NULL::text) UNION SELECT amplified_samples.amplification_id, amplified_samples.dna_id, amplified_samples.validation_id, amplified_samples."comment", amplified_samples.chk_lvl, amplified_samples.dirty, amplified_samples.guid, amplified_samples.last_change_dt, amplified_samples.last_change_user, amplified_samples."owner", amplified_samples.synch, amplified_samples.version FROM apiis_admin.amplified_samples WHERE (amplified_samples."owner" = 'SmallPop'::text);


ALTER TABLE visitor.amplified_samples OWNER TO apiis_admin;

--
-- Name: analyzed_samples; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW analyzed_samples AS
    SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = NULL::text) UNION SELECT analyzed_samples.electrophoresis_id, analyzed_samples.dna_id, analyzed_samples.marker_id, analyzed_samples.chk_lvl, analyzed_samples.dirty, analyzed_samples.guid, analyzed_samples.last_change_dt, analyzed_samples.last_change_user, analyzed_samples."owner", analyzed_samples.synch, analyzed_samples.version FROM apiis_admin.analyzed_samples WHERE (analyzed_samples."owner" = 'SmallPop'::text);


ALTER TABLE visitor.analyzed_samples OWNER TO apiis_admin;

--
-- Name: blobs; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW blobs AS
    SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = NULL::text) UNION SELECT blobs.blob_id, blobs.blob, blobs.db_mimetype, blobs.last_change_dt, blobs.last_change_user, blobs.dirty, blobs.chk_lvl, blobs.guid, blobs."owner", blobs.version, blobs.synch FROM apiis_admin.blobs WHERE (blobs."owner" = 'SmallPop'::text);


ALTER TABLE visitor.blobs OWNER TO apiis_admin;

--
-- Name: codes; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW codes AS
    SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = NULL::text) UNION SELECT codes.ext_code, codes."class", codes.db_code, codes.short_name, codes.long_name, codes.description, codes.opening_dt, codes.closing_dt, codes.last_change_dt, codes.last_change_user, codes.dirty, codes.chk_lvl, codes.guid, codes."owner", codes.version, codes.synch FROM apiis_admin.codes WHERE (codes."owner" = 'SmallPop'::text);


ALTER TABLE visitor.codes OWNER TO apiis_admin;

--
-- Name: contacts; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW contacts AS
    SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = NULL::text) UNION SELECT contacts.db_contact, contacts.title, contacts.salutation, contacts.first_name, contacts.second_name, contacts.third_name, contacts.birth_dt, contacts.db_language, contacts.street, contacts.zip, contacts.town, contacts.db_country, contacts.label, contacts.phone, contacts.phone2, contacts.fax, contacts.email, contacts.bank_name, contacts.bank_zip, contacts.account, contacts.opening_dt, contacts.closing_dt, contacts."comment", contacts.chk_lvl, contacts.dirty, contacts.guid, contacts.last_change_dt, contacts.last_change_user, contacts."owner", contacts.synch, contacts.version FROM apiis_admin.contacts WHERE (contacts."owner" = 'SmallPop'::text);


ALTER TABLE visitor.contacts OWNER TO apiis_admin;

--
-- Name: dna_extraction; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW dna_extraction AS
    SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = NULL::text) UNION SELECT dna_extraction.chk_lvl, dna_extraction.dirty, dna_extraction.guid, dna_extraction.last_change_dt, dna_extraction.last_change_user, dna_extraction."owner", dna_extraction.synch, dna_extraction.version, dna_extraction.dna_id, dna_extraction.sample_id, dna_extraction.project_id, dna_extraction.validation_id, dna_extraction.dna_concentration, dna_extraction.dna_purity, dna_extraction.reused FROM apiis_admin.dna_extraction WHERE (dna_extraction."owner" = 'SmallPop'::text);


ALTER TABLE visitor.dna_extraction OWNER TO apiis_admin;

--
-- Name: electrophoresises; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW electrophoresises AS
    SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = NULL::text) UNION SELECT electrophoresises.electrophoresis_id, electrophoresises.ext_electrophoresis, electrophoresises.project_id, electrophoresises.db_user, electrophoresises.db_software, electrophoresises.product_id, electrophoresises.protocol_id, electrophoresises.electrophoresis_dt, electrophoresises.db_method, electrophoresises.purpose, electrophoresises."comment", electrophoresises.chk_lvl, electrophoresises.dirty, electrophoresises.guid, electrophoresises.last_change_dt, electrophoresises.last_change_user, electrophoresises."owner", electrophoresises.synch, electrophoresises.version FROM apiis_admin.electrophoresises WHERE (electrophoresises."owner" = 'SmallPop'::text);


ALTER TABLE visitor.electrophoresises OWNER TO apiis_admin;

--
-- Name: event; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW event AS
    SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = NULL::text) UNION SELECT event.event_id, event.db_event_type, event.db_sampler, event.event_dt, event.db_location, event.last_change_dt, event.last_change_user, event.dirty, event.chk_lvl, event.guid, event."owner", event.version, event.synch FROM apiis_admin.event WHERE (event."owner" = 'SmallPop'::text);


ALTER TABLE visitor.event OWNER TO apiis_admin;

--
-- Name: gel_images; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW gel_images AS
    SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = NULL::text) UNION SELECT gel_images.gel_id, gel_images.sample_id, gel_images.lane, gel_images."valid", gel_images.chk_lvl, gel_images.dirty, gel_images.guid, gel_images.last_change_dt, gel_images.last_change_user, gel_images."owner", gel_images.synch, gel_images.version FROM apiis_admin.gel_images WHERE (gel_images."owner" = 'SmallPop'::text);


ALTER TABLE visitor.gel_images OWNER TO apiis_admin;

--
-- Name: languages; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW languages AS
    SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = NULL::text) UNION SELECT languages.lang_id, languages.iso_lang, languages.lang, languages.last_change_dt, languages.last_change_user, languages.creation_dt, languages.creation_user, languages.end_dt, languages.end_user, languages.dirty, languages.chk_lvl, languages.guid, languages."owner", languages.version, languages.synch FROM apiis_admin.languages WHERE (languages."owner" = 'SmallPop'::text);


ALTER TABLE visitor.languages OWNER TO apiis_admin;

--
-- Name: locations; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW locations AS
    SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = NULL::text) UNION SELECT locations.db_organism, locations.db_location, locations.entry_dt, locations.db_entry_action, locations.exit_dt, locations.db_exit_action, locations.chk_lvl, locations.dirty, locations.guid, locations.last_change_dt, locations.last_change_user, locations."owner", locations.synch, locations.version FROM apiis_admin.locations WHERE (locations."owner" = 'SmallPop'::text);


ALTER TABLE visitor.locations OWNER TO apiis_admin;

--
-- Name: markers; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW markers AS
    SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = NULL::text) UNION SELECT markers.marker_id, markers.marker_name, markers.db_marker_type, markers.db_primer1, markers.db_primer2, markers."comment", markers.chk_lvl, markers.dirty, markers.guid, markers.last_change_dt, markers.last_change_user, markers."owner", markers.synch, markers.version FROM apiis_admin.markers WHERE (markers."owner" = 'SmallPop'::text);


ALTER TABLE visitor.markers OWNER TO apiis_admin;

--
-- Name: microsatellites; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW microsatellites AS
    SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = NULL::text) UNION SELECT microsatellites.microsatellite_id, microsatellites.dna_id, microsatellites.project_id, microsatellites.marker_id, microsatellites.allele1, microsatellites.allele2, microsatellites."comment", microsatellites.chk_lvl, microsatellites.dirty, microsatellites.guid, microsatellites.last_change_dt, microsatellites.last_change_user, microsatellites."owner", microsatellites.synch, microsatellites.version FROM apiis_admin.microsatellites WHERE (microsatellites."owner" = 'SmallPop'::text);


ALTER TABLE visitor.microsatellites OWNER TO apiis_admin;

--
-- Name: nodes; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW nodes AS
    SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = NULL::text) UNION SELECT nodes.nodename, nodes.address, nodes.last_change_dt, nodes.last_change_user, nodes.dirty, nodes.chk_lvl, nodes.guid, nodes."owner", nodes.version, nodes.synch FROM apiis_admin.nodes WHERE (nodes."owner" = 'SmallPop'::text);


ALTER TABLE visitor.nodes OWNER TO apiis_admin;

--
-- Name: organisms; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW organisms AS
    SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = NULL::text) UNION SELECT organisms.db_organism, organisms.db_sire, organisms.db_dam, organisms.db_sex, organisms.birth_dt, organisms.birth_year, organisms.latitude, organisms.longitude, organisms.db_donor_type, organisms.db_species, organisms.db_breed, organisms.db_photo, organisms."comment", organisms.la_rep, organisms.la_rep_dt, organisms.last_change_dt, organisms.last_change_user, organisms.dirty, organisms.chk_lvl, organisms.guid, organisms."owner", organisms.version, organisms.synch, organisms.db_hybrid FROM apiis_admin.organisms WHERE (organisms."owner" = 'SmallPop'::text);


ALTER TABLE visitor.organisms OWNER TO apiis_admin;

--
-- Name: pcr_amplification; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW pcr_amplification AS
    SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = NULL::text) UNION SELECT pcr_amplification.amplification_id, pcr_amplification.ext_amplification, pcr_amplification.project_id, pcr_amplification.protocol_id, pcr_amplification."comment", pcr_amplification.chk_lvl, pcr_amplification.dirty, pcr_amplification.guid, pcr_amplification.last_change_dt, pcr_amplification.last_change_user, pcr_amplification."owner", pcr_amplification.synch, pcr_amplification.version FROM apiis_admin.pcr_amplification WHERE (pcr_amplification."owner" = 'SmallPop'::text);


ALTER TABLE visitor.pcr_amplification OWNER TO apiis_admin;

--
-- Name: pcr_markers; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW pcr_markers AS
    SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = NULL::text) UNION SELECT pcr_markers.amplification_id, pcr_markers.marker_id, pcr_markers.chk_lvl, pcr_markers.dirty, pcr_markers.guid, pcr_markers.last_change_dt, pcr_markers.last_change_user, pcr_markers."owner", pcr_markers.synch, pcr_markers.version FROM apiis_admin.pcr_markers WHERE (pcr_markers."owner" = 'SmallPop'::text);


ALTER TABLE visitor.pcr_markers OWNER TO apiis_admin;

--
-- Name: projects; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW projects AS
    SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = NULL::text) UNION SELECT projects.chk_lvl, projects.dirty, projects.guid, projects.last_change_dt, projects.last_change_user, projects."owner", projects.synch, projects.version, projects.project_id, projects.project_name, projects.keyword, projects.begin_dt, projects.finish_dt, projects.description, projects."comment" FROM apiis_admin.projects WHERE (projects."owner" = 'SmallPop'::text);


ALTER TABLE visitor.projects OWNER TO apiis_admin;

--
-- Name: protocols; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW protocols AS
    SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = NULL::text) UNION SELECT protocols.protocol_id, protocols.protocol_name, protocols."comment", protocols.chk_lvl, protocols.dirty, protocols.guid, protocols.last_change_dt, protocols.last_change_user, protocols."owner", protocols.synch, protocols.version, protocols.db_protocol_type FROM apiis_admin.protocols WHERE (protocols."owner" = 'SmallPop'::text);


ALTER TABLE visitor.protocols OWNER TO apiis_admin;

--
-- Name: sample_collection; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW sample_collection AS
    SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = NULL::text) UNION SELECT sample_collection.chk_lvl, sample_collection.dirty, sample_collection.guid, sample_collection.last_change_dt, sample_collection.last_change_user, sample_collection."owner", sample_collection.synch, sample_collection.version, sample_collection.sample_id, sample_collection.project_id, sample_collection.reused FROM apiis_admin.sample_collection WHERE (sample_collection."owner" = 'SmallPop'::text);


ALTER TABLE visitor.sample_collection OWNER TO apiis_admin;

--
-- Name: samples; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW samples AS
    SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = NULL::text) UNION SELECT samples.chk_lvl, samples.dirty, samples.guid, samples.last_change_dt, samples.last_change_user, samples."owner", samples.synch, samples.version, samples.sample_id, samples.ext_sample, samples.db_organism, samples.db_vessel_type, samples.db_material_type, samples.db_user, samples.protocol_id, samples.production_dt, samples.storage_dt, samples."comment" FROM apiis_admin.samples WHERE (samples."owner" = 'SmallPop'::text);


ALTER TABLE visitor.samples OWNER TO apiis_admin;

--
-- Name: sequences; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW sequences AS
    SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = NULL::text) UNION SELECT sequences.sequence_id, sequences.dna_id, sequences.project_id, sequences.marker_id, sequences."sequence", sequences."comment", sequences.chk_lvl, sequences.dirty, sequences.guid, sequences.last_change_dt, sequences.last_change_user, sequences."owner", sequences.synch, sequences.version FROM apiis_admin.sequences WHERE (sequences."owner" = 'SmallPop'::text);


ALTER TABLE visitor.sequences OWNER TO apiis_admin;

--
-- Name: storage; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW "storage" AS
    SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = NULL::text) UNION SELECT "storage".storage_id, "storage".storage_name, "storage".parent_id, "storage"."comment", "storage".chk_lvl, "storage".dirty, "storage".guid, "storage".last_change_dt, "storage".last_change_user, "storage"."owner", "storage".synch, "storage".version FROM apiis_admin."storage" WHERE ("storage"."owner" = 'SmallPop'::text);


ALTER TABLE visitor."storage" OWNER TO apiis_admin;

--
-- Name: storage_samples; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW storage_samples AS
    SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = NULL::text) UNION SELECT storage_samples.chk_lvl, storage_samples.dirty, storage_samples.guid, storage_samples.last_change_dt, storage_samples.last_change_user, storage_samples."owner", storage_samples.synch, storage_samples.version, storage_samples.storage_id, storage_samples.sample_id, storage_samples.no_units FROM apiis_admin.storage_samples WHERE (storage_samples."owner" = 'SmallPop'::text);


ALTER TABLE visitor.storage_samples OWNER TO apiis_admin;

--
-- Name: transfer; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW transfer AS
    SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = NULL::text) UNION SELECT transfer.db_organism, transfer.ext_organism, transfer.db_unit, transfer.id_set, transfer.opening_dt, transfer.closing_dt, transfer.last_change_dt, transfer.last_change_user, transfer.dirty, transfer.chk_lvl, transfer.guid, transfer."owner", transfer.version, transfer.synch FROM apiis_admin.transfer WHERE (transfer."owner" = 'SmallPop'::text);


ALTER TABLE visitor.transfer OWNER TO apiis_admin;

--
-- Name: unit; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW unit AS
    SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = NULL::text) UNION SELECT unit.db_unit, unit.ext_unit, unit.ext_id, unit.db_contact, unit.db_member, unit.opening_dt, unit.closing_dt, unit.last_change_dt, unit.last_change_user, unit.dirty, unit.chk_lvl, unit.guid, unit."owner", unit.version, unit.synch FROM apiis_admin.unit WHERE (unit."owner" = 'SmallPop'::text);


ALTER TABLE visitor.unit OWNER TO apiis_admin;

--
-- Name: v_dbtar_visitor; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW v_dbtar_visitor AS
    SELECT ar_dbtpolicies.dbtpolicy_id, codes.ext_code AS sqlaction, ar_dbttables.table_name, ar_dbttables.table_columns, ar_dbtdescriptors.descriptor_name, ar_dbtdescriptors.descriptor_value FROM apiis_admin.codes, apiis_admin.ar_dbtpolicies, apiis_admin.ar_dbttables, apiis_admin.ar_dbtdescriptors WHERE ((((ar_dbtpolicies.table_id = ar_dbttables.table_id) AND (ar_dbtpolicies.descriptor_id = ar_dbtdescriptors.descriptor_id)) AND (ar_dbtpolicies.action_id = codes.db_code)) AND (ar_dbtpolicies.dbtpolicy_id IN (SELECT ar_role_dbtpolicies.dbtpolicy_id FROM apiis_admin.ar_role_dbtpolicies WHERE (ar_role_dbtpolicies.role_id = ANY (ARRAY[125, 129])))));


ALTER TABLE visitor.v_dbtar_visitor OWNER TO apiis_admin;

--
-- Name: v_star_visitor; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW v_star_visitor AS
    SELECT ar_stpolicies.stpolicy_id, ar_stpolicies.stpolicy_name, ar_stpolicies.stpolicy_type, ar_stpolicies.stpolicy_desc FROM apiis_admin.ar_stpolicies WHERE (ar_stpolicies.stpolicy_id IN (SELECT ar_role_stpolicies.stpolicy_id FROM apiis_admin.ar_role_stpolicies WHERE (ar_role_stpolicies.role_id = ANY (ARRAY[125, 129]))));


ALTER TABLE visitor.v_star_visitor OWNER TO apiis_admin;

--
-- Name: validation; Type: VIEW; Schema: visitor; Owner: apiis_admin
--

CREATE VIEW validation AS
    SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = NULL::text) UNION SELECT validation.validation_id, validation.gel_id, validation.protocol_id, validation."comment", validation.chk_lvl, validation.dirty, validation.guid, validation.last_change_dt, validation.last_change_user, validation."owner", validation.synch, validation.version FROM apiis_admin.validation WHERE (validation."owner" = 'SmallPop'::text);


ALTER TABLE visitor.validation OWNER TO apiis_admin;

SET search_path = apiis_admin, pg_catalog;

--
-- Data for Name: amplified_samples; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY amplified_samples (amplification_id, dna_id, validation_id, "comment", chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Data for Name: analyzed_samples; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY analyzed_samples (electrophoresis_id, dna_id, marker_id, chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Data for Name: ar_constraints; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_constraints (cons_id, cons_name, cons_type, cons_desc, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
\.


--
-- Data for Name: ar_dbtdescriptors; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_dbtdescriptors (descriptor_id, descriptor_name, descriptor_value, descriptor_desc, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
1	owner	(=)SmallPop	\N	2009-11-01 14:21:44	cong	\N	\N	220	SmallPop	1	f
\.


--
-- Data for Name: ar_dbtpolicies; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_dbtpolicies (dbtpolicy_id, action_id, table_id, descriptor_id, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
127	101	64	1	2009-11-01 14:21:44	cong	\N	\N	221	SmallPop	1	f
32	102	16	1	2009-11-01 14:21:44	cong	\N	\N	222	SmallPop	1	f
90	100	46	1	2009-11-01 14:21:44	cong	\N	\N	223	SmallPop	1	f
118	100	60	1	2009-11-01 14:21:44	cong	\N	\N	224	SmallPop	1	f
71	101	36	1	2009-11-01 14:21:44	cong	\N	\N	225	SmallPop	1	f
102	100	52	1	2009-11-01 14:21:44	cong	\N	\N	226	SmallPop	1	f
18	100	10	1	2009-11-01 14:21:44	cong	\N	\N	227	SmallPop	1	f
125	103	63	1	2009-11-01 14:21:44	cong	\N	\N	228	SmallPop	1	f
16	102	8	1	2009-11-01 14:21:44	cong	\N	\N	229	SmallPop	1	f
44	102	22	1	2009-11-01 14:21:44	cong	\N	\N	230	SmallPop	1	f
55	101	28	1	2009-11-01 14:21:44	cong	\N	\N	231	SmallPop	1	f
84	102	42	1	2009-11-01 14:21:44	cong	\N	\N	232	SmallPop	1	f
27	101	14	1	2009-11-01 14:21:44	cong	\N	\N	233	SmallPop	1	f
161	103	81	1	2009-11-01 14:21:44	cong	\N	\N	234	SmallPop	1	f
95	101	48	1	2009-11-01 14:21:44	cong	\N	\N	235	SmallPop	1	f
57	103	29	1	2009-11-01 14:21:44	cong	\N	\N	236	SmallPop	1	f
20	102	10	1	2009-11-01 14:21:44	cong	\N	\N	237	SmallPop	1	f
163	101	82	1	2009-11-01 14:21:44	cong	\N	\N	238	SmallPop	1	f
109	103	55	1	2009-11-01 14:21:44	cong	\N	\N	239	SmallPop	1	f
151	101	76	1	2009-11-01 14:21:44	cong	\N	\N	240	SmallPop	1	f
89	103	45	1	2009-11-01 14:21:44	cong	\N	\N	241	SmallPop	1	f
175	101	88	1	2009-11-01 14:21:44	cong	\N	\N	242	SmallPop	1	f
148	102	74	1	2009-11-01 14:21:44	cong	\N	\N	243	SmallPop	1	f
31	101	16	1	2009-11-01 14:21:44	cong	\N	\N	244	SmallPop	1	f
35	101	18	1	2009-11-01 14:21:44	cong	\N	\N	245	SmallPop	1	f
11	101	6	1	2009-11-01 14:21:44	cong	\N	\N	246	SmallPop	1	f
78	100	40	1	2009-11-01 14:21:44	cong	\N	\N	247	SmallPop	1	f
93	103	47	1	2009-11-01 14:21:44	cong	\N	\N	248	SmallPop	1	f
106	100	54	1	2009-11-01 14:21:44	cong	\N	\N	249	SmallPop	1	f
157	103	79	1	2009-11-01 14:21:44	cong	\N	\N	250	SmallPop	1	f
65	103	33	1	2009-11-01 14:21:44	cong	\N	\N	251	SmallPop	1	f
29	103	15	1	2009-11-01 14:21:44	cong	\N	\N	252	SmallPop	1	f
138	100	70	1	2009-11-01 14:21:44	cong	\N	\N	253	SmallPop	1	f
114	100	58	1	2009-11-01 14:21:44	cong	\N	\N	254	SmallPop	1	f
58	100	30	1	2009-11-01 14:21:44	cong	\N	\N	255	SmallPop	1	f
153	103	77	1	2009-11-01 14:21:44	cong	\N	\N	256	SmallPop	1	f
15	101	8	1	2009-11-01 14:21:44	cong	\N	\N	257	SmallPop	1	f
137	103	69	1	2009-11-01 14:21:44	cong	\N	\N	258	SmallPop	1	f
81	103	41	1	2009-11-01 14:21:44	cong	\N	\N	259	SmallPop	1	f
60	102	30	1	2009-11-01 14:21:44	cong	\N	\N	260	SmallPop	1	f
101	103	51	1	2009-11-01 14:21:44	cong	\N	\N	261	SmallPop	1	f
73	103	37	1	2009-11-01 14:21:44	cong	\N	\N	262	SmallPop	1	f
86	100	44	1	2009-11-01 14:21:44	cong	\N	\N	263	SmallPop	1	f
76	102	38	1	2009-11-01 14:21:44	cong	\N	\N	264	SmallPop	1	f
62	100	32	1	2009-11-01 14:21:44	cong	\N	\N	265	SmallPop	1	f
67	101	34	1	2009-11-01 14:21:44	cong	\N	\N	266	SmallPop	1	f
165	103	83	1	2009-11-01 14:21:44	cong	\N	\N	267	SmallPop	1	f
139	101	70	1	2009-11-01 14:21:44	cong	\N	\N	268	SmallPop	1	f
129	103	65	1	2009-11-01 14:21:44	cong	\N	\N	269	SmallPop	1	f
2	100	2	1	2009-11-01 14:21:44	cong	\N	\N	270	SmallPop	1	f
17	103	9	1	2009-11-01 14:21:44	cong	\N	\N	271	SmallPop	1	f
110	100	56	1	2009-11-01 14:21:44	cong	\N	\N	272	SmallPop	1	f
82	100	42	1	2009-11-01 14:21:44	cong	\N	\N	273	SmallPop	1	f
147	101	74	1	2009-11-01 14:21:44	cong	\N	\N	274	SmallPop	1	f
168	102	84	1	2009-11-01 14:21:44	cong	\N	\N	275	SmallPop	1	f
135	101	68	1	2009-11-01 14:21:44	cong	\N	\N	276	SmallPop	1	f
14	100	8	1	2009-11-01 14:21:44	cong	\N	\N	277	SmallPop	1	f
112	102	56	1	2009-11-01 14:21:44	cong	\N	\N	278	SmallPop	1	f
69	103	35	1	2009-11-01 14:21:44	cong	\N	\N	279	SmallPop	1	f
172	102	86	1	2009-11-01 14:21:44	cong	\N	\N	280	SmallPop	1	f
145	103	73	1	2009-11-01 14:21:44	cong	\N	\N	281	SmallPop	1	f
49	103	25	1	2009-11-01 14:21:44	cong	\N	\N	282	SmallPop	1	f
178	100	90	1	2009-11-01 14:21:44	cong	\N	\N	283	SmallPop	1	f
24	102	12	1	2009-11-01 14:21:44	cong	\N	\N	284	SmallPop	1	f
140	102	70	1	2009-11-01 14:21:44	cong	\N	\N	285	SmallPop	1	f
124	102	62	1	2009-11-01 14:21:44	cong	\N	\N	286	SmallPop	1	f
104	102	52	1	2009-11-01 14:21:44	cong	\N	\N	287	SmallPop	1	f
131	101	66	1	2009-11-01 14:21:44	cong	\N	\N	288	SmallPop	1	f
121	103	61	1	2009-11-01 14:21:44	cong	\N	\N	289	SmallPop	1	f
79	101	40	1	2009-11-01 14:21:44	cong	\N	\N	290	SmallPop	1	f
154	100	78	1	2009-11-01 14:21:44	cong	\N	\N	291	SmallPop	1	f
23	101	12	1	2009-11-01 14:21:44	cong	\N	\N	292	SmallPop	1	f
96	102	48	1	2009-11-01 14:21:44	cong	\N	\N	293	SmallPop	1	f
126	100	64	1	2009-11-01 14:21:44	cong	\N	\N	294	SmallPop	1	f
159	101	80	1	2009-11-01 14:21:44	cong	\N	\N	295	SmallPop	1	f
160	102	80	1	2009-11-01 14:21:44	cong	\N	\N	296	SmallPop	1	f
176	102	88	1	2009-11-01 14:21:44	cong	\N	\N	297	SmallPop	1	f
47	101	24	1	2009-11-01 14:21:44	cong	\N	\N	298	SmallPop	1	f
8	102	4	1	2009-11-01 14:21:44	cong	\N	\N	299	SmallPop	1	f
98	100	50	1	2009-11-01 14:21:44	cong	\N	\N	300	SmallPop	1	f
37	103	19	1	2009-11-01 14:21:44	cong	\N	\N	301	SmallPop	1	f
117	103	59	1	2009-11-01 14:21:44	cong	\N	\N	302	SmallPop	1	f
43	101	22	1	2009-11-01 14:21:44	cong	\N	\N	303	SmallPop	1	f
5	103	3	1	2009-11-01 14:21:44	cong	\N	\N	304	SmallPop	1	f
170	100	86	1	2009-11-01 14:21:44	cong	\N	\N	305	SmallPop	1	f
33	103	17	1	2009-11-01 14:21:44	cong	\N	\N	306	SmallPop	1	f
21	103	11	1	2009-11-01 14:21:44	cong	\N	\N	307	SmallPop	1	f
63	101	32	1	2009-11-01 14:21:44	cong	\N	\N	308	SmallPop	1	f
7	101	4	1	2009-11-01 14:21:44	cong	\N	\N	309	SmallPop	1	f
26	100	14	1	2009-11-01 14:21:44	cong	\N	\N	310	SmallPop	1	f
80	102	40	1	2009-11-01 14:21:44	cong	\N	\N	311	SmallPop	1	f
119	101	60	1	2009-11-01 14:21:44	cong	\N	\N	312	SmallPop	1	f
180	102	90	1	2009-11-01 14:21:44	cong	\N	\N	313	SmallPop	1	f
99	101	50	1	2009-11-01 14:21:44	cong	\N	\N	314	SmallPop	1	f
179	101	90	1	2009-11-01 14:21:44	cong	\N	\N	315	SmallPop	1	f
162	100	82	1	2009-11-01 14:21:44	cong	\N	\N	316	SmallPop	1	f
72	102	36	1	2009-11-01 14:21:44	cong	\N	\N	317	SmallPop	1	f
74	100	38	1	2009-11-01 14:21:44	cong	\N	\N	318	SmallPop	1	f
61	103	31	1	2009-11-01 14:21:44	cong	\N	\N	319	SmallPop	1	f
108	102	54	1	2009-11-01 14:21:44	cong	\N	\N	320	SmallPop	1	f
115	101	58	1	2009-11-01 14:21:44	cong	\N	\N	321	SmallPop	1	f
92	102	46	1	2009-11-01 14:21:44	cong	\N	\N	322	SmallPop	1	f
103	101	52	1	2009-11-01 14:21:44	cong	\N	\N	323	SmallPop	1	f
10	100	6	1	2009-11-01 14:21:44	cong	\N	\N	324	SmallPop	1	f
113	103	57	1	2009-11-01 14:21:44	cong	\N	\N	325	SmallPop	1	f
152	102	76	1	2009-11-01 14:21:44	cong	\N	\N	326	SmallPop	1	f
142	100	72	1	2009-11-01 14:21:44	cong	\N	\N	327	SmallPop	1	f
91	101	46	1	2009-11-01 14:21:44	cong	\N	\N	328	SmallPop	1	f
167	101	84	1	2009-11-01 14:21:44	cong	\N	\N	329	SmallPop	1	f
48	102	24	1	2009-11-01 14:21:44	cong	\N	\N	330	SmallPop	1	f
107	101	54	1	2009-11-01 14:21:44	cong	\N	\N	331	SmallPop	1	f
87	101	44	1	2009-11-01 14:21:44	cong	\N	\N	332	SmallPop	1	f
174	100	88	1	2009-11-01 14:21:44	cong	\N	\N	333	SmallPop	1	f
77	103	39	1	2009-11-01 14:21:44	cong	\N	\N	334	SmallPop	1	f
133	103	67	1	2009-11-01 14:21:44	cong	\N	\N	335	SmallPop	1	f
149	103	75	1	2009-11-01 14:21:44	cong	\N	\N	336	SmallPop	1	f
123	101	62	1	2009-11-01 14:21:44	cong	\N	\N	337	SmallPop	1	f
50	100	26	1	2009-11-01 14:21:44	cong	\N	\N	338	SmallPop	1	f
39	101	20	1	2009-11-01 14:21:44	cong	\N	\N	339	SmallPop	1	f
64	102	32	1	2009-11-01 14:21:44	cong	\N	\N	340	SmallPop	1	f
97	103	49	1	2009-11-01 14:21:44	cong	\N	\N	341	SmallPop	1	f
12	102	6	1	2009-11-01 14:21:44	cong	\N	\N	342	SmallPop	1	f
41	103	21	1	2009-11-01 14:21:44	cong	\N	\N	343	SmallPop	1	f
52	102	26	1	2009-11-01 14:21:44	cong	\N	\N	344	SmallPop	1	f
173	103	87	1	2009-11-01 14:21:44	cong	\N	\N	345	SmallPop	1	f
56	102	28	1	2009-11-01 14:21:44	cong	\N	\N	346	SmallPop	1	f
45	103	23	1	2009-11-01 14:21:44	cong	\N	\N	347	SmallPop	1	f
66	100	34	1	2009-11-01 14:21:44	cong	\N	\N	348	SmallPop	1	f
19	101	10	1	2009-11-01 14:21:44	cong	\N	\N	349	SmallPop	1	f
54	100	28	1	2009-11-01 14:21:44	cong	\N	\N	350	SmallPop	1	f
70	100	36	1	2009-11-01 14:21:44	cong	\N	\N	351	SmallPop	1	f
68	102	34	1	2009-11-01 14:21:44	cong	\N	\N	352	SmallPop	1	f
166	100	84	1	2009-11-01 14:21:44	cong	\N	\N	353	SmallPop	1	f
1	103	1	1	2009-11-01 14:21:44	cong	\N	\N	354	SmallPop	1	f
136	102	68	1	2009-11-01 14:21:44	cong	\N	\N	355	SmallPop	1	f
88	102	44	1	2009-11-01 14:21:44	cong	\N	\N	356	SmallPop	1	f
116	102	58	1	2009-11-01 14:21:44	cong	\N	\N	357	SmallPop	1	f
144	102	72	1	2009-11-01 14:21:44	cong	\N	\N	358	SmallPop	1	f
141	103	71	1	2009-11-01 14:21:44	cong	\N	\N	359	SmallPop	1	f
30	100	16	1	2009-11-01 14:21:44	cong	\N	\N	360	SmallPop	1	f
100	102	50	1	2009-11-01 14:21:44	cong	\N	\N	361	SmallPop	1	f
25	103	13	1	2009-11-01 14:21:44	cong	\N	\N	362	SmallPop	1	f
128	102	64	1	2009-11-01 14:21:44	cong	\N	\N	363	SmallPop	1	f
28	102	14	1	2009-11-01 14:21:44	cong	\N	\N	364	SmallPop	1	f
120	102	60	1	2009-11-01 14:21:44	cong	\N	\N	365	SmallPop	1	f
156	102	78	1	2009-11-01 14:21:44	cong	\N	\N	366	SmallPop	1	f
134	100	68	1	2009-11-01 14:21:44	cong	\N	\N	367	SmallPop	1	f
40	102	20	1	2009-11-01 14:21:44	cong	\N	\N	368	SmallPop	1	f
75	101	38	1	2009-11-01 14:21:44	cong	\N	\N	369	SmallPop	1	f
83	101	42	1	2009-11-01 14:21:44	cong	\N	\N	370	SmallPop	1	f
59	101	30	1	2009-11-01 14:21:44	cong	\N	\N	371	SmallPop	1	f
177	103	89	1	2009-11-01 14:21:44	cong	\N	\N	372	SmallPop	1	f
150	100	76	1	2009-11-01 14:21:44	cong	\N	\N	373	SmallPop	1	f
155	101	78	1	2009-11-01 14:21:44	cong	\N	\N	374	SmallPop	1	f
130	100	66	1	2009-11-01 14:21:44	cong	\N	\N	375	SmallPop	1	f
53	103	27	1	2009-11-01 14:21:44	cong	\N	\N	376	SmallPop	1	f
122	100	62	1	2009-11-01 14:21:44	cong	\N	\N	377	SmallPop	1	f
143	101	72	1	2009-11-01 14:21:44	cong	\N	\N	378	SmallPop	1	f
158	100	80	1	2009-11-01 14:21:44	cong	\N	\N	379	SmallPop	1	f
42	100	22	1	2009-11-01 14:21:44	cong	\N	\N	380	SmallPop	1	f
22	100	12	1	2009-11-01 14:21:44	cong	\N	\N	381	SmallPop	1	f
46	100	24	1	2009-11-01 14:21:44	cong	\N	\N	382	SmallPop	1	f
13	103	7	1	2009-11-01 14:21:44	cong	\N	\N	383	SmallPop	1	f
105	103	53	1	2009-11-01 14:21:44	cong	\N	\N	384	SmallPop	1	f
6	100	4	1	2009-11-01 14:21:44	cong	\N	\N	385	SmallPop	1	f
85	103	43	1	2009-11-01 14:21:44	cong	\N	\N	386	SmallPop	1	f
36	102	18	1	2009-11-01 14:21:44	cong	\N	\N	387	SmallPop	1	f
3	101	2	1	2009-11-01 14:21:44	cong	\N	\N	388	SmallPop	1	f
94	100	48	1	2009-11-01 14:21:44	cong	\N	\N	389	SmallPop	1	f
146	100	74	1	2009-11-01 14:21:44	cong	\N	\N	390	SmallPop	1	f
51	101	26	1	2009-11-01 14:21:44	cong	\N	\N	391	SmallPop	1	f
9	103	5	1	2009-11-01 14:21:44	cong	\N	\N	392	SmallPop	1	f
111	101	56	1	2009-11-01 14:21:44	cong	\N	\N	393	SmallPop	1	f
38	100	20	1	2009-11-01 14:21:44	cong	\N	\N	394	SmallPop	1	f
4	102	2	1	2009-11-01 14:21:44	cong	\N	\N	395	SmallPop	1	f
34	100	18	1	2009-11-01 14:21:44	cong	\N	\N	396	SmallPop	1	f
169	103	85	1	2009-11-01 14:21:44	cong	\N	\N	397	SmallPop	1	f
164	102	82	1	2009-11-01 14:21:44	cong	\N	\N	398	SmallPop	1	f
132	102	66	1	2009-11-01 14:21:44	cong	\N	\N	399	SmallPop	1	f
171	101	86	1	2009-11-01 14:21:44	cong	\N	\N	400	SmallPop	1	f
\.


--
-- Data for Name: ar_dbttables; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_dbttables (table_id, table_name, table_columns, table_desc, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
33	ar_user_roles	user_id,role_id,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	130	SmallPop	1	f
32	ar_roles	role_id,role_name,role_long_name,role_type,role_subset,role_descr,synch	\N	2009-11-01 14:21:44	cong	\N	\N	131	SmallPop	1	f
90	sequences	sequence_id,dna_id,project_id,marker_id,sequence,comment,synch	\N	2009-11-01 14:21:44	cong	\N	\N	132	SmallPop	1	f
63	samples	chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version,sample_id,ext_sample,db_organism,db_vessel_type,db_material_type,db_user,protocol_id,production_dt,storage_dt,comment	\N	2009-11-01 14:21:44	cong	\N	\N	133	SmallPop	1	f
21	nodes	nodename,address,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	134	SmallPop	1	f
71	validation	validation_id,gel_id,protocol_id,comment,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	135	SmallPop	1	f
7	contacts	db_contact,title,salutation,first_name,second_name,third_name,birth_dt,db_language,street,zip,town,db_country,label,phone,phone2,fax,email,bank_name,bank_zip,account,opening_dt,closing_dt,comment,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	136	SmallPop	1	f
80	amplified_samples	amplification_id,dna_id,validation_id,comment,synch	\N	2009-11-01 14:21:44	cong	\N	\N	137	SmallPop	1	f
26	languages	lang_id,iso_lang,lang,synch	\N	2009-11-01 14:21:44	cong	\N	\N	138	SmallPop	1	f
18	sources	source,tablename,class,columnnames,synch	\N	2009-11-01 14:21:44	cong	\N	\N	139	SmallPop	1	f
72	validation	validation_id,gel_id,protocol_id,comment,synch	\N	2009-11-01 14:21:44	cong	\N	\N	140	SmallPop	1	f
16	new_pest	class,key,trait,estimator,pev,synch	\N	2009-11-01 14:21:44	cong	\N	\N	141	SmallPop	1	f
44	ar_stpolicies	stpolicy_id,stpolicy_name,stpolicy_type,stpolicy_desc,synch	\N	2009-11-01 14:21:44	cong	\N	\N	142	SmallPop	1	f
55	organisms	db_organism,db_sire,db_dam,db_sex,birth_dt,birth_year,latitude,longitude,db_donor_type,db_species,db_breed,db_photo,comment,la_rep,la_rep_dt,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch,db_hybrid	\N	2009-11-01 14:21:44	cong	\N	\N	143	SmallPop	1	f
84	electrophoresises	electrophoresis_id,ext_electrophoresis,project_id,db_user,db_software,product_id,protocol_id,electrophoresis_dt,db_method,purpose,comment,synch	\N	2009-11-01 14:21:44	cong	\N	\N	144	SmallPop	1	f
74	gel_images	gel_id,sample_id,lane,valid,synch	\N	2009-11-01 14:21:44	cong	\N	\N	145	SmallPop	1	f
27	ar_users	user_id,user_login,user_password,user_language_id,user_marker,user_disabled,user_status,user_last_login,user_last_activ_time,user_session_id,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	146	SmallPop	1	f
57	storage	storage_id,storage_name,parent_id,comment,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	147	SmallPop	1	f
61	projects	chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version,project_id,project_name,keyword,begin_dt,finish_dt,description,comment	\N	2009-11-01 14:21:44	cong	\N	\N	148	SmallPop	1	f
20	targets	target,tablename,class,columnnames,synch	\N	2009-11-01 14:21:44	cong	\N	\N	149	SmallPop	1	f
89	sequences	sequence_id,dna_id,project_id,marker_id,sequence,comment,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	150	SmallPop	1	f
10	inspool	ds,record_seq,in_date,ext_unit,proc_dt,status,record,synch	\N	2009-11-01 14:21:44	cong	\N	\N	151	SmallPop	1	f
31	ar_roles	role_id,role_name,role_long_name,role_type,role_subset,role_descr,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	152	SmallPop	1	f
35	ar_dbtpolicies	dbtpolicy_id,action_id,table_id,descriptor_id,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	153	SmallPop	1	f
11	inspool_err	record_seq,err_type,action,dbtable,dbcol,err_source,short_msg,long_msg,ext_col,ext_val,mod_val,comp_val,target_col,ds,ext_unit,status,err_dt,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	154	SmallPop	1	f
78	pcr_amplification	amplification_id,ext_amplification,project_id,protocol_id,comment,synch	\N	2009-11-01 14:21:44	cong	\N	\N	155	SmallPop	1	f
48	ar_constraints	cons_id,cons_name,cons_type,cons_desc,synch	\N	2009-11-01 14:21:44	cong	\N	\N	156	SmallPop	1	f
87	microsatellites	microsatellite_id,dna_id,project_id,marker_id,allele1,allele2,comment,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	157	SmallPop	1	f
77	pcr_amplification	amplification_id,ext_amplification,project_id,protocol_id,comment,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	158	SmallPop	1	f
65	storage_samples	chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version,storage_id,sample_id,no_units	\N	2009-11-01 14:21:44	cong	\N	\N	159	SmallPop	1	f
29	ar_users_data	user_id,user_first_name,user_second_name,user_institution,user_email,user_country,user_street,user_town,user_zip,user_other_info,opening_dt,closing_dt,last_change_dt,last_change_user,creation_dt,creation_user,end_dt,end_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	160	SmallPop	1	f
50	ar_role_constraints	cons_id,first_role_id,second_role_id,synch	\N	2009-11-01 14:21:44	cong	\N	\N	161	SmallPop	1	f
39	ar_dbttables	table_id,table_name,table_columns,table_desc,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	162	SmallPop	1	f
64	samples	synch,sample_id,ext_sample,db_organism,db_vessel_type,db_material_type,db_user,protocol_id,production_dt,storage_dt,comment	\N	2009-11-01 14:21:44	cong	\N	\N	163	SmallPop	1	f
58	storage	storage_id,storage_name,parent_id,comment,synch	\N	2009-11-01 14:21:44	cong	\N	\N	164	SmallPop	1	f
41	ar_dbtdescriptors	descriptor_id,descriptor_name,descriptor_value,descriptor_desc,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	165	SmallPop	1	f
12	inspool_err	record_seq,err_type,action,dbtable,dbcol,err_source,short_msg,long_msg,ext_col,ext_val,mod_val,comp_val,target_col,ds,ext_unit,status,err_dt,synch	\N	2009-11-01 14:21:44	cong	\N	\N	166	SmallPop	1	f
15	new_pest	class,key,trait,estimator,pev,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	167	SmallPop	1	f
81	pcr_markers	amplification_id,marker_id,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	168	SmallPop	1	f
52	codes	ext_code,class,db_code,short_name,long_name,description,opening_dt,closing_dt,synch	\N	2009-11-01 14:21:44	cong	\N	\N	169	SmallPop	1	f
60	protocols	protocol_id,protocol_name,comment,synch,db_protocol_type	\N	2009-11-01 14:21:44	cong	\N	\N	170	SmallPop	1	f
56	organisms	db_organism,db_sire,db_dam,db_sex,birth_dt,birth_year,latitude,longitude,db_donor_type,db_species,db_breed,db_photo,comment,la_rep,la_rep_dt,synch,db_hybrid	\N	2009-11-01 14:21:44	cong	\N	\N	171	SmallPop	1	f
73	gel_images	gel_id,sample_id,lane,valid,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	172	SmallPop	1	f
66	storage_samples	synch,storage_id,sample_id,no_units	\N	2009-11-01 14:21:44	cong	\N	\N	173	SmallPop	1	f
45	ar_role_stpolicies	role_id,stpolicy_id,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	174	SmallPop	1	f
86	analyzed_samples	electrophoresis_id,dna_id,marker_id,synch	\N	2009-11-01 14:21:44	cong	\N	\N	175	SmallPop	1	f
76	markers	marker_id,marker_name,db_marker_type,db_primer1,db_primer2,comment,synch	\N	2009-11-01 14:21:44	cong	\N	\N	176	SmallPop	1	f
19	targets	target,tablename,class,columnnames,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	177	SmallPop	1	f
62	projects	synch,project_id,project_name,keyword,begin_dt,finish_dt,description,comment	\N	2009-11-01 14:21:44	cong	\N	\N	178	SmallPop	1	f
54	transfer	db_organism,ext_organism,db_unit,id_set,opening_dt,closing_dt,synch	\N	2009-11-01 14:21:44	cong	\N	\N	179	SmallPop	1	f
67	sample_collection	chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version,sample_id,project_id,reused	\N	2009-11-01 14:21:44	cong	\N	\N	180	SmallPop	1	f
70	dna_extraction	synch,dna_id,sample_id,project_id,validation_id,dna_concentration,dna_purity,reused	\N	2009-11-01 14:21:44	cong	\N	\N	181	SmallPop	1	f
68	sample_collection	synch,sample_id,project_id,reused	\N	2009-11-01 14:21:44	cong	\N	\N	182	SmallPop	1	f
2	unit	db_unit,ext_unit,ext_id,db_contact,db_member,opening_dt,closing_dt,synch	\N	2009-11-01 14:21:44	cong	\N	\N	183	SmallPop	1	f
17	sources	source,tablename,class,columnnames,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	184	SmallPop	1	f
1	unit	db_unit,ext_unit,ext_id,db_contact,db_member,opening_dt,closing_dt,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	185	SmallPop	1	f
88	microsatellites	microsatellite_id,dna_id,project_id,marker_id,allele1,allele2,comment,synch	\N	2009-11-01 14:21:44	cong	\N	\N	186	SmallPop	1	f
30	ar_users_data	user_id,user_first_name,user_second_name,user_institution,user_email,user_country,user_street,user_town,user_zip,user_other_info,opening_dt,closing_dt,synch	\N	2009-11-01 14:21:44	cong	\N	\N	187	SmallPop	1	f
82	pcr_markers	amplification_id,marker_id,synch	\N	2009-11-01 14:21:44	cong	\N	\N	188	SmallPop	1	f
25	languages	lang_id,iso_lang,lang,last_change_dt,last_change_user,creation_dt,creation_user,end_dt,end_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	189	SmallPop	1	f
28	ar_users	user_id,user_login,user_password,user_language_id,user_marker,user_disabled,user_status,user_last_login,user_last_activ_time,user_session_id,synch	\N	2009-11-01 14:21:44	cong	\N	\N	190	SmallPop	1	f
83	electrophoresises	electrophoresis_id,ext_electrophoresis,project_id,db_user,db_software,product_id,protocol_id,electrophoresis_dt,db_method,purpose,comment,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	191	SmallPop	1	f
75	markers	marker_id,marker_name,db_marker_type,db_primer1,db_primer2,comment,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	192	SmallPop	1	f
40	ar_dbttables	table_id,table_name,table_columns,table_desc,synch	\N	2009-11-01 14:21:44	cong	\N	\N	193	SmallPop	1	f
14	load_stat	ds,job_start,job_end,status,rec_tot_no,rec_err_no,rec_ok_no,synch	\N	2009-11-01 14:21:44	cong	\N	\N	194	SmallPop	1	f
69	dna_extraction	chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version,dna_id,sample_id,project_id,validation_id,dna_concentration,dna_purity,reused	\N	2009-11-01 14:21:44	cong	\N	\N	195	SmallPop	1	f
59	protocols	protocol_id,protocol_name,comment,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version,db_protocol_type	\N	2009-11-01 14:21:44	cong	\N	\N	196	SmallPop	1	f
49	ar_role_constraints	cons_id,first_role_id,second_role_id,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	197	SmallPop	1	f
24	blobs	blob_id,blob,db_mimetype,synch	\N	2009-11-01 14:21:44	cong	\N	\N	198	SmallPop	1	f
53	transfer	db_organism,ext_organism,db_unit,id_set,opening_dt,closing_dt,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	199	SmallPop	1	f
79	amplified_samples	amplification_id,dna_id,validation_id,comment,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	200	SmallPop	1	f
22	nodes	nodename,address,synch	\N	2009-11-01 14:21:44	cong	\N	\N	201	SmallPop	1	f
42	ar_dbtdescriptors	descriptor_id,descriptor_name,descriptor_value,descriptor_desc,synch	\N	2009-11-01 14:21:44	cong	\N	\N	202	SmallPop	1	f
46	ar_role_stpolicies	role_id,stpolicy_id,synch	\N	2009-11-01 14:21:44	cong	\N	\N	203	SmallPop	1	f
23	blobs	blob_id,blob,db_mimetype,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	204	SmallPop	1	f
13	load_stat	ds,job_start,job_end,status,rec_tot_no,rec_err_no,rec_ok_no,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	205	SmallPop	1	f
6	event	event_id,db_event_type,db_sampler,event_dt,db_location,synch	\N	2009-11-01 14:21:44	cong	\N	\N	206	SmallPop	1	f
85	analyzed_samples	electrophoresis_id,dna_id,marker_id,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	207	SmallPop	1	f
3	locations	db_organism,db_location,entry_dt,db_entry_action,exit_dt,db_exit_action,chk_lvl,dirty,guid,last_change_dt,last_change_user,owner,synch,version	\N	2009-11-01 14:21:44	cong	\N	\N	208	SmallPop	1	f
36	ar_dbtpolicies	dbtpolicy_id,action_id,table_id,descriptor_id,synch	\N	2009-11-01 14:21:44	cong	\N	\N	209	SmallPop	1	f
9	inspool	ds,record_seq,in_date,ext_unit,proc_dt,status,record,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	210	SmallPop	1	f
51	codes	ext_code,class,db_code,short_name,long_name,description,opening_dt,closing_dt,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	211	SmallPop	1	f
47	ar_constraints	cons_id,cons_name,cons_type,cons_desc,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	212	SmallPop	1	f
8	contacts	db_contact,title,salutation,first_name,second_name,third_name,birth_dt,db_language,street,zip,town,db_country,label,phone,phone2,fax,email,bank_name,bank_zip,account,opening_dt,closing_dt,comment,synch	\N	2009-11-01 14:21:44	cong	\N	\N	213	SmallPop	1	f
38	ar_role_dbtpolicies	role_id,dbtpolicy_id,synch	\N	2009-11-01 14:21:44	cong	\N	\N	214	SmallPop	1	f
4	locations	db_organism,db_location,entry_dt,db_entry_action,exit_dt,db_exit_action,synch	\N	2009-11-01 14:21:44	cong	\N	\N	215	SmallPop	1	f
34	ar_user_roles	user_id,role_id,synch	\N	2009-11-01 14:21:44	cong	\N	\N	216	SmallPop	1	f
37	ar_role_dbtpolicies	role_id,dbtpolicy_id,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	217	SmallPop	1	f
43	ar_stpolicies	stpolicy_id,stpolicy_name,stpolicy_type,stpolicy_desc,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	218	SmallPop	1	f
5	event	event_id,db_event_type,db_sampler,event_dt,db_location,last_change_dt,last_change_user,dirty,chk_lvl,guid,owner,version,synch	\N	2009-11-01 14:21:44	cong	\N	\N	219	SmallPop	1	f
\.


--
-- Data for Name: ar_role_constraints; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_role_constraints (cons_id, first_role_id, second_role_id, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
\.


--
-- Data for Name: ar_role_dbtpolicies; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_role_dbtpolicies (role_id, dbtpolicy_id, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
126	160	2009-11-19 01:07:13	www-data	\N	\N	1175	SmallPop	1	f
126	172	2009-11-19 01:07:13	www-data	\N	\N	1176	SmallPop	1	f
126	96	2009-11-19 01:07:13	www-data	\N	\N	1177	SmallPop	1	f
126	84	2009-11-19 01:07:13	www-data	\N	\N	1178	SmallPop	1	f
126	72	2009-11-19 01:07:13	www-data	\N	\N	1179	SmallPop	1	f
126	80	2009-11-19 01:07:13	www-data	\N	\N	1180	SmallPop	1	f
126	100	2009-11-19 01:07:13	www-data	\N	\N	1181	SmallPop	1	f
126	76	2009-11-19 01:07:13	www-data	\N	\N	1182	SmallPop	1	f
126	64	2009-11-19 01:07:13	www-data	\N	\N	1183	SmallPop	1	f
126	92	2009-11-19 01:07:13	www-data	\N	\N	1184	SmallPop	1	f
126	88	2009-11-19 01:07:13	www-data	\N	\N	1185	SmallPop	1	f
126	68	2009-11-19 01:07:13	www-data	\N	\N	1186	SmallPop	1	f
126	56	2009-11-19 01:07:13	www-data	\N	\N	1187	SmallPop	1	f
126	60	2009-11-19 01:07:13	www-data	\N	\N	1188	SmallPop	1	f
126	48	2009-11-19 01:07:13	www-data	\N	\N	1189	SmallPop	1	f
126	104	2009-11-19 01:07:13	www-data	\N	\N	1190	SmallPop	1	f
126	16	2009-11-19 01:07:13	www-data	\N	\N	1191	SmallPop	1	f
126	140	2009-11-19 01:07:13	www-data	\N	\N	1192	SmallPop	1	f
126	168	2009-11-19 01:07:13	www-data	\N	\N	1193	SmallPop	1	f
126	12	2009-11-19 01:07:13	www-data	\N	\N	1194	SmallPop	1	f
126	148	2009-11-19 01:07:13	www-data	\N	\N	1195	SmallPop	1	f
126	20	2009-11-19 01:07:13	www-data	\N	\N	1196	SmallPop	1	f
126	24	2009-11-19 01:07:13	www-data	\N	\N	1197	SmallPop	1	f
126	52	2009-11-19 01:07:13	www-data	\N	\N	1198	SmallPop	1	f
126	28	2009-11-19 01:07:13	www-data	\N	\N	1199	SmallPop	1	f
126	8	2009-11-19 01:07:13	www-data	\N	\N	1200	SmallPop	1	f
126	152	2009-11-19 01:07:13	www-data	\N	\N	1201	SmallPop	1	f
126	176	2009-11-19 01:07:13	www-data	\N	\N	1202	SmallPop	1	f
126	32	2009-11-19 01:07:13	www-data	\N	\N	1203	SmallPop	1	f
126	44	2009-11-19 01:07:13	www-data	\N	\N	1204	SmallPop	1	f
126	112	2009-11-19 01:07:13	www-data	\N	\N	1205	SmallPop	1	f
126	156	2009-11-19 01:07:13	www-data	\N	\N	1206	SmallPop	1	f
126	164	2009-11-19 01:07:13	www-data	\N	\N	1207	SmallPop	1	f
126	124	2009-11-19 01:07:13	www-data	\N	\N	1208	SmallPop	1	f
126	120	2009-11-19 01:07:13	www-data	\N	\N	1209	SmallPop	1	f
126	136	2009-11-19 01:07:13	www-data	\N	\N	1210	SmallPop	1	f
126	128	2009-11-19 01:07:13	www-data	\N	\N	1211	SmallPop	1	f
126	180	2009-11-19 01:07:13	www-data	\N	\N	1212	SmallPop	1	f
126	36	2009-11-19 01:07:13	www-data	\N	\N	1213	SmallPop	1	f
126	116	2009-11-19 01:07:13	www-data	\N	\N	1214	SmallPop	1	f
126	132	2009-11-19 01:07:13	www-data	\N	\N	1215	SmallPop	1	f
126	40	2009-11-19 01:07:13	www-data	\N	\N	1216	SmallPop	1	f
126	108	2009-11-19 01:07:13	www-data	\N	\N	1217	SmallPop	1	f
126	4	2009-11-19 01:07:13	www-data	\N	\N	1218	SmallPop	1	f
126	144	2009-11-19 01:07:13	www-data	\N	\N	1219	SmallPop	1	f
126	158	2009-11-19 01:07:13	www-data	\N	\N	1220	SmallPop	1	f
126	170	2009-11-19 01:07:13	www-data	\N	\N	1221	SmallPop	1	f
126	94	2009-11-19 01:07:13	www-data	\N	\N	1222	SmallPop	1	f
126	82	2009-11-19 01:07:13	www-data	\N	\N	1223	SmallPop	1	f
126	70	2009-11-19 01:07:13	www-data	\N	\N	1224	SmallPop	1	f
126	78	2009-11-19 01:07:13	www-data	\N	\N	1225	SmallPop	1	f
126	98	2009-11-19 01:07:13	www-data	\N	\N	1226	SmallPop	1	f
126	74	2009-11-19 01:07:13	www-data	\N	\N	1227	SmallPop	1	f
126	62	2009-11-19 01:07:13	www-data	\N	\N	1228	SmallPop	1	f
126	90	2009-11-19 01:07:13	www-data	\N	\N	1229	SmallPop	1	f
126	86	2009-11-19 01:07:13	www-data	\N	\N	1230	SmallPop	1	f
126	66	2009-11-19 01:07:13	www-data	\N	\N	1231	SmallPop	1	f
126	54	2009-11-19 01:07:13	www-data	\N	\N	1232	SmallPop	1	f
126	58	2009-11-19 01:07:13	www-data	\N	\N	1233	SmallPop	1	f
126	46	2009-11-19 01:07:13	www-data	\N	\N	1234	SmallPop	1	f
126	102	2009-11-19 01:07:13	www-data	\N	\N	1235	SmallPop	1	f
126	14	2009-11-19 01:07:13	www-data	\N	\N	1236	SmallPop	1	f
126	138	2009-11-19 01:07:13	www-data	\N	\N	1237	SmallPop	1	f
126	166	2009-11-19 01:07:13	www-data	\N	\N	1238	SmallPop	1	f
126	10	2009-11-19 01:07:13	www-data	\N	\N	1239	SmallPop	1	f
126	146	2009-11-19 01:07:13	www-data	\N	\N	1240	SmallPop	1	f
126	18	2009-11-19 01:07:13	www-data	\N	\N	1241	SmallPop	1	f
126	22	2009-11-19 01:07:13	www-data	\N	\N	1242	SmallPop	1	f
126	50	2009-11-19 01:07:13	www-data	\N	\N	1243	SmallPop	1	f
126	26	2009-11-19 01:07:13	www-data	\N	\N	1244	SmallPop	1	f
126	6	2009-11-19 01:07:13	www-data	\N	\N	1245	SmallPop	1	f
126	150	2009-11-19 01:07:13	www-data	\N	\N	1246	SmallPop	1	f
126	174	2009-11-19 01:07:13	www-data	\N	\N	1247	SmallPop	1	f
126	30	2009-11-19 01:07:13	www-data	\N	\N	1248	SmallPop	1	f
126	42	2009-11-19 01:07:13	www-data	\N	\N	1249	SmallPop	1	f
126	110	2009-11-19 01:07:13	www-data	\N	\N	1250	SmallPop	1	f
126	154	2009-11-19 01:07:13	www-data	\N	\N	1251	SmallPop	1	f
126	162	2009-11-19 01:07:13	www-data	\N	\N	1252	SmallPop	1	f
126	122	2009-11-19 01:07:13	www-data	\N	\N	1253	SmallPop	1	f
126	118	2009-11-19 01:07:13	www-data	\N	\N	1254	SmallPop	1	f
126	134	2009-11-19 01:07:13	www-data	\N	\N	1255	SmallPop	1	f
126	126	2009-11-19 01:07:13	www-data	\N	\N	1256	SmallPop	1	f
126	178	2009-11-19 01:07:13	www-data	\N	\N	1257	SmallPop	1	f
126	34	2009-11-19 01:07:13	www-data	\N	\N	1258	SmallPop	1	f
126	114	2009-11-19 01:07:13	www-data	\N	\N	1259	SmallPop	1	f
126	130	2009-11-19 01:07:13	www-data	\N	\N	1260	SmallPop	1	f
126	38	2009-11-19 01:07:13	www-data	\N	\N	1261	SmallPop	1	f
126	106	2009-11-19 01:07:13	www-data	\N	\N	1262	SmallPop	1	f
126	2	2009-11-19 01:07:13	www-data	\N	\N	1263	SmallPop	1	f
126	142	2009-11-19 01:07:13	www-data	\N	\N	1264	SmallPop	1	f
126	157	2009-11-19 01:07:13	www-data	\N	\N	1265	SmallPop	1	f
126	169	2009-11-19 01:07:13	www-data	\N	\N	1266	SmallPop	1	f
126	93	2009-11-19 01:07:13	www-data	\N	\N	1267	SmallPop	1	f
126	81	2009-11-19 01:07:13	www-data	\N	\N	1268	SmallPop	1	f
126	69	2009-11-19 01:07:13	www-data	\N	\N	1269	SmallPop	1	f
126	77	2009-11-19 01:07:13	www-data	\N	\N	1270	SmallPop	1	f
126	97	2009-11-19 01:07:13	www-data	\N	\N	1271	SmallPop	1	f
126	73	2009-11-19 01:07:13	www-data	\N	\N	1272	SmallPop	1	f
126	61	2009-11-19 01:07:13	www-data	\N	\N	1273	SmallPop	1	f
126	89	2009-11-19 01:07:14	www-data	\N	\N	1274	SmallPop	1	f
126	85	2009-11-19 01:07:14	www-data	\N	\N	1275	SmallPop	1	f
126	65	2009-11-19 01:07:14	www-data	\N	\N	1276	SmallPop	1	f
126	53	2009-11-19 01:07:14	www-data	\N	\N	1277	SmallPop	1	f
126	57	2009-11-19 01:07:14	www-data	\N	\N	1278	SmallPop	1	f
126	45	2009-11-19 01:07:14	www-data	\N	\N	1279	SmallPop	1	f
126	101	2009-11-19 01:07:14	www-data	\N	\N	1280	SmallPop	1	f
126	13	2009-11-19 01:07:14	www-data	\N	\N	1281	SmallPop	1	f
126	137	2009-11-19 01:07:14	www-data	\N	\N	1282	SmallPop	1	f
126	165	2009-11-19 01:07:14	www-data	\N	\N	1283	SmallPop	1	f
126	9	2009-11-19 01:07:14	www-data	\N	\N	1284	SmallPop	1	f
126	145	2009-11-19 01:07:14	www-data	\N	\N	1285	SmallPop	1	f
126	17	2009-11-19 01:07:14	www-data	\N	\N	1286	SmallPop	1	f
126	21	2009-11-19 01:07:14	www-data	\N	\N	1287	SmallPop	1	f
126	49	2009-11-19 01:07:14	www-data	\N	\N	1288	SmallPop	1	f
126	25	2009-11-19 01:07:14	www-data	\N	\N	1289	SmallPop	1	f
126	5	2009-11-19 01:07:14	www-data	\N	\N	1290	SmallPop	1	f
126	149	2009-11-19 01:07:14	www-data	\N	\N	1291	SmallPop	1	f
126	173	2009-11-19 01:07:14	www-data	\N	\N	1292	SmallPop	1	f
126	29	2009-11-19 01:07:14	www-data	\N	\N	1293	SmallPop	1	f
126	41	2009-11-19 01:07:14	www-data	\N	\N	1294	SmallPop	1	f
126	109	2009-11-19 01:07:14	www-data	\N	\N	1295	SmallPop	1	f
126	153	2009-11-19 01:07:14	www-data	\N	\N	1296	SmallPop	1	f
126	161	2009-11-19 01:07:14	www-data	\N	\N	1297	SmallPop	1	f
126	121	2009-11-19 01:07:14	www-data	\N	\N	1298	SmallPop	1	f
126	117	2009-11-19 01:07:14	www-data	\N	\N	1299	SmallPop	1	f
126	133	2009-11-19 01:07:14	www-data	\N	\N	1300	SmallPop	1	f
126	125	2009-11-19 01:07:14	www-data	\N	\N	1301	SmallPop	1	f
126	177	2009-11-19 01:07:14	www-data	\N	\N	1302	SmallPop	1	f
126	33	2009-11-19 01:07:14	www-data	\N	\N	1303	SmallPop	1	f
126	113	2009-11-19 01:07:14	www-data	\N	\N	1304	SmallPop	1	f
126	129	2009-11-19 01:07:14	www-data	\N	\N	1305	SmallPop	1	f
126	37	2009-11-19 01:07:14	www-data	\N	\N	1306	SmallPop	1	f
126	105	2009-11-19 01:07:14	www-data	\N	\N	1307	SmallPop	1	f
126	1	2009-11-19 01:07:14	www-data	\N	\N	1308	SmallPop	1	f
126	141	2009-11-19 01:07:14	www-data	\N	\N	1309	SmallPop	1	f
126	159	2009-11-19 01:07:14	www-data	\N	\N	1310	SmallPop	1	f
126	171	2009-11-19 01:07:14	www-data	\N	\N	1311	SmallPop	1	f
126	95	2009-11-19 01:07:14	www-data	\N	\N	1312	SmallPop	1	f
126	83	2009-11-19 01:07:14	www-data	\N	\N	1313	SmallPop	1	f
126	71	2009-11-19 01:07:14	www-data	\N	\N	1314	SmallPop	1	f
126	79	2009-11-19 01:07:14	www-data	\N	\N	1315	SmallPop	1	f
126	99	2009-11-19 01:07:14	www-data	\N	\N	1316	SmallPop	1	f
126	75	2009-11-19 01:07:14	www-data	\N	\N	1317	SmallPop	1	f
126	63	2009-11-19 01:07:14	www-data	\N	\N	1318	SmallPop	1	f
126	91	2009-11-19 01:07:14	www-data	\N	\N	1319	SmallPop	1	f
126	87	2009-11-19 01:07:14	www-data	\N	\N	1320	SmallPop	1	f
126	67	2009-11-19 01:07:14	www-data	\N	\N	1321	SmallPop	1	f
126	55	2009-11-19 01:07:14	www-data	\N	\N	1322	SmallPop	1	f
126	59	2009-11-19 01:07:14	www-data	\N	\N	1323	SmallPop	1	f
126	47	2009-11-19 01:07:14	www-data	\N	\N	1324	SmallPop	1	f
126	103	2009-11-19 01:07:14	www-data	\N	\N	1325	SmallPop	1	f
126	15	2009-11-19 01:07:14	www-data	\N	\N	1326	SmallPop	1	f
126	139	2009-11-19 01:07:14	www-data	\N	\N	1327	SmallPop	1	f
126	167	2009-11-19 01:07:14	www-data	\N	\N	1328	SmallPop	1	f
126	11	2009-11-19 01:07:14	www-data	\N	\N	1329	SmallPop	1	f
126	147	2009-11-19 01:07:14	www-data	\N	\N	1330	SmallPop	1	f
126	19	2009-11-19 01:07:14	www-data	\N	\N	1331	SmallPop	1	f
126	23	2009-11-19 01:07:14	www-data	\N	\N	1332	SmallPop	1	f
126	51	2009-11-19 01:07:14	www-data	\N	\N	1333	SmallPop	1	f
126	27	2009-11-19 01:07:14	www-data	\N	\N	1334	SmallPop	1	f
126	7	2009-11-19 01:07:14	www-data	\N	\N	1335	SmallPop	1	f
126	151	2009-11-19 01:07:14	www-data	\N	\N	1336	SmallPop	1	f
126	175	2009-11-19 01:07:14	www-data	\N	\N	1337	SmallPop	1	f
126	31	2009-11-19 01:07:14	www-data	\N	\N	1338	SmallPop	1	f
126	43	2009-11-19 01:07:14	www-data	\N	\N	1339	SmallPop	1	f
126	111	2009-11-19 01:07:14	www-data	\N	\N	1340	SmallPop	1	f
126	155	2009-11-19 01:07:14	www-data	\N	\N	1341	SmallPop	1	f
126	163	2009-11-19 01:07:14	www-data	\N	\N	1342	SmallPop	1	f
126	123	2009-11-19 01:07:14	www-data	\N	\N	1343	SmallPop	1	f
126	119	2009-11-19 01:07:14	www-data	\N	\N	1344	SmallPop	1	f
126	135	2009-11-19 01:07:14	www-data	\N	\N	1345	SmallPop	1	f
126	127	2009-11-19 01:07:14	www-data	\N	\N	1346	SmallPop	1	f
126	179	2009-11-19 01:07:14	www-data	\N	\N	1347	SmallPop	1	f
126	35	2009-11-19 01:07:14	www-data	\N	\N	1348	SmallPop	1	f
126	115	2009-11-19 01:07:14	www-data	\N	\N	1349	SmallPop	1	f
126	131	2009-11-19 01:07:14	www-data	\N	\N	1350	SmallPop	1	f
126	39	2009-11-19 01:07:14	www-data	\N	\N	1351	SmallPop	1	f
126	107	2009-11-19 01:07:14	www-data	\N	\N	1352	SmallPop	1	f
126	3	2009-11-19 01:07:14	www-data	\N	\N	1353	SmallPop	1	f
126	143	2009-11-19 01:07:14	www-data	\N	\N	1354	SmallPop	1	f
129	157	2009-11-19 14:55:09	www-data	\N	\N	1547	SmallPop	1	f
129	169	2009-11-19 14:55:09	www-data	\N	\N	1548	SmallPop	1	f
129	45	2009-11-19 14:55:09	www-data	\N	\N	1549	SmallPop	1	f
129	101	2009-11-19 14:55:09	www-data	\N	\N	1550	SmallPop	1	f
129	13	2009-11-19 14:55:09	www-data	\N	\N	1551	SmallPop	1	f
129	137	2009-11-19 14:55:09	www-data	\N	\N	1552	SmallPop	1	f
129	165	2009-11-19 14:55:09	www-data	\N	\N	1553	SmallPop	1	f
129	145	2009-11-19 14:55:09	www-data	\N	\N	1554	SmallPop	1	f
129	149	2009-11-19 14:55:09	www-data	\N	\N	1555	SmallPop	1	f
129	173	2009-11-19 14:55:09	www-data	\N	\N	1556	SmallPop	1	f
129	109	2009-11-19 14:55:09	www-data	\N	\N	1557	SmallPop	1	f
129	153	2009-11-19 14:55:09	www-data	\N	\N	1558	SmallPop	1	f
129	161	2009-11-19 14:55:09	www-data	\N	\N	1559	SmallPop	1	f
129	121	2009-11-19 14:55:09	www-data	\N	\N	1560	SmallPop	1	f
129	117	2009-11-19 14:55:09	www-data	\N	\N	1561	SmallPop	1	f
129	133	2009-11-19 14:55:09	www-data	\N	\N	1562	SmallPop	1	f
129	125	2009-11-19 14:55:09	www-data	\N	\N	1563	SmallPop	1	f
129	177	2009-11-19 14:55:09	www-data	\N	\N	1564	SmallPop	1	f
129	113	2009-11-19 14:55:09	www-data	\N	\N	1565	SmallPop	1	f
129	129	2009-11-19 14:55:09	www-data	\N	\N	1566	SmallPop	1	f
129	105	2009-11-19 14:55:09	www-data	\N	\N	1567	SmallPop	1	f
129	1	2009-11-19 14:55:09	www-data	\N	\N	1568	SmallPop	1	f
129	141	2009-11-19 14:55:09	www-data	\N	\N	1569	SmallPop	1	f
130	158	2009-11-19 15:07:55	www-data	\N	\N	1571	SmallPop	1	f
130	170	2009-11-19 15:07:55	www-data	\N	\N	1572	SmallPop	1	f
130	46	2009-11-19 15:07:55	www-data	\N	\N	1573	SmallPop	1	f
130	102	2009-11-19 15:07:55	www-data	\N	\N	1574	SmallPop	1	f
130	14	2009-11-19 15:07:55	www-data	\N	\N	1575	SmallPop	1	f
130	138	2009-11-19 15:07:55	www-data	\N	\N	1576	SmallPop	1	f
130	166	2009-11-19 15:07:55	www-data	\N	\N	1577	SmallPop	1	f
130	146	2009-11-19 15:07:55	www-data	\N	\N	1578	SmallPop	1	f
130	150	2009-11-19 15:07:55	www-data	\N	\N	1579	SmallPop	1	f
130	174	2009-11-19 15:07:55	www-data	\N	\N	1580	SmallPop	1	f
130	110	2009-11-19 15:07:55	www-data	\N	\N	1581	SmallPop	1	f
130	154	2009-11-19 15:07:55	www-data	\N	\N	1582	SmallPop	1	f
130	162	2009-11-19 15:07:55	www-data	\N	\N	1583	SmallPop	1	f
130	122	2009-11-19 15:07:55	www-data	\N	\N	1584	SmallPop	1	f
130	118	2009-11-19 15:07:55	www-data	\N	\N	1585	SmallPop	1	f
130	134	2009-11-19 15:07:55	www-data	\N	\N	1586	SmallPop	1	f
130	126	2009-11-19 15:07:55	www-data	\N	\N	1587	SmallPop	1	f
130	178	2009-11-19 15:07:55	www-data	\N	\N	1588	SmallPop	1	f
130	114	2009-11-19 15:07:55	www-data	\N	\N	1589	SmallPop	1	f
130	130	2009-11-19 15:07:55	www-data	\N	\N	1590	SmallPop	1	f
130	106	2009-11-19 15:07:55	www-data	\N	\N	1591	SmallPop	1	f
130	2	2009-11-19 15:07:55	www-data	\N	\N	1592	SmallPop	1	f
130	142	2009-11-19 15:07:55	www-data	\N	\N	1593	SmallPop	1	f
130	159	2009-11-19 15:07:55	www-data	\N	\N	1594	SmallPop	1	f
130	171	2009-11-19 15:07:55	www-data	\N	\N	1595	SmallPop	1	f
130	47	2009-11-19 15:07:55	www-data	\N	\N	1596	SmallPop	1	f
130	103	2009-11-19 15:07:55	www-data	\N	\N	1597	SmallPop	1	f
130	15	2009-11-19 15:07:55	www-data	\N	\N	1598	SmallPop	1	f
130	139	2009-11-19 15:07:55	www-data	\N	\N	1599	SmallPop	1	f
130	167	2009-11-19 15:07:55	www-data	\N	\N	1600	SmallPop	1	f
130	147	2009-11-19 15:07:55	www-data	\N	\N	1601	SmallPop	1	f
130	51	2009-11-19 15:07:55	www-data	\N	\N	1602	SmallPop	1	f
130	151	2009-11-19 15:07:55	www-data	\N	\N	1603	SmallPop	1	f
130	175	2009-11-19 15:07:55	www-data	\N	\N	1604	SmallPop	1	f
130	111	2009-11-19 15:07:55	www-data	\N	\N	1605	SmallPop	1	f
130	155	2009-11-19 15:07:55	www-data	\N	\N	1606	SmallPop	1	f
130	163	2009-11-19 15:07:55	www-data	\N	\N	1607	SmallPop	1	f
130	123	2009-11-19 15:07:55	www-data	\N	\N	1608	SmallPop	1	f
130	119	2009-11-19 15:07:55	www-data	\N	\N	1609	SmallPop	1	f
130	135	2009-11-19 15:07:55	www-data	\N	\N	1610	SmallPop	1	f
130	127	2009-11-19 15:07:55	www-data	\N	\N	1611	SmallPop	1	f
130	179	2009-11-19 15:07:55	www-data	\N	\N	1612	SmallPop	1	f
130	115	2009-11-19 15:07:55	www-data	\N	\N	1613	SmallPop	1	f
130	131	2009-11-19 15:07:55	www-data	\N	\N	1614	SmallPop	1	f
130	107	2009-11-19 15:07:55	www-data	\N	\N	1615	SmallPop	1	f
130	3	2009-11-19 15:07:55	www-data	\N	\N	1616	SmallPop	1	f
130	143	2009-11-19 15:07:55	www-data	\N	\N	1617	SmallPop	1	f
131	160	2009-11-19 15:10:31	www-data	\N	\N	1619	SmallPop	1	f
131	172	2009-11-19 15:10:31	www-data	\N	\N	1620	SmallPop	1	f
131	48	2009-11-19 15:10:31	www-data	\N	\N	1621	SmallPop	1	f
131	104	2009-11-19 15:10:31	www-data	\N	\N	1622	SmallPop	1	f
131	16	2009-11-19 15:10:31	www-data	\N	\N	1623	SmallPop	1	f
131	140	2009-11-19 15:10:31	www-data	\N	\N	1624	SmallPop	1	f
131	168	2009-11-19 15:10:31	www-data	\N	\N	1625	SmallPop	1	f
131	148	2009-11-19 15:10:31	www-data	\N	\N	1626	SmallPop	1	f
131	8	2009-11-19 15:10:31	www-data	\N	\N	1627	SmallPop	1	f
131	152	2009-11-19 15:10:31	www-data	\N	\N	1628	SmallPop	1	f
131	176	2009-11-19 15:10:31	www-data	\N	\N	1629	SmallPop	1	f
131	112	2009-11-19 15:10:31	www-data	\N	\N	1630	SmallPop	1	f
131	156	2009-11-19 15:10:31	www-data	\N	\N	1631	SmallPop	1	f
131	164	2009-11-19 15:10:31	www-data	\N	\N	1632	SmallPop	1	f
131	124	2009-11-19 15:10:31	www-data	\N	\N	1633	SmallPop	1	f
131	120	2009-11-19 15:10:31	www-data	\N	\N	1634	SmallPop	1	f
131	136	2009-11-19 15:10:31	www-data	\N	\N	1635	SmallPop	1	f
131	128	2009-11-19 15:10:31	www-data	\N	\N	1636	SmallPop	1	f
131	180	2009-11-19 15:10:31	www-data	\N	\N	1637	SmallPop	1	f
131	116	2009-11-19 15:10:31	www-data	\N	\N	1638	SmallPop	1	f
131	132	2009-11-19 15:10:31	www-data	\N	\N	1639	SmallPop	1	f
131	108	2009-11-19 15:10:31	www-data	\N	\N	1640	SmallPop	1	f
131	4	2009-11-19 15:10:31	www-data	\N	\N	1641	SmallPop	1	f
131	144	2009-11-19 15:10:31	www-data	\N	\N	1642	SmallPop	1	f
132	96	2009-11-19 15:21:11	www-data	\N	\N	1644	SmallPop	1	f
132	84	2009-11-19 15:21:11	www-data	\N	\N	1645	SmallPop	1	f
132	72	2009-11-19 15:21:11	www-data	\N	\N	1646	SmallPop	1	f
132	80	2009-11-19 15:21:11	www-data	\N	\N	1647	SmallPop	1	f
132	100	2009-11-19 15:21:11	www-data	\N	\N	1648	SmallPop	1	f
132	76	2009-11-19 15:21:11	www-data	\N	\N	1649	SmallPop	1	f
132	64	2009-11-19 15:21:11	www-data	\N	\N	1650	SmallPop	1	f
132	92	2009-11-19 15:21:11	www-data	\N	\N	1651	SmallPop	1	f
132	88	2009-11-19 15:21:11	www-data	\N	\N	1652	SmallPop	1	f
132	68	2009-11-19 15:21:11	www-data	\N	\N	1653	SmallPop	1	f
132	56	2009-11-19 15:21:11	www-data	\N	\N	1654	SmallPop	1	f
132	60	2009-11-19 15:21:11	www-data	\N	\N	1655	SmallPop	1	f
132	12	2009-11-19 15:21:11	www-data	\N	\N	1656	SmallPop	1	f
132	20	2009-11-19 15:21:11	www-data	\N	\N	1657	SmallPop	1	f
132	24	2009-11-19 15:21:11	www-data	\N	\N	1658	SmallPop	1	f
132	52	2009-11-19 15:21:11	www-data	\N	\N	1659	SmallPop	1	f
132	28	2009-11-19 15:21:11	www-data	\N	\N	1660	SmallPop	1	f
132	8	2009-11-19 15:21:11	www-data	\N	\N	1661	SmallPop	1	f
132	32	2009-11-19 15:21:11	www-data	\N	\N	1662	SmallPop	1	f
132	44	2009-11-19 15:21:11	www-data	\N	\N	1663	SmallPop	1	f
132	40	2009-11-19 15:21:11	www-data	\N	\N	1664	SmallPop	1	f
132	94	2009-11-19 15:21:11	www-data	\N	\N	1665	SmallPop	1	f
132	82	2009-11-19 15:21:11	www-data	\N	\N	1666	SmallPop	1	f
132	70	2009-11-19 15:21:11	www-data	\N	\N	1667	SmallPop	1	f
132	78	2009-11-19 15:21:11	www-data	\N	\N	1668	SmallPop	1	f
132	98	2009-11-19 15:21:11	www-data	\N	\N	1669	SmallPop	1	f
132	74	2009-11-19 15:21:11	www-data	\N	\N	1670	SmallPop	1	f
132	62	2009-11-19 15:21:11	www-data	\N	\N	1671	SmallPop	1	f
132	90	2009-11-19 15:21:11	www-data	\N	\N	1672	SmallPop	1	f
132	86	2009-11-19 15:21:11	www-data	\N	\N	1673	SmallPop	1	f
132	66	2009-11-19 15:21:11	www-data	\N	\N	1674	SmallPop	1	f
132	54	2009-11-19 15:21:11	www-data	\N	\N	1675	SmallPop	1	f
132	58	2009-11-19 15:21:11	www-data	\N	\N	1676	SmallPop	1	f
132	10	2009-11-19 15:21:11	www-data	\N	\N	1677	SmallPop	1	f
132	18	2009-11-19 15:21:11	www-data	\N	\N	1678	SmallPop	1	f
132	22	2009-11-19 15:21:11	www-data	\N	\N	1679	SmallPop	1	f
132	50	2009-11-19 15:21:11	www-data	\N	\N	1680	SmallPop	1	f
132	26	2009-11-19 15:21:11	www-data	\N	\N	1681	SmallPop	1	f
132	30	2009-11-19 15:21:11	www-data	\N	\N	1682	SmallPop	1	f
132	42	2009-11-19 15:21:11	www-data	\N	\N	1683	SmallPop	1	f
132	34	2009-11-19 15:21:11	www-data	\N	\N	1684	SmallPop	1	f
132	38	2009-11-19 15:21:11	www-data	\N	\N	1685	SmallPop	1	f
132	93	2009-11-19 15:21:11	www-data	\N	\N	1686	SmallPop	1	f
132	81	2009-11-19 15:21:11	www-data	\N	\N	1687	SmallPop	1	f
132	69	2009-11-19 15:21:11	www-data	\N	\N	1688	SmallPop	1	f
132	77	2009-11-19 15:21:11	www-data	\N	\N	1689	SmallPop	1	f
132	97	2009-11-19 15:21:11	www-data	\N	\N	1690	SmallPop	1	f
132	73	2009-11-19 15:21:11	www-data	\N	\N	1691	SmallPop	1	f
132	61	2009-11-19 15:21:11	www-data	\N	\N	1692	SmallPop	1	f
132	89	2009-11-19 15:21:11	www-data	\N	\N	1693	SmallPop	1	f
132	85	2009-11-19 15:21:11	www-data	\N	\N	1694	SmallPop	1	f
132	65	2009-11-19 15:21:11	www-data	\N	\N	1695	SmallPop	1	f
132	53	2009-11-19 15:21:11	www-data	\N	\N	1696	SmallPop	1	f
132	57	2009-11-19 15:21:11	www-data	\N	\N	1697	SmallPop	1	f
132	9	2009-11-19 15:21:11	www-data	\N	\N	1698	SmallPop	1	f
132	17	2009-11-19 15:21:11	www-data	\N	\N	1699	SmallPop	1	f
132	21	2009-11-19 15:21:11	www-data	\N	\N	1700	SmallPop	1	f
132	49	2009-11-19 15:21:11	www-data	\N	\N	1701	SmallPop	1	f
132	25	2009-11-19 15:21:11	www-data	\N	\N	1702	SmallPop	1	f
132	29	2009-11-19 15:21:11	www-data	\N	\N	1703	SmallPop	1	f
132	41	2009-11-19 15:21:11	www-data	\N	\N	1704	SmallPop	1	f
132	33	2009-11-19 15:21:11	www-data	\N	\N	1705	SmallPop	1	f
132	37	2009-11-19 15:21:11	www-data	\N	\N	1706	SmallPop	1	f
132	95	2009-11-19 15:21:11	www-data	\N	\N	1707	SmallPop	1	f
132	83	2009-11-19 15:21:11	www-data	\N	\N	1708	SmallPop	1	f
132	71	2009-11-19 15:21:11	www-data	\N	\N	1709	SmallPop	1	f
132	79	2009-11-19 15:21:11	www-data	\N	\N	1710	SmallPop	1	f
132	99	2009-11-19 15:21:11	www-data	\N	\N	1711	SmallPop	1	f
132	75	2009-11-19 15:21:11	www-data	\N	\N	1712	SmallPop	1	f
132	63	2009-11-19 15:21:11	www-data	\N	\N	1713	SmallPop	1	f
132	91	2009-11-19 15:21:11	www-data	\N	\N	1714	SmallPop	1	f
132	87	2009-11-19 15:21:11	www-data	\N	\N	1715	SmallPop	1	f
132	67	2009-11-19 15:21:11	www-data	\N	\N	1716	SmallPop	1	f
132	55	2009-11-19 15:21:11	www-data	\N	\N	1717	SmallPop	1	f
132	59	2009-11-19 15:21:11	www-data	\N	\N	1718	SmallPop	1	f
132	11	2009-11-19 15:21:11	www-data	\N	\N	1719	SmallPop	1	f
132	19	2009-11-19 15:21:11	www-data	\N	\N	1720	SmallPop	1	f
132	23	2009-11-19 15:21:11	www-data	\N	\N	1721	SmallPop	1	f
132	51	2009-11-19 15:21:11	www-data	\N	\N	1722	SmallPop	1	f
132	27	2009-11-19 15:21:11	www-data	\N	\N	1723	SmallPop	1	f
132	7	2009-11-19 15:21:11	www-data	\N	\N	1724	SmallPop	1	f
132	31	2009-11-19 15:21:11	www-data	\N	\N	1725	SmallPop	1	f
132	43	2009-11-19 15:21:11	www-data	\N	\N	1726	SmallPop	1	f
132	35	2009-11-19 15:21:11	www-data	\N	\N	1727	SmallPop	1	f
132	39	2009-11-19 15:21:11	www-data	\N	\N	1728	SmallPop	1	f
133	160	2009-11-19 15:22:39	www-data	\N	\N	1730	SmallPop	1	f
133	172	2009-11-19 15:22:39	www-data	\N	\N	1731	SmallPop	1	f
133	96	2009-11-19 15:22:39	www-data	\N	\N	1732	SmallPop	1	f
133	84	2009-11-19 15:22:39	www-data	\N	\N	1733	SmallPop	1	f
133	72	2009-11-19 15:22:39	www-data	\N	\N	1734	SmallPop	1	f
133	80	2009-11-19 15:22:39	www-data	\N	\N	1735	SmallPop	1	f
133	100	2009-11-19 15:22:39	www-data	\N	\N	1736	SmallPop	1	f
133	76	2009-11-19 15:22:39	www-data	\N	\N	1737	SmallPop	1	f
133	64	2009-11-19 15:22:39	www-data	\N	\N	1738	SmallPop	1	f
133	92	2009-11-19 15:22:39	www-data	\N	\N	1739	SmallPop	1	f
133	88	2009-11-19 15:22:39	www-data	\N	\N	1740	SmallPop	1	f
133	68	2009-11-19 15:22:39	www-data	\N	\N	1741	SmallPop	1	f
133	56	2009-11-19 15:22:39	www-data	\N	\N	1742	SmallPop	1	f
133	60	2009-11-19 15:22:39	www-data	\N	\N	1743	SmallPop	1	f
133	48	2009-11-19 15:22:39	www-data	\N	\N	1744	SmallPop	1	f
133	104	2009-11-19 15:22:39	www-data	\N	\N	1745	SmallPop	1	f
133	16	2009-11-19 15:22:39	www-data	\N	\N	1746	SmallPop	1	f
133	140	2009-11-19 15:22:39	www-data	\N	\N	1747	SmallPop	1	f
133	168	2009-11-19 15:22:39	www-data	\N	\N	1748	SmallPop	1	f
133	12	2009-11-19 15:22:39	www-data	\N	\N	1749	SmallPop	1	f
133	148	2009-11-19 15:22:39	www-data	\N	\N	1750	SmallPop	1	f
133	20	2009-11-19 15:22:39	www-data	\N	\N	1751	SmallPop	1	f
133	24	2009-11-19 15:22:39	www-data	\N	\N	1752	SmallPop	1	f
133	52	2009-11-19 15:22:39	www-data	\N	\N	1753	SmallPop	1	f
133	28	2009-11-19 15:22:39	www-data	\N	\N	1754	SmallPop	1	f
133	8	2009-11-19 15:22:39	www-data	\N	\N	1755	SmallPop	1	f
133	152	2009-11-19 15:22:39	www-data	\N	\N	1756	SmallPop	1	f
133	176	2009-11-19 15:22:39	www-data	\N	\N	1757	SmallPop	1	f
133	32	2009-11-19 15:22:39	www-data	\N	\N	1758	SmallPop	1	f
133	44	2009-11-19 15:22:39	www-data	\N	\N	1759	SmallPop	1	f
133	112	2009-11-19 15:22:39	www-data	\N	\N	1760	SmallPop	1	f
133	156	2009-11-19 15:22:39	www-data	\N	\N	1761	SmallPop	1	f
133	164	2009-11-19 15:22:39	www-data	\N	\N	1762	SmallPop	1	f
133	124	2009-11-19 15:22:39	www-data	\N	\N	1763	SmallPop	1	f
133	120	2009-11-19 15:22:39	www-data	\N	\N	1764	SmallPop	1	f
133	136	2009-11-19 15:22:39	www-data	\N	\N	1765	SmallPop	1	f
133	128	2009-11-19 15:22:39	www-data	\N	\N	1766	SmallPop	1	f
133	180	2009-11-19 15:22:39	www-data	\N	\N	1767	SmallPop	1	f
133	36	2009-11-19 15:22:39	www-data	\N	\N	1768	SmallPop	1	f
133	116	2009-11-19 15:22:39	www-data	\N	\N	1769	SmallPop	1	f
133	132	2009-11-19 15:22:39	www-data	\N	\N	1770	SmallPop	1	f
133	40	2009-11-19 15:22:39	www-data	\N	\N	1771	SmallPop	1	f
133	108	2009-11-19 15:22:39	www-data	\N	\N	1772	SmallPop	1	f
133	4	2009-11-19 15:22:39	www-data	\N	\N	1773	SmallPop	1	f
133	144	2009-11-19 15:22:39	www-data	\N	\N	1774	SmallPop	1	f
133	158	2009-11-19 15:22:39	www-data	\N	\N	1775	SmallPop	1	f
133	170	2009-11-19 15:22:39	www-data	\N	\N	1776	SmallPop	1	f
133	94	2009-11-19 15:22:39	www-data	\N	\N	1777	SmallPop	1	f
133	82	2009-11-19 15:22:39	www-data	\N	\N	1778	SmallPop	1	f
133	70	2009-11-19 15:22:39	www-data	\N	\N	1779	SmallPop	1	f
133	78	2009-11-19 15:22:39	www-data	\N	\N	1780	SmallPop	1	f
133	98	2009-11-19 15:22:39	www-data	\N	\N	1781	SmallPop	1	f
133	74	2009-11-19 15:22:39	www-data	\N	\N	1782	SmallPop	1	f
133	62	2009-11-19 15:22:39	www-data	\N	\N	1783	SmallPop	1	f
133	90	2009-11-19 15:22:39	www-data	\N	\N	1784	SmallPop	1	f
133	86	2009-11-19 15:22:39	www-data	\N	\N	1785	SmallPop	1	f
133	66	2009-11-19 15:22:39	www-data	\N	\N	1786	SmallPop	1	f
133	54	2009-11-19 15:22:39	www-data	\N	\N	1787	SmallPop	1	f
133	58	2009-11-19 15:22:39	www-data	\N	\N	1788	SmallPop	1	f
133	46	2009-11-19 15:22:39	www-data	\N	\N	1789	SmallPop	1	f
133	102	2009-11-19 15:22:39	www-data	\N	\N	1790	SmallPop	1	f
133	14	2009-11-19 15:22:39	www-data	\N	\N	1791	SmallPop	1	f
133	138	2009-11-19 15:22:39	www-data	\N	\N	1792	SmallPop	1	f
133	166	2009-11-19 15:22:39	www-data	\N	\N	1793	SmallPop	1	f
133	10	2009-11-19 15:22:39	www-data	\N	\N	1794	SmallPop	1	f
133	146	2009-11-19 15:22:39	www-data	\N	\N	1795	SmallPop	1	f
133	18	2009-11-19 15:22:39	www-data	\N	\N	1796	SmallPop	1	f
133	22	2009-11-19 15:22:39	www-data	\N	\N	1797	SmallPop	1	f
133	50	2009-11-19 15:22:39	www-data	\N	\N	1798	SmallPop	1	f
133	26	2009-11-19 15:22:39	www-data	\N	\N	1799	SmallPop	1	f
133	6	2009-11-19 15:22:39	www-data	\N	\N	1800	SmallPop	1	f
133	150	2009-11-19 15:22:39	www-data	\N	\N	1801	SmallPop	1	f
133	174	2009-11-19 15:22:39	www-data	\N	\N	1802	SmallPop	1	f
133	30	2009-11-19 15:22:39	www-data	\N	\N	1803	SmallPop	1	f
133	42	2009-11-19 15:22:39	www-data	\N	\N	1804	SmallPop	1	f
133	110	2009-11-19 15:22:39	www-data	\N	\N	1805	SmallPop	1	f
133	154	2009-11-19 15:22:39	www-data	\N	\N	1806	SmallPop	1	f
133	162	2009-11-19 15:22:39	www-data	\N	\N	1807	SmallPop	1	f
133	122	2009-11-19 15:22:39	www-data	\N	\N	1808	SmallPop	1	f
133	118	2009-11-19 15:22:39	www-data	\N	\N	1809	SmallPop	1	f
133	134	2009-11-19 15:22:39	www-data	\N	\N	1810	SmallPop	1	f
133	126	2009-11-19 15:22:39	www-data	\N	\N	1811	SmallPop	1	f
133	178	2009-11-19 15:22:39	www-data	\N	\N	1812	SmallPop	1	f
133	34	2009-11-19 15:22:39	www-data	\N	\N	1813	SmallPop	1	f
133	114	2009-11-19 15:22:39	www-data	\N	\N	1814	SmallPop	1	f
133	130	2009-11-19 15:22:39	www-data	\N	\N	1815	SmallPop	1	f
133	38	2009-11-19 15:22:39	www-data	\N	\N	1816	SmallPop	1	f
133	106	2009-11-19 15:22:39	www-data	\N	\N	1817	SmallPop	1	f
133	2	2009-11-19 15:22:39	www-data	\N	\N	1818	SmallPop	1	f
133	142	2009-11-19 15:22:39	www-data	\N	\N	1819	SmallPop	1	f
133	157	2009-11-19 15:22:39	www-data	\N	\N	1820	SmallPop	1	f
133	169	2009-11-19 15:22:39	www-data	\N	\N	1821	SmallPop	1	f
133	93	2009-11-19 15:22:39	www-data	\N	\N	1822	SmallPop	1	f
133	81	2009-11-19 15:22:39	www-data	\N	\N	1823	SmallPop	1	f
133	69	2009-11-19 15:22:39	www-data	\N	\N	1824	SmallPop	1	f
133	77	2009-11-19 15:22:39	www-data	\N	\N	1825	SmallPop	1	f
133	97	2009-11-19 15:22:39	www-data	\N	\N	1826	SmallPop	1	f
133	73	2009-11-19 15:22:39	www-data	\N	\N	1827	SmallPop	1	f
133	61	2009-11-19 15:22:39	www-data	\N	\N	1828	SmallPop	1	f
133	89	2009-11-19 15:22:39	www-data	\N	\N	1829	SmallPop	1	f
133	85	2009-11-19 15:22:39	www-data	\N	\N	1830	SmallPop	1	f
133	65	2009-11-19 15:22:39	www-data	\N	\N	1831	SmallPop	1	f
133	53	2009-11-19 15:22:39	www-data	\N	\N	1832	SmallPop	1	f
133	57	2009-11-19 15:22:39	www-data	\N	\N	1833	SmallPop	1	f
133	45	2009-11-19 15:22:39	www-data	\N	\N	1834	SmallPop	1	f
133	101	2009-11-19 15:22:39	www-data	\N	\N	1835	SmallPop	1	f
133	13	2009-11-19 15:22:39	www-data	\N	\N	1836	SmallPop	1	f
133	137	2009-11-19 15:22:39	www-data	\N	\N	1837	SmallPop	1	f
133	165	2009-11-19 15:22:39	www-data	\N	\N	1838	SmallPop	1	f
133	9	2009-11-19 15:22:39	www-data	\N	\N	1839	SmallPop	1	f
133	145	2009-11-19 15:22:39	www-data	\N	\N	1840	SmallPop	1	f
133	17	2009-11-19 15:22:39	www-data	\N	\N	1841	SmallPop	1	f
133	21	2009-11-19 15:22:39	www-data	\N	\N	1842	SmallPop	1	f
133	49	2009-11-19 15:22:39	www-data	\N	\N	1843	SmallPop	1	f
133	25	2009-11-19 15:22:39	www-data	\N	\N	1844	SmallPop	1	f
133	5	2009-11-19 15:22:39	www-data	\N	\N	1845	SmallPop	1	f
133	149	2009-11-19 15:22:39	www-data	\N	\N	1846	SmallPop	1	f
133	173	2009-11-19 15:22:39	www-data	\N	\N	1847	SmallPop	1	f
133	29	2009-11-19 15:22:39	www-data	\N	\N	1848	SmallPop	1	f
133	41	2009-11-19 15:22:39	www-data	\N	\N	1849	SmallPop	1	f
133	109	2009-11-19 15:22:39	www-data	\N	\N	1850	SmallPop	1	f
133	153	2009-11-19 15:22:39	www-data	\N	\N	1851	SmallPop	1	f
133	161	2009-11-19 15:22:39	www-data	\N	\N	1852	SmallPop	1	f
133	121	2009-11-19 15:22:39	www-data	\N	\N	1853	SmallPop	1	f
133	117	2009-11-19 15:22:39	www-data	\N	\N	1854	SmallPop	1	f
133	133	2009-11-19 15:22:39	www-data	\N	\N	1855	SmallPop	1	f
133	125	2009-11-19 15:22:39	www-data	\N	\N	1856	SmallPop	1	f
133	177	2009-11-19 15:22:39	www-data	\N	\N	1857	SmallPop	1	f
133	33	2009-11-19 15:22:39	www-data	\N	\N	1858	SmallPop	1	f
133	113	2009-11-19 15:22:39	www-data	\N	\N	1859	SmallPop	1	f
133	129	2009-11-19 15:22:39	www-data	\N	\N	1860	SmallPop	1	f
133	37	2009-11-19 15:22:39	www-data	\N	\N	1861	SmallPop	1	f
133	105	2009-11-19 15:22:39	www-data	\N	\N	1862	SmallPop	1	f
133	1	2009-11-19 15:22:39	www-data	\N	\N	1863	SmallPop	1	f
133	141	2009-11-19 15:22:39	www-data	\N	\N	1864	SmallPop	1	f
133	159	2009-11-19 15:22:39	www-data	\N	\N	1865	SmallPop	1	f
133	171	2009-11-19 15:22:39	www-data	\N	\N	1866	SmallPop	1	f
133	95	2009-11-19 15:22:39	www-data	\N	\N	1867	SmallPop	1	f
133	83	2009-11-19 15:22:39	www-data	\N	\N	1868	SmallPop	1	f
133	71	2009-11-19 15:22:39	www-data	\N	\N	1869	SmallPop	1	f
133	79	2009-11-19 15:22:39	www-data	\N	\N	1870	SmallPop	1	f
133	99	2009-11-19 15:22:39	www-data	\N	\N	1871	SmallPop	1	f
133	75	2009-11-19 15:22:39	www-data	\N	\N	1872	SmallPop	1	f
133	63	2009-11-19 15:22:39	www-data	\N	\N	1873	SmallPop	1	f
133	91	2009-11-19 15:22:39	www-data	\N	\N	1874	SmallPop	1	f
133	87	2009-11-19 15:22:39	www-data	\N	\N	1875	SmallPop	1	f
133	67	2009-11-19 15:22:39	www-data	\N	\N	1876	SmallPop	1	f
133	55	2009-11-19 15:22:39	www-data	\N	\N	1877	SmallPop	1	f
133	59	2009-11-19 15:22:39	www-data	\N	\N	1878	SmallPop	1	f
133	47	2009-11-19 15:22:39	www-data	\N	\N	1879	SmallPop	1	f
133	103	2009-11-19 15:22:39	www-data	\N	\N	1880	SmallPop	1	f
133	15	2009-11-19 15:22:39	www-data	\N	\N	1881	SmallPop	1	f
133	139	2009-11-19 15:22:39	www-data	\N	\N	1882	SmallPop	1	f
133	167	2009-11-19 15:22:39	www-data	\N	\N	1883	SmallPop	1	f
133	11	2009-11-19 15:22:39	www-data	\N	\N	1884	SmallPop	1	f
133	147	2009-11-19 15:22:39	www-data	\N	\N	1885	SmallPop	1	f
133	19	2009-11-19 15:22:39	www-data	\N	\N	1886	SmallPop	1	f
133	23	2009-11-19 15:22:39	www-data	\N	\N	1887	SmallPop	1	f
133	51	2009-11-19 15:22:39	www-data	\N	\N	1888	SmallPop	1	f
133	27	2009-11-19 15:22:39	www-data	\N	\N	1889	SmallPop	1	f
133	7	2009-11-19 15:22:39	www-data	\N	\N	1890	SmallPop	1	f
133	151	2009-11-19 15:22:39	www-data	\N	\N	1891	SmallPop	1	f
133	175	2009-11-19 15:22:39	www-data	\N	\N	1892	SmallPop	1	f
133	31	2009-11-19 15:22:39	www-data	\N	\N	1893	SmallPop	1	f
133	43	2009-11-19 15:22:39	www-data	\N	\N	1894	SmallPop	1	f
133	111	2009-11-19 15:22:39	www-data	\N	\N	1895	SmallPop	1	f
133	155	2009-11-19 15:22:39	www-data	\N	\N	1896	SmallPop	1	f
133	163	2009-11-19 15:22:39	www-data	\N	\N	1897	SmallPop	1	f
133	123	2009-11-19 15:22:39	www-data	\N	\N	1898	SmallPop	1	f
133	119	2009-11-19 15:22:39	www-data	\N	\N	1899	SmallPop	1	f
133	135	2009-11-19 15:22:39	www-data	\N	\N	1900	SmallPop	1	f
133	127	2009-11-19 15:22:39	www-data	\N	\N	1901	SmallPop	1	f
133	179	2009-11-19 15:22:39	www-data	\N	\N	1902	SmallPop	1	f
133	35	2009-11-19 15:22:39	www-data	\N	\N	1903	SmallPop	1	f
133	115	2009-11-19 15:22:39	www-data	\N	\N	1904	SmallPop	1	f
133	131	2009-11-19 15:22:39	www-data	\N	\N	1905	SmallPop	1	f
133	39	2009-11-19 15:22:39	www-data	\N	\N	1906	SmallPop	1	f
133	107	2009-11-19 15:22:39	www-data	\N	\N	1907	SmallPop	1	f
133	3	2009-11-19 15:22:39	www-data	\N	\N	1908	SmallPop	1	f
133	143	2009-11-19 15:22:39	www-data	\N	\N	1909	SmallPop	1	f
\.


--
-- Data for Name: ar_role_stpolicies; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_role_stpolicies (role_id, stpolicy_id, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
111	5	2009-11-01 14:28:34	www-data	\N	\N	744	SmallPop	1	f
111	4	2009-11-01 14:28:34	www-data	\N	\N	745	SmallPop	1	f
111	3	2009-11-01 14:28:34	www-data	\N	\N	746	SmallPop	1	f
111	7	2009-11-01 14:28:34	www-data	\N	\N	747	SmallPop	1	f
111	8	2009-11-01 14:28:34	www-data	\N	\N	748	SmallPop	1	f
111	6	2009-11-01 14:28:34	www-data	\N	\N	749	SmallPop	1	f
111	9	2009-11-01 14:28:34	www-data	\N	\N	750	SmallPop	1	f
111	2	2009-11-01 14:28:34	www-data	\N	\N	751	SmallPop	1	f
111	13	2009-11-01 14:28:34	www-data	\N	\N	752	SmallPop	1	f
111	1	2009-11-01 14:28:34	www-data	\N	\N	753	SmallPop	1	f
111	14	2009-11-01 14:34:40	www-data	\N	\N	758	SmallPop	1	f
111	10	2009-11-01 14:34:40	www-data	\N	\N	759	SmallPop	1	f
111	12	2009-11-01 14:34:40	www-data	\N	\N	760	SmallPop	1	f
111	11	2009-11-01 14:34:40	www-data	\N	\N	761	SmallPop	1	f
113	13	2009-11-01 17:28:23	www-data	\N	\N	950	SmallPop	1	f
113	18	2009-11-01 17:28:23	www-data	\N	\N	951	SmallPop	1	f
113	10	2009-11-01 17:28:23	www-data	\N	\N	952	SmallPop	1	f
113	17	2009-11-01 17:28:23	www-data	\N	\N	953	SmallPop	1	f
113	12	2009-11-01 17:28:23	www-data	\N	\N	954	SmallPop	1	f
113	11	2009-11-01 17:28:23	www-data	\N	\N	955	SmallPop	1	f
113	16	2009-11-01 17:28:23	www-data	\N	\N	956	SmallPop	1	f
113	19	2009-11-01 17:48:05	www-data	\N	\N	1073	SmallPop	1	f
124	13	2009-11-01 18:05:30	www-data	\N	\N	1130	SmallPop	1	f
124	10	2009-11-01 18:05:30	www-data	\N	\N	1131	SmallPop	1	f
124	17	2009-11-01 18:05:30	www-data	\N	\N	1132	SmallPop	1	f
124	12	2009-11-01 18:05:30	www-data	\N	\N	1133	SmallPop	1	f
124	11	2009-11-01 18:05:30	www-data	\N	\N	1134	SmallPop	1	f
124	19	2009-11-01 18:05:30	www-data	\N	\N	1135	SmallPop	1	f
124	16	2009-11-01 18:05:30	www-data	\N	\N	1136	SmallPop	1	f
124	15	2009-11-01 18:05:30	www-data	\N	\N	1137	SmallPop	1	f
125	13	2009-11-01 18:11:31	www-data	\N	\N	1142	SmallPop	1	f
125	10	2009-11-01 18:11:31	www-data	\N	\N	1143	SmallPop	1	f
125	17	2009-11-01 18:11:31	www-data	\N	\N	1144	SmallPop	1	f
125	12	2009-11-01 18:11:31	www-data	\N	\N	1145	SmallPop	1	f
125	11	2009-11-01 18:11:31	www-data	\N	\N	1146	SmallPop	1	f
125	19	2009-11-01 18:11:31	www-data	\N	\N	1147	SmallPop	1	f
125	16	2009-11-01 18:11:31	www-data	\N	\N	1148	SmallPop	1	f
\.


--
-- Data for Name: ar_roles; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_roles (role_id, role_name, role_long_name, role_type, role_subset, role_descr, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
111	User Administrators	User Administrators	ST	\N	Members which have this role can add users to or remove users from the system. He can update the data and grant new roles to existing users.	2009-11-01 14:52:03	admin	\N	\N	743	SmallPop	3	\N
113	Lab Managers	Lab Managers	ST	\N	Members which are granted this role can work with most functions in the system except data entry via the workflow.	2009-11-01 17:26:40	admin	\N	\N	949	SmallPop	1	\N
124	Scientists	Scientists	ST	\N	Members which are granted this role can use the workflow for data entry and other functions in the system except the administration of data.	2009-11-01 18:06:56	admin	\N	\N	1129	SmallPop	2	\N
125	Visitors	Visitors	ST	\N	Members which are granted this role are limited to use the workflow and the administration of data.	2009-11-01 18:12:41	admin	\N	\N	1141	SmallPop	2	\N
129	Read	Read	DBT	\N	\N	2009-11-19 14:52:52	admin	\N	\N	1546	SmallPop	1	\N
130	Write	Write	DBT	\N	\N	2009-11-19 15:05:00	admin	\N	\N	1570	SmallPop	1	\N
131	Delete	Delete	DBT	\N	\N	2009-11-19 15:08:24	admin	\N	\N	1618	SmallPop	1	\N
132	Manage User	Manage User	DBT	\N	\N	2009-11-19 15:11:14	admin	\N	\N	1643	SmallPop	1	\N
133	Full right	Full right	DBT	Delete,Manage User,Read,Write	\N	2009-11-19 15:22:29	admin	\N	\N	1729	SmallPop	1	\N
\.


--
-- Data for Name: ar_stpolicies; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_stpolicies (stpolicy_id, stpolicy_name, stpolicy_type, stpolicy_desc, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
6	grant role to the user	action	\N	2009-11-01 14:21:44	cong	\N	\N	116	SmallPop	1	f
11	logout	www	\N	2009-11-01 14:21:44	cong	\N	\N	117	SmallPop	1	f
3	create public views	action	\N	2009-11-01 14:21:44	cong	\N	\N	118	SmallPop	1	f
7	delete role	action	\N	2009-11-01 14:21:44	cong	\N	\N	119	SmallPop	1	f
9	revoke role from the user	action	\N	2009-11-01 14:21:44	cong	\N	\N	120	SmallPop	1	f
2	show info about users or roles	action	\N	2009-11-01 14:21:44	cong	\N	\N	121	SmallPop	1	f
12	help	www	\N	2009-11-01 14:21:44	cong	\N	\N	122	SmallPop	1	f
14	arm	www	\N	2009-11-01 14:21:44	cong	\N	\N	123	SmallPop	1	f
8	delete user	action	\N	2009-11-01 14:21:44	cong	\N	\N	124	SmallPop	1	f
4	add new user	action	\N	2009-11-01 14:21:44	cong	\N	\N	125	SmallPop	1	f
1	access_rights_manager.pl	program	\N	2009-11-01 14:21:44	cong	\N	\N	126	SmallPop	1	f
10	documentation	www	\N	2009-11-01 14:21:44	cong	\N	\N	127	SmallPop	1	f
13	access_rights_manager tool	form	\N	2009-11-01 14:21:44	cong	\N	\N	128	SmallPop	1	f
5	add new role	action	\N	2009-11-01 14:21:44	cong	\N	\N	129	SmallPop	1	f
15	workflow	www	\N	2009-11-01 14:30:35	cong	\N	\N	754	SmallPop	1	\N
16	reports	www	\N	2009-11-01 14:30:58	cong	\N	\N	755	SmallPop	1	\N
17	export_data	www	\N	2009-11-01 14:31:11	cong	\N	\N	756	SmallPop	1	\N
18	administration	www	\N	2009-11-01 14:32:07	cong	\N	\N	757	SmallPop	1	\N
19	manage_data	www	\N	2009-11-01 17:47:50	admin	\N	\N	1072	SmallPop	1	\N
\.


--
-- Data for Name: ar_user_roles; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_user_roles (user_id, role_id, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
101	111	2009-11-01 14:36:59	cong	\N	\N	946	SmallPop	1	f
102	113	2009-11-01 17:45:24	admin	\N	\N	1071	SmallPop	1	f
104	125	2009-11-01 18:13:45	admin	\N	\N	1152	SmallPop	1	f
106	111	2009-11-19 11:47:33	admin	\N	\N	1540	SmallPop	1	f
106	133	2009-11-19 15:23:01	admin	\N	\N	1910	SmallPop	1	f
104	129	2009-11-19 15:25:45	admin	\N	\N	1912	SmallPop	1	f
107	131	2009-11-19 15:26:47	admin	\N	\N	1915	SmallPop	1	f
107	129	2009-11-19 15:26:47	admin	\N	\N	1916	SmallPop	1	f
107	130	2009-11-19 15:26:47	admin	\N	\N	1917	SmallPop	1	f
107	124	2009-11-19 15:26:47	admin	\N	\N	1918	SmallPop	1	f
102	131	2009-11-19 15:28:35	admin	\N	\N	1922	SmallPop	1	f
102	129	2009-11-19 15:28:35	admin	\N	\N	1923	SmallPop	1	f
102	130	2009-11-19 15:28:35	admin	\N	\N	1924	SmallPop	1	f
101	132	2009-11-19 15:29:43	molabis	\N	\N	1925	SmallPop	1	f
108	131	2009-11-19 15:31:53	admin	\N	\N	1928	SmallPop	1	f
108	129	2009-11-19 15:31:53	admin	\N	\N	1929	SmallPop	1	f
108	130	2009-11-19 15:31:53	admin	\N	\N	1930	SmallPop	1	f
108	113	2009-11-19 15:31:53	admin	\N	\N	1931	SmallPop	1	f
108	124	2009-11-19 15:31:53	admin	\N	\N	1932	SmallPop	1	f
\.


--
-- Data for Name: ar_users; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_users (user_id, user_login, user_password, user_language_id, user_marker, user_disabled, user_status, user_last_login, user_last_activ_time, user_session_id, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
101	admin	ISMvKXpXpadDiUoOSoAfww	25	SmallPop	f	f	\N	\N	\N	2009-11-01 14:36:23	cong	\N	\N	943	SmallPop	1	\N
102	manager	HQJYwkQKjRnnFikrIx4xkA	25	SmallPop	f	f	\N	\N	\N	2009-11-01 17:29:07	admin	\N	\N	957	SmallPop	1	\N
104	visitor	Enhwkw1lxX7mX8xH8hcNOA	25	SmallPop	f	f	\N	\N	\N	2009-11-01 18:13:27	admin	\N	\N	1149	SmallPop	1	\N
106	molabis	zKCL2ss+OCPxIo91lgHrVw	25	SmallPop	f	f	\N	\N	\N	2009-11-19 14:48:38	admin	\N	\N	1537	SmallPop	2	\N
107	scientist	6vgvp+LAnXSNy65LSwmr6A	25	SmallPop	f	f	\N	\N	\N	2009-11-19 15:26:34	admin	\N	\N	1913	SmallPop	1	\N
108	staff	ElMghGWx76h2+YLYqec+7w	25	SmallPop	f	f	\N	\N	\N	2009-11-19 15:31:28	admin	\N	\N	1926	SmallPop	1	\N
\.


--
-- Data for Name: ar_users_data; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY ar_users_data (user_id, user_first_name, user_second_name, user_institution, user_email, user_country, user_street, user_town, user_zip, user_other_info, opening_dt, closing_dt, last_change_dt, last_change_user, creation_dt, creation_user, end_dt, end_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
101	Admin	User	\N	\N	Germany	\N	\N	\N	\N	\N	\N	2009-11-01 14:36:23	cong	2009-11-01 14:36:23	cong	\N	\N	\N	\N	944	SmallPop	1	\N
102	Manager	User	\N	\N	Germany	\N	\N	\N	\N	\N	\N	2009-11-01 17:29:08	admin	2009-11-01 17:29:08	admin	\N	\N	\N	\N	958	SmallPop	1	\N
104	Visitor	User	\N	\N	Germany	\N	\N	\N	\N	\N	\N	2009-11-01 18:13:27	admin	2009-11-01 18:13:27	admin	\N	\N	\N	\N	1150	SmallPop	1	\N
106	Molabis	User	\N	\N	Germany	\N	\N	\N	\N	\N	\N	2009-11-19 14:48:38	admin	2009-11-19 14:48:38	admin	\N	\N	\N	\N	1538	SmallPop	2	\N
107	Scientist	User	\N	\N	Germany	\N	\N	\N	\N	\N	\N	2009-11-19 15:26:34	admin	2009-11-19 15:26:34	admin	\N	\N	\N	\N	1914	SmallPop	1	\N
108	Staff	User	\N	\N	Germany	\N	\N	\N	\N	\N	\N	2009-11-19 15:31:28	admin	2009-11-19 15:31:28	admin	\N	\N	\N	\N	1927	SmallPop	1	\N
\.


--
-- Data for Name: blobs; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY blobs (blob_id, blob, db_mimetype, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
\.


--
-- Data for Name: codes; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY codes (ext_code, "class", db_code, short_name, long_name, description, opening_dt, closing_dt, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
insert	SQLACTION	100	insert	\N	\N	\N	\N	2009-11-01 14:21:44	cong	\N	\N	100	SmallPop	1	f
update	SQLACTION	101	update	\N	\N	\N	\N	2009-11-01 14:21:44	cong	\N	\N	101	SmallPop	1	f
delete	SQLACTION	102	delete	\N	\N	\N	\N	2009-11-01 14:21:44	cong	\N	\N	102	SmallPop	1	f
select	SQLACTION	103	select	\N	\N	\N	\N	2009-11-01 14:21:44	cong	\N	\N	103	SmallPop	1	f
application/x-zip-compressed	MIMETYPE	104	application/x-zip-compressed	application/x-zip-compressed	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	598	SmallPop	1	\N
application/vnd.oasis.opendocument.text	MIMETYPE	105	application/vnd.oasis.opendocument.text	application/vnd.oasis.opendocument.text	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	599	SmallPop	1	\N
application/vnd.oasis.opendocument.text-template	MIMETYPE	106	application/vnd.oasis.opendocument.text-template	application/vnd.oasis.opendocument.text-template	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	600	SmallPop	1	\N
application/vnd.oasis.opendocument.text-web	MIMETYPE	107	application/vnd.oasis.opendocument.text-web	application/vnd.oasis.opendocument.text-web	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	601	SmallPop	1	\N
application/vnd.oasis.opendocument.text-master	MIMETYPE	108	application/vnd.oasis.opendocument.text-master	application/vnd.oasis.opendocument.text-master	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	602	SmallPop	1	\N
application/vnd.oasis.opendocument.graphics	MIMETYPE	109	application/vnd.oasis.opendocument.graphics	application/vnd.oasis.opendocument.graphics	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	603	SmallPop	1	\N
application/vnd.oasis.opendocument.graphics-template	MIMETYPE	110	application/vnd.oasis.opendocument.graphics-template	application/vnd.oasis.opendocument.graphics-template	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	604	SmallPop	1	\N
application/vnd.oasis.opendocument.presentation	MIMETYPE	111	application/vnd.oasis.opendocument.presentation	application/vnd.oasis.opendocument.presentation	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	605	SmallPop	1	\N
application/vnd.oasis.opendocument.presentation-template	MIMETYPE	112	application/vnd.oasis.opendocument.presentation-template	application/vnd.oasis.opendocument.presentation-template	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	606	SmallPop	1	\N
application/vnd.oasis.opendocument.spreadsheet	MIMETYPE	113	application/vnd.oasis.opendocument.spreadsheet	application/vnd.oasis.opendocument.spreadsheet	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	607	SmallPop	1	\N
application/vnd.oasis.opendocument.spreadsheet-template	MIMETYPE	114	application/vnd.oasis.opendocument.spreadsheet-template	application/vnd.oasis.opendocument.spreadsheet-template	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	608	SmallPop	1	\N
application/vnd.oasis.opendocument.chart	MIMETYPE	115	application/vnd.oasis.opendocument.chart	application/vnd.oasis.opendocument.chart	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	609	SmallPop	1	\N
application/vnd.oasis.opendocument.formula	MIMETYPE	116	application/vnd.oasis.opendocument.formula	application/vnd.oasis.opendocument.formula	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	610	SmallPop	1	\N
application/vnd.oasis.opendocument.database	MIMETYPE	117	application/vnd.oasis.opendocument.database	application/vnd.oasis.opendocument.database	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	611	SmallPop	1	\N
application/vnd.oasis.opendocument.image	MIMETYPE	118	application/vnd.oasis.opendocument.image	application/vnd.oasis.opendocument.image	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	612	SmallPop	1	\N
application/vnd.openofficeorg.extension	MIMETYPE	119	application/vnd.openofficeorg.extension	application/vnd.openofficeorg.extension	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	613	SmallPop	1	\N
application/andrew-inset	MIMETYPE	120	application/andrew-inset	application/andrew-inset	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	614	SmallPop	1	\N
application/mac-binhex40	MIMETYPE	121	application/mac-binhex40	application/mac-binhex40	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	615	SmallPop	1	\N
application/mac-compactpro	MIMETYPE	122	application/mac-compactpro	application/mac-compactpro	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	616	SmallPop	1	\N
application/msword	MIMETYPE	123	application/msword	application/msword	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	617	SmallPop	1	\N
application/octet-stream	MIMETYPE	124	application/octet-stream	application/octet-stream	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	618	SmallPop	1	\N
application/x-rar-compressed	MIMETYPE	125	application/x-rar-compressed	application/x-rar-compressed	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	619	SmallPop	1	\N
application/oda	MIMETYPE	126	application/oda	application/oda	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	620	SmallPop	1	\N
application/pdf	MIMETYPE	127	application/pdf	application/pdf	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	621	SmallPop	1	\N
application/postscript	MIMETYPE	128	application/postscript	application/postscript	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	622	SmallPop	1	\N
application/smil	MIMETYPE	129	application/smil	application/smil	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	623	SmallPop	1	\N
application/vnd.mif	MIMETYPE	130	application/vnd.mif	application/vnd.mif	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	624	SmallPop	1	\N
application/vnd.ms-excel	MIMETYPE	131	application/vnd.ms-excel	application/vnd.ms-excel	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	625	SmallPop	1	\N
application/vnd.ms-powerpoint	MIMETYPE	132	application/vnd.ms-powerpoint	application/vnd.ms-powerpoint	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	626	SmallPop	1	\N
application/vnd.wap.wbxml	MIMETYPE	133	application/vnd.wap.wbxml	application/vnd.wap.wbxml	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	627	SmallPop	1	\N
application/vnd.wap.wmlc	MIMETYPE	134	application/vnd.wap.wmlc	application/vnd.wap.wmlc	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	628	SmallPop	1	\N
application/vnd.wap.wmlscriptc	MIMETYPE	135	application/vnd.wap.wmlscriptc	application/vnd.wap.wmlscriptc	\N	2009-11-01	\N	2009-11-01 14:25:20	cong	\N	\N	629	SmallPop	1	\N
application/x-bcpio	MIMETYPE	136	application/x-bcpio	application/x-bcpio	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	630	SmallPop	1	\N
application/x-cdlink	MIMETYPE	137	application/x-cdlink	application/x-cdlink	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	631	SmallPop	1	\N
application/x-chess-pgn	MIMETYPE	138	application/x-chess-pgn	application/x-chess-pgn	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	632	SmallPop	1	\N
application/x-cpio	MIMETYPE	139	application/x-cpio	application/x-cpio	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	633	SmallPop	1	\N
application/x-csh	MIMETYPE	140	application/x-csh	application/x-csh	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	634	SmallPop	1	\N
application/x-director	MIMETYPE	141	application/x-director	application/x-director	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	635	SmallPop	1	\N
application/x-dvi	MIMETYPE	142	application/x-dvi	application/x-dvi	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	636	SmallPop	1	\N
application/x-futuresplash	MIMETYPE	143	application/x-futuresplash	application/x-futuresplash	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	637	SmallPop	1	\N
application/x-gtar	MIMETYPE	144	application/x-gtar	application/x-gtar	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	638	SmallPop	1	\N
application/x-hdf	MIMETYPE	145	application/x-hdf	application/x-hdf	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	639	SmallPop	1	\N
application/x-javascript	MIMETYPE	146	application/x-javascript	application/x-javascript	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	640	SmallPop	1	\N
application/x-koan	MIMETYPE	147	application/x-koan	application/x-koan	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	641	SmallPop	1	\N
application/x-latex	MIMETYPE	148	application/x-latex	application/x-latex	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	642	SmallPop	1	\N
application/x-netcdf	MIMETYPE	149	application/x-netcdf	application/x-netcdf	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	643	SmallPop	1	\N
application/x-sh	MIMETYPE	150	application/x-sh	application/x-sh	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	644	SmallPop	1	\N
application/x-shar	MIMETYPE	151	application/x-shar	application/x-shar	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	645	SmallPop	1	\N
application/x-shockwave-flash	MIMETYPE	152	application/x-shockwave-flash	application/x-shockwave-flash	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	646	SmallPop	1	\N
application/x-stuffit	MIMETYPE	153	application/x-stuffit	application/x-stuffit	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	647	SmallPop	1	\N
application/x-sv4cpio	MIMETYPE	154	application/x-sv4cpio	application/x-sv4cpio	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	648	SmallPop	1	\N
application/x-sv4crc	MIMETYPE	155	application/x-sv4crc	application/x-sv4crc	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	649	SmallPop	1	\N
application/x-tar	MIMETYPE	156	application/x-tar	application/x-tar	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	650	SmallPop	1	\N
application/x-tcl	MIMETYPE	157	application/x-tcl	application/x-tcl	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	651	SmallPop	1	\N
application/x-tex	MIMETYPE	158	application/x-tex	application/x-tex	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	652	SmallPop	1	\N
application/x-texinfo	MIMETYPE	159	application/x-texinfo	application/x-texinfo	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	653	SmallPop	1	\N
application/x-troff	MIMETYPE	160	application/x-troff	application/x-troff	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	654	SmallPop	1	\N
application/x-troff-man	MIMETYPE	161	application/x-troff-man	application/x-troff-man	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	655	SmallPop	1	\N
application/x-troff-me	MIMETYPE	162	application/x-troff-me	application/x-troff-me	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	656	SmallPop	1	\N
application/x-troff-ms	MIMETYPE	163	application/x-troff-ms	application/x-troff-ms	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	657	SmallPop	1	\N
application/x-ustar	MIMETYPE	164	application/x-ustar	application/x-ustar	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	658	SmallPop	1	\N
application/x-wais-source	MIMETYPE	165	application/x-wais-source	application/x-wais-source	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	659	SmallPop	1	\N
application/xhtml+xml	MIMETYPE	166	application/xhtml+xml	application/xhtml+xml	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	660	SmallPop	1	\N
application/zip	MIMETYPE	167	application/zip	application/zip	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	661	SmallPop	1	\N
audio/basic	MIMETYPE	168	audio/basic	audio/basic	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	662	SmallPop	1	\N
audio/midi	MIMETYPE	169	audio/midi	audio/midi	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	663	SmallPop	1	\N
audio/mpeg	MIMETYPE	170	audio/mpeg	audio/mpeg	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	664	SmallPop	1	\N
audio/x-aiff	MIMETYPE	171	audio/x-aiff	audio/x-aiff	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	665	SmallPop	1	\N
audio/x-mpegurl	MIMETYPE	172	audio/x-mpegurl	audio/x-mpegurl	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	666	SmallPop	1	\N
audio/x-pn-realaudio	MIMETYPE	173	audio/x-pn-realaudio	audio/x-pn-realaudio	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	667	SmallPop	1	\N
audio/x-pn-realaudio-plugin	MIMETYPE	174	audio/x-pn-realaudio-plugin	audio/x-pn-realaudio-plugin	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	668	SmallPop	1	\N
audio/x-realaudio	MIMETYPE	175	audio/x-realaudio	audio/x-realaudio	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	669	SmallPop	1	\N
audio/x-wav	MIMETYPE	176	audio/x-wav	audio/x-wav	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	670	SmallPop	1	\N
chemical/x-pdb	MIMETYPE	177	chemical/x-pdb	chemical/x-pdb	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	671	SmallPop	1	\N
chemical/x-xyz	MIMETYPE	178	chemical/x-xyz	chemical/x-xyz	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	672	SmallPop	1	\N
image/bmp	MIMETYPE	179	image/bmp	image/bmp	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	673	SmallPop	1	\N
image/gif	MIMETYPE	180	image/gif	image/gif	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	674	SmallPop	1	\N
image/ief	MIMETYPE	181	image/ief	image/ief	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	675	SmallPop	1	\N
image/jpeg	MIMETYPE	182	image/jpeg	image/jpeg	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	676	SmallPop	1	\N
image/png	MIMETYPE	183	image/png	image/png	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	677	SmallPop	1	\N
image/tiff	MIMETYPE	184	image/tiff	image/tiff	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	678	SmallPop	1	\N
image/vnd.djvu	MIMETYPE	185	image/vnd.djvu	image/vnd.djvu	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	679	SmallPop	1	\N
image/vnd.wap.wbmp	MIMETYPE	186	image/vnd.wap.wbmp	image/vnd.wap.wbmp	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	680	SmallPop	1	\N
image/x-cmu-raster	MIMETYPE	187	image/x-cmu-raster	image/x-cmu-raster	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	681	SmallPop	1	\N
image/x-portable-anymap	MIMETYPE	188	image/x-portable-anymap	image/x-portable-anymap	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	682	SmallPop	1	\N
image/x-portable-bitmap	MIMETYPE	189	image/x-portable-bitmap	image/x-portable-bitmap	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	683	SmallPop	1	\N
image/x-portable-graymap	MIMETYPE	190	image/x-portable-graymap	image/x-portable-graymap	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	684	SmallPop	1	\N
image/x-portable-pixmap	MIMETYPE	191	image/x-portable-pixmap	image/x-portable-pixmap	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	685	SmallPop	1	\N
image/x-rgb	MIMETYPE	192	image/x-rgb	image/x-rgb	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	686	SmallPop	1	\N
image/x-xbitmap	MIMETYPE	193	image/x-xbitmap	image/x-xbitmap	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	687	SmallPop	1	\N
image/x-xwindowdump	MIMETYPE	194	image/x-xwindowdump	image/x-xwindowdump	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	688	SmallPop	1	\N
model/iges	MIMETYPE	195	model/iges	model/iges	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	689	SmallPop	1	\N
model/mesh	MIMETYPE	196	model/mesh	model/mesh	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	690	SmallPop	1	\N
model/vrml	MIMETYPE	197	model/vrml	model/vrml	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	691	SmallPop	1	\N
text/css	MIMETYPE	198	text/css	text/css	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	692	SmallPop	1	\N
text/html	MIMETYPE	199	text/html	text/html	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	693	SmallPop	1	\N
text/plain	MIMETYPE	200	text/plain	text/plain	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	694	SmallPop	1	\N
text/richtext	MIMETYPE	201	text/richtext	text/richtext	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	695	SmallPop	1	\N
text/rtf	MIMETYPE	202	text/rtf	text/rtf	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	696	SmallPop	1	\N
text/sgml	MIMETYPE	203	text/sgml	text/sgml	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	697	SmallPop	1	\N
text/tab-separated-values	MIMETYPE	204	text/tab-separated-values	text/tab-separated-values	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	698	SmallPop	1	\N
text/vnd.wap.wml	MIMETYPE	205	text/vnd.wap.wml	text/vnd.wap.wml	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	699	SmallPop	1	\N
text/vnd.wap.wmlscript	MIMETYPE	206	text/vnd.wap.wmlscript	text/vnd.wap.wmlscript	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	700	SmallPop	1	\N
text/x-setext	MIMETYPE	207	text/x-setext	text/x-setext	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	701	SmallPop	1	\N
text/xml	MIMETYPE	208	text/xml	text/xml	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	702	SmallPop	1	\N
video/mpeg	MIMETYPE	209	video/mpeg	video/mpeg	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	703	SmallPop	1	\N
video/quicktime	MIMETYPE	210	video/quicktime	video/quicktime	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	704	SmallPop	1	\N
video/vnd.mpegurl	MIMETYPE	211	video/vnd.mpegurl	video/vnd.mpegurl	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	705	SmallPop	1	\N
video/x-msvideo	MIMETYPE	212	video/x-msvideo	video/x-msvideo	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	706	SmallPop	1	\N
video/x-sgi-movie	MIMETYPE	213	video/x-sgi-movie	video/x-sgi-movie	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	707	SmallPop	1	\N
x-conference/x-cooltalk	MIMETYPE	214	x-conference/x-cooltalk	x-conference/x-cooltalk	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	708	SmallPop	1	\N
DNA	MATERIAL_TYPE	215	DNA	DNA	\N	2009-11-01	\N	2009-11-01 14:25:21	cong	\N	\N	709	SmallPop	1	\N
Animals	DONOR_TYPE	216	Animals	Animals	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	710	SmallPop	1	\N
Plants	DONOR_TYPE	217	Plants	Plants	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	711	SmallPop	1	\N
Sampling	PROTOCOL_TYPE	218	Sampling	Sampling	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	712	SmallPop	1	\N
DNA extraction	PROTOCOL_TYPE	219	DNA extraction	DNA extraction	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	713	SmallPop	1	\N
DNA validation	PROTOCOL_TYPE	220	DNA validation	DNA validation	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	714	SmallPop	1	\N
PCR amplification	PROTOCOL_TYPE	221	PCR amplification	PCR amplification	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	715	SmallPop	1	\N
PCR validation	PROTOCOL_TYPE	222	PCR validation	PCR validation	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	716	SmallPop	1	\N
Electrophoresis	PROTOCOL_TYPE	223	Electrophoresis	Electrophoresis	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	717	SmallPop	1	\N
CE	METHOD	224	Capillary Electrophoresis	Capillary Electrophoresis	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	718	SmallPop	1	\N
GE	METHOD	225	Gel Electrophoresis	Gel Electrophoresis	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	719	SmallPop	1	\N
S	PURPOSE	226	Sequencing	Sequencing	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	720	SmallPop	1	\N
G	PURPOSE	227	Genotyping	Genotyping	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	721	SmallPop	1	\N
Microsatellite	MARKER_TYPE	228	Microsatellite	Microsatellite	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	722	SmallPop	1	\N
Sequencing	MARKER_TYPE	229	Sequencing	Sequencing	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	723	SmallPop	1	\N
Germany	COUNTRY	230	Germany	Germany	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	724	SmallPop	1	\N
Vietnam	COUNTRY	231	Vietnam	Vietnam	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	725	SmallPop	1	\N
EN	LANGUAGE	232	EN	English	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	726	SmallPop	1	\N
DE	LANGUAGE	233	DE	German	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	727	SmallPop	1	\N
VI	LANGUAGE	234	VI	Vietnamese	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	728	SmallPop	1	\N
unknown_breed	BREED	236	unknown_breed	unknown_breed	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	730	SmallPop	1	\N
unknown_species	SPECIES	237	unknown_species	unknown_species	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	731	SmallPop	1	\N
Default	PRIMER	238	Default	Default	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	732	SmallPop	1	\N
Default	VESSEL_TYPE	239	Default	Default	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	733	SmallPop	1	\N
m	SEX	240	m	male	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	734	SmallPop	1	\N
f	SEX	241	f	female	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	735	SmallPop	1	\N
u	SEX	242	u	unknown_sex	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	736	SmallPop	1	\N
unknown_software	SOFTWARE	235	unknown_software	unknown_software	\N	2009-11-01	\N	2009-11-01 17:50:30	manager	\N	\N	729	SmallPop	3	\N
\.


--
-- Data for Name: contacts; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY contacts (db_contact, title, salutation, first_name, second_name, third_name, birth_dt, db_language, street, zip, town, db_country, label, phone, phone2, fax, email, bank_name, bank_zip, account, opening_dt, closing_dt, "comment", chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
100	\N	\N	Default	Default	\N	\N	234	\N	\N	\N	231	\N	\N	\N	\N	\N	\N	\N	\N	2009-11-01	\N	\N	\N	\N	737	2009-11-01 14:25:22	cong	SmallPop	\N	1
101	\N	\N	Default	Default	\N	\N	234	\N	\N	\N	231	\N	\N	\N	\N	\N	\N	\N	\N	2009-11-01	\N	\N	\N	\N	739	2009-11-01 14:25:22	cong	SmallPop	\N	1
\.


--
-- Data for Name: dna_extraction; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY dna_extraction (chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version, dna_id, sample_id, project_id, validation_id, dna_concentration, dna_purity, reused) FROM stdin;
\.


--
-- Data for Name: electrophoresises; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY electrophoresises (electrophoresis_id, ext_electrophoresis, project_id, db_user, db_software, product_id, protocol_id, electrophoresis_dt, db_method, purpose, "comment", chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Data for Name: event; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY event (event_id, db_event_type, db_sampler, event_dt, db_location, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
\.


--
-- Data for Name: gel_images; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY gel_images (gel_id, sample_id, lane, "valid", chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Data for Name: inspool; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY inspool (ds, record_seq, in_date, ext_unit, proc_dt, status, record, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
\.


--
-- Data for Name: inspool_err; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY inspool_err (record_seq, err_type, "action", dbtable, dbcol, err_source, short_msg, long_msg, ext_col, ext_val, mod_val, comp_val, target_col, ds, ext_unit, status, err_dt, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
\.


--
-- Data for Name: languages; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY languages (lang_id, iso_lang, lang, last_change_dt, last_change_user, creation_dt, creation_user, end_dt, end_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
1	aa	Afar	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	1	SmallPop	1	t
2	ab	Abkhazian	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	2	SmallPop	1	t
3	af	Afrikanns	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	3	SmallPop	1	t
4	am	Amharic	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	4	SmallPop	1	t
5	ar	Arabic	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	5	SmallPop	1	t
6	as	Assamese	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	6	SmallPop	1	t
7	ay	Aymara	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	7	SmallPop	1	t
8	az	Azwerbaijani	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	8	SmallPop	1	t
9	ba	Bashkir	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	9	SmallPop	1	t
10	be	Byelorussian	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	10	SmallPop	1	t
11	bg	Bulgarian	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	11	SmallPop	1	t
12	bh	Bihari	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	12	SmallPop	1	t
13	bi	Bislama	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	13	SmallPop	1	t
14	bn	Bengali	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	14	SmallPop	1	t
15	bo	Tibetan	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	15	SmallPop	1	t
16	br	Breton	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	16	SmallPop	1	t
17	ca	Catalan	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	17	SmallPop	1	t
18	co	Corsican	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	18	SmallPop	1	t
19	cs	Czech	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	19	SmallPop	1	t
20	cy	Welch	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	20	SmallPop	1	t
21	da	Danish	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	21	SmallPop	1	t
22	de	German	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	22	SmallPop	1	t
23	dz	Bhutani	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	23	SmallPop	1	t
24	el	Greek	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	24	SmallPop	1	t
25	en	English	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	25	SmallPop	1	t
26	eo	Esperanto	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	26	SmallPop	1	t
27	es	Spanish	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	27	SmallPop	1	t
28	et	Estonian	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	28	SmallPop	1	t
29	eu	Basque	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	29	SmallPop	1	t
30	fa	Persian	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	30	SmallPop	1	t
31	fi	Finnish	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	31	SmallPop	1	t
32	fj	Fiji	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	32	SmallPop	1	t
33	fo	Faeroese	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	33	SmallPop	1	t
34	fr	French	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	34	SmallPop	1	t
35	fy	Frisian	2009-11-01 14:21:43		2009-11-01 14:21:43		\N	\N	\N	\N	35	SmallPop	1	t
36	ga	Irish	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	36	SmallPop	1	t
37	gd	Scots Gaelic	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	37	SmallPop	1	t
38	gl	Galician	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	38	SmallPop	1	t
39	gn	Guarani	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	39	SmallPop	1	t
40	gu	Gujarati	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	40	SmallPop	1	t
41	ha	Hausa	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	41	SmallPop	1	t
42	he	Hebrew	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	42	SmallPop	1	t
43	hi	Hindi	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	43	SmallPop	1	t
44	hr	Croatian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	44	SmallPop	1	t
45	hu	Hungarian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	45	SmallPop	1	t
46	hy	Armenian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	46	SmallPop	1	t
47	ia	Interlingua	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	47	SmallPop	1	t
48	id	Indonesian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	48	SmallPop	1	t
49	ie	Interlingue	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	49	SmallPop	1	t
50	ik	Inupiak	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	50	SmallPop	1	t
51	in	former Indonesian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	51	SmallPop	1	t
52	is	Icelandic	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	52	SmallPop	1	t
53	it	Italian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	53	SmallPop	1	t
54	iu	Inuktitut (eskimo)	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	54	SmallPop	1	t
55	iw	former Hebrew	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	55	SmallPop	1	t
56	ja	Japanese	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	56	SmallPop	1	t
57	ji	former Yiddish	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	57	SmallPop	1	t
58	jw	Javanese	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	58	SmallPop	1	t
59	ka	Georgian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	59	SmallPop	1	t
60	kk	Kazakh	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	60	SmallPop	1	t
61	kl	Greenlandic	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	61	SmallPop	1	t
62	km	Cambodian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	62	SmallPop	1	t
63	kn	Kannada	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	63	SmallPop	1	t
64	ko	Korean	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	64	SmallPop	1	t
65	ks	Kashmiri	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	65	SmallPop	1	t
66	ku	Kurdish	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	66	SmallPop	1	t
67	ky	Kirghiz	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	67	SmallPop	1	t
68	la	Latin	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	68	SmallPop	1	t
69	ln	Lingala	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	69	SmallPop	1	t
70	lo	Laothian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	70	SmallPop	1	t
71	lt	Lithuanian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	71	SmallPop	1	t
72	lv	Latvian, Lettish	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	72	SmallPop	1	t
73	mg	Malagasy	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	73	SmallPop	1	t
74	mi	Maori	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	74	SmallPop	1	t
75	mk	Macedonian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	75	SmallPop	1	t
76	ml	Malayalam	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	76	SmallPop	1	t
77	mn	Mongolian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	77	SmallPop	1	t
78	mo	Moldavian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	78	SmallPop	1	t
79	mr	Marathi	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	79	SmallPop	1	t
80	ms	Malayalam	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	80	SmallPop	1	t
81	mt	Maltese	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	81	SmallPop	1	t
82	my	Burmese	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	82	SmallPop	1	t
83	na	Nauru	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	83	SmallPop	1	t
84	ne	Nepali	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	84	SmallPop	1	t
85	nl	Dutch	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	85	SmallPop	1	t
86	no	Norwegian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	86	SmallPop	1	t
87	oc	Occitan	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	87	SmallPop	1	t
88	om	(Afan) Oromo	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	88	SmallPop	1	t
89	or	Oriya	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	89	SmallPop	1	t
90	pa	Punjabi	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	90	SmallPop	1	t
91	pl	Polish	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	91	SmallPop	1	t
92	ps	Pashto, Pushto	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	92	SmallPop	1	t
93	pt	Portuguese	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	93	SmallPop	1	t
94	qu	Quechua	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	94	SmallPop	1	t
95	rm	Rhaeto-Romance	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	95	SmallPop	1	t
96	rn	Kirundi	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	96	SmallPop	1	t
97	ro	Romanian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	97	SmallPop	1	t
98	ru	Russian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	98	SmallPop	1	t
99	rw	Kinyarwanda	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	99	SmallPop	1	t
100	sa	Sanskrit	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	100	SmallPop	1	t
101	sd	Sindhi	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	101	SmallPop	1	t
102	sg	Sangro	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	102	SmallPop	1	t
103	sh	Serbo-Croatian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	103	SmallPop	1	t
104	si	Singhalese	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	104	SmallPop	1	t
105	sk	Slovak	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	105	SmallPop	1	t
106	sl	Slovenian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	106	SmallPop	1	t
107	sm	Samoan	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	107	SmallPop	1	t
108	sn	Shona	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	108	SmallPop	1	t
109	so	Somali	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	109	SmallPop	1	t
110	sq	Albanien	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	110	SmallPop	1	t
111	sr	Serbian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	111	SmallPop	1	t
112	ss	Siswati	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	112	SmallPop	1	t
113	st	Sesotho	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	113	SmallPop	1	t
114	su	Sudanese	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	114	SmallPop	1	t
115	sv	Swedish	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	115	SmallPop	1	t
116	sw	Swahili	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	116	SmallPop	1	t
117	ta	Tamil	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	117	SmallPop	1	t
118	te	Tegulu	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	118	SmallPop	1	t
119	tg	Tajik	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	119	SmallPop	1	t
120	th	Thai	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	120	SmallPop	1	t
121	ti	Tigrinya	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	121	SmallPop	1	t
122	tk	Turkmen	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	122	SmallPop	1	t
123	tl	Tagalog	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	123	SmallPop	1	t
124	tn	Setswana	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	124	SmallPop	1	t
125	to	Tonga	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	125	SmallPop	1	t
126	tr	Turkish	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	126	SmallPop	1	t
127	ts	Tsongo	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	127	SmallPop	1	t
128	tt	Tatar	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	128	SmallPop	1	t
129	tw	Twi	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	129	SmallPop	1	t
130	ug	Uigur	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	130	SmallPop	1	t
131	uk	Ukrainian	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	131	SmallPop	1	t
132	ur	Urdu	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	132	SmallPop	1	t
133	uz	Uzbek	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	133	SmallPop	1	t
134	vi	Vietnamese	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	134	SmallPop	1	t
135	vo	Volapuk	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	135	SmallPop	1	t
136	wo	Wolof	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	136	SmallPop	1	t
137	xh	Xhosa	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	137	SmallPop	1	t
138	yi	Yiddish	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	138	SmallPop	1	t
139	yo	Yoruba	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	139	SmallPop	1	t
140	za	Zhuang	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	140	SmallPop	1	t
141	zh	Chinese	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	141	SmallPop	1	t
142	zu	Zulu	2009-11-01 14:21:44		2009-11-01 14:21:44		\N	\N	\N	\N	142	SmallPop	1	t
\.


--
-- Data for Name: load_stat; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY load_stat (ds, job_start, job_end, status, rec_tot_no, rec_err_no, rec_ok_no, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
\.


--
-- Data for Name: locations; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY locations (db_organism, db_location, entry_dt, db_entry_action, exit_dt, db_exit_action, chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Data for Name: markers; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY markers (marker_id, marker_name, db_marker_type, db_primer1, db_primer2, "comment", chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Data for Name: microsatellites; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY microsatellites (microsatellite_id, dna_id, project_id, marker_id, allele1, allele2, "comment", chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Data for Name: new_pest; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY new_pest ("class", "key", trait, estimator, pev, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
\.


--
-- Data for Name: nodes; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY nodes (nodename, address, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
SmallPop	10.1.1.126	2009-11-01 14:21:44		\N	\N	143	SmallPop	1	\N
\.


--
-- Data for Name: organisms; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY organisms (db_organism, db_sire, db_dam, db_sex, birth_dt, birth_year, latitude, longitude, db_donor_type, db_species, db_breed, db_photo, "comment", la_rep, la_rep_dt, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch, db_hybrid) FROM stdin;
\.


--
-- Data for Name: pcr_amplification; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY pcr_amplification (amplification_id, ext_amplification, project_id, protocol_id, "comment", chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Data for Name: pcr_markers; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY pcr_markers (amplification_id, marker_id, chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Data for Name: projects; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY projects (chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version, project_id, project_name, keyword, begin_dt, finish_dt, description, "comment") FROM stdin;
\.


--
-- Data for Name: protocols; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY protocols (protocol_id, protocol_name, "comment", chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version, db_protocol_type) FROM stdin;
\.


--
-- Data for Name: sample_collection; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY sample_collection (chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version, sample_id, project_id, reused) FROM stdin;
\.


--
-- Data for Name: samples; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY samples (chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version, sample_id, ext_sample, db_organism, db_vessel_type, db_material_type, db_user, protocol_id, production_dt, storage_dt, "comment") FROM stdin;
\.


--
-- Data for Name: sequences; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY sequences (sequence_id, dna_id, project_id, marker_id, "sequence", "comment", chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Data for Name: sources; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY sources (source, tablename, "class", columnnames, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
\.


--
-- Data for Name: storage; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY "storage" (storage_id, storage_name, parent_id, "comment", chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Data for Name: storage_samples; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY storage_samples (chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version, storage_id, sample_id, no_units) FROM stdin;
\.


--
-- Data for Name: targets; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY targets (target, tablename, "class", columnnames, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
\.


--
-- Data for Name: transfer; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY transfer (db_organism, ext_organism, db_unit, id_set, opening_dt, closing_dt, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
1	unknown_sire	101	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	741	SmallPop	1	\N
2	unknown_dam	101	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	742	SmallPop	1	\N
\.


--
-- Data for Name: unit; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY unit (db_unit, ext_unit, ext_id, db_contact, db_member, opening_dt, closing_dt, last_change_dt, last_change_user, dirty, chk_lvl, guid, "owner", version, synch) FROM stdin;
100	USERS	Default	100	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	738	SmallPop	1	\N
101	ORGANISMS	ID	101	\N	2009-11-01	\N	2009-11-01 14:25:22	cong	\N	\N	740	SmallPop	1	\N
\.


--
-- Data for Name: validation; Type: TABLE DATA; Schema: apiis_admin; Owner: apiis_admin
--

COPY validation (validation_id, gel_id, protocol_id, "comment", chk_lvl, dirty, guid, last_change_dt, last_change_user, "owner", synch, version) FROM stdin;
\.


--
-- Name: idx_inspool_err_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE INDEX idx_inspool_err_1 ON inspool_err USING btree (record_seq);


--
-- Name: idx_transfer_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE INDEX idx_transfer_1 ON transfer USING btree (db_organism);


--
-- Name: idx_transfer_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE INDEX idx_transfer_2 ON transfer USING btree (ext_organism, db_unit);


--
-- Name: uidx_amplified_samples_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_amplified_samples_rowid ON amplified_samples USING btree (guid);


--
-- Name: uidx_analyzed_samples_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_analyzed_samples_rowid ON analyzed_samples USING btree (guid);


--
-- Name: uidx_ar_constraints_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_constraints_1 ON ar_constraints USING btree (cons_id);


--
-- Name: uidx_ar_constraints_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_constraints_2 ON ar_constraints USING btree (cons_name, cons_type);


--
-- Name: uidx_ar_constraints_3; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_constraints_3 ON ar_constraints USING btree (guid);


--
-- Name: uidx_ar_constraints_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_constraints_rowid ON ar_constraints USING btree (guid);


--
-- Name: uidx_ar_dbtdescriptors_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbtdescriptors_1 ON ar_dbtdescriptors USING btree (descriptor_id);


--
-- Name: uidx_ar_dbtdescriptors_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbtdescriptors_2 ON ar_dbtdescriptors USING btree (descriptor_name, descriptor_value);


--
-- Name: uidx_ar_dbtdescriptors_3; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbtdescriptors_3 ON ar_dbtdescriptors USING btree (guid);


--
-- Name: uidx_ar_dbtdescriptors_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbtdescriptors_rowid ON ar_dbtdescriptors USING btree (guid);


--
-- Name: uidx_ar_dbtpolicies_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbtpolicies_1 ON ar_dbtpolicies USING btree (dbtpolicy_id);


--
-- Name: uidx_ar_dbtpolicies_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbtpolicies_2 ON ar_dbtpolicies USING btree (action_id, table_id, descriptor_id);


--
-- Name: uidx_ar_dbtpolicies_3; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbtpolicies_3 ON ar_dbtpolicies USING btree (guid);


--
-- Name: uidx_ar_dbtpolicies_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbtpolicies_rowid ON ar_dbtpolicies USING btree (guid);


--
-- Name: uidx_ar_dbttables_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbttables_1 ON ar_dbttables USING btree (table_id);


--
-- Name: uidx_ar_dbttables_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbttables_2 ON ar_dbttables USING btree (table_name, table_columns);


--
-- Name: uidx_ar_dbttables_3; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbttables_3 ON ar_dbttables USING btree (guid);


--
-- Name: uidx_ar_dbttables_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_dbttables_rowid ON ar_dbttables USING btree (guid);


--
-- Name: uidx_ar_role_constraints_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_role_constraints_1 ON ar_role_constraints USING btree (cons_id, first_role_id, second_role_id);


--
-- Name: uidx_ar_role_constraints_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_role_constraints_2 ON ar_role_constraints USING btree (guid);


--
-- Name: uidx_ar_role_constraints_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_role_constraints_rowid ON ar_role_constraints USING btree (guid);


--
-- Name: uidx_ar_role_dbtpolicies_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_role_dbtpolicies_1 ON ar_role_dbtpolicies USING btree (role_id, dbtpolicy_id);


--
-- Name: uidx_ar_role_dbtpolicies_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_role_dbtpolicies_2 ON ar_role_dbtpolicies USING btree (guid);


--
-- Name: uidx_ar_role_dbtpolicies_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_role_dbtpolicies_rowid ON ar_role_dbtpolicies USING btree (guid);


--
-- Name: uidx_ar_role_stpolicies_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_role_stpolicies_1 ON ar_role_stpolicies USING btree (role_id, stpolicy_id);


--
-- Name: uidx_ar_role_stpolicies_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_role_stpolicies_2 ON ar_role_stpolicies USING btree (guid);


--
-- Name: uidx_ar_role_stpolicies_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_role_stpolicies_rowid ON ar_role_stpolicies USING btree (guid);


--
-- Name: uidx_ar_roles_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_roles_1 ON ar_roles USING btree (role_id);


--
-- Name: uidx_ar_roles_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_roles_2 ON ar_roles USING btree (role_name, role_type);


--
-- Name: uidx_ar_roles_3; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_roles_3 ON ar_roles USING btree (guid);


--
-- Name: uidx_ar_roles_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_roles_rowid ON ar_roles USING btree (guid);


--
-- Name: uidx_ar_stpolicies_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_stpolicies_1 ON ar_stpolicies USING btree (stpolicy_id);


--
-- Name: uidx_ar_stpolicies_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_stpolicies_2 ON ar_stpolicies USING btree (stpolicy_name, stpolicy_type);


--
-- Name: uidx_ar_stpolicies_3; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_stpolicies_3 ON ar_stpolicies USING btree (guid);


--
-- Name: uidx_ar_stpolicies_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_stpolicies_rowid ON ar_stpolicies USING btree (guid);


--
-- Name: uidx_ar_user_roles_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_user_roles_1 ON ar_user_roles USING btree (user_id, role_id);


--
-- Name: uidx_ar_user_roles_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_user_roles_2 ON ar_user_roles USING btree (guid);


--
-- Name: uidx_ar_user_roles_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_user_roles_rowid ON ar_user_roles USING btree (guid);


--
-- Name: uidx_ar_users_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_users_1 ON ar_users USING btree (user_id);


--
-- Name: uidx_ar_users_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_users_2 ON ar_users USING btree (user_login);


--
-- Name: uidx_ar_users_3; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_users_3 ON ar_users USING btree (guid);


--
-- Name: uidx_ar_users_data_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_users_data_1 ON ar_users_data USING btree (user_id);


--
-- Name: uidx_ar_users_data_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_users_data_2 ON ar_users_data USING btree (guid);


--
-- Name: uidx_ar_users_data_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_users_data_rowid ON ar_users_data USING btree (guid);


--
-- Name: uidx_ar_users_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_ar_users_rowid ON ar_users USING btree (guid);


--
-- Name: uidx_blobs_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_blobs_rowid ON blobs USING btree (guid);


--
-- Name: uidx_codes_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_codes_1 ON codes USING btree (db_code);


--
-- Name: uidx_codes_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_codes_2 ON codes USING btree ("class", ext_code, closing_dt);


--
-- Name: uidx_codes_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_codes_rowid ON codes USING btree (guid);


--
-- Name: uidx_contacts_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_contacts_1 ON contacts USING btree (db_contact);


--
-- Name: uidx_contacts_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_contacts_rowid ON contacts USING btree (guid);


--
-- Name: uidx_dna_extraction_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_dna_extraction_rowid ON dna_extraction USING btree (guid);


--
-- Name: uidx_electrophoresises_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_electrophoresises_rowid ON electrophoresises USING btree (guid);


--
-- Name: uidx_event_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_event_1 ON event USING btree (event_id, db_event_type, db_location, event_dt);


--
-- Name: uidx_event_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_event_rowid ON event USING btree (guid);


--
-- Name: uidx_gel_images_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_gel_images_rowid ON gel_images USING btree (guid);


--
-- Name: uidx_inspool_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_inspool_1 ON inspool USING btree (record_seq);


--
-- Name: uidx_inspool_err_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_inspool_err_rowid ON inspool_err USING btree (guid);


--
-- Name: uidx_inspool_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_inspool_rowid ON inspool USING btree (guid);


--
-- Name: uidx_languages_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_languages_1 ON languages USING btree (lang_id);


--
-- Name: uidx_languages_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_languages_2 ON languages USING btree (iso_lang);


--
-- Name: uidx_languages_3; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_languages_3 ON languages USING btree (guid);


--
-- Name: uidx_languages_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_languages_rowid ON languages USING btree (guid);


--
-- Name: uidx_load_stat_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_load_stat_rowid ON load_stat USING btree (guid);


--
-- Name: uidx_locations_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_locations_rowid ON locations USING btree (guid);


--
-- Name: uidx_markers_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_markers_1 ON markers USING btree (marker_id);


--
-- Name: uidx_markers_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_markers_2 ON markers USING btree (marker_name);


--
-- Name: uidx_markers_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_markers_rowid ON markers USING btree (guid);


--
-- Name: uidx_microsatellites_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_microsatellites_rowid ON microsatellites USING btree (guid);


--
-- Name: uidx_new_pest_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_new_pest_1 ON new_pest USING btree ("class", "key", trait);


--
-- Name: uidx_new_pest_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_new_pest_rowid ON new_pest USING btree (guid);


--
-- Name: uidx_nodes_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_nodes_1 ON nodes USING btree (guid);


--
-- Name: uidx_nodes_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_nodes_rowid ON nodes USING btree (guid);


--
-- Name: uidx_organisms_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_organisms_1 ON organisms USING btree (db_organism);


--
-- Name: uidx_organisms_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_organisms_rowid ON organisms USING btree (guid);


--
-- Name: uidx_pcr_amplification_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_pcr_amplification_1 ON pcr_amplification USING btree (amplification_id);


--
-- Name: uidx_pcr_amplification_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_pcr_amplification_2 ON pcr_amplification USING btree (ext_amplification);


--
-- Name: uidx_pcr_amplification_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_pcr_amplification_rowid ON pcr_amplification USING btree (guid);


--
-- Name: uidx_pcr_markers_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_pcr_markers_rowid ON pcr_markers USING btree (guid);


--
-- Name: uidx_pk_codes; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_pk_codes ON codes USING btree ("class", ext_code) WHERE (closing_dt IS NULL);


--
-- Name: uidx_pk_transfer; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_pk_transfer ON transfer USING btree (db_unit, ext_organism) WHERE (closing_dt IS NULL);


--
-- Name: uidx_pk_unit; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_pk_unit ON unit USING btree (ext_unit, ext_id) WHERE (closing_dt IS NULL);


--
-- Name: uidx_projects_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_projects_1 ON projects USING btree (project_id);


--
-- Name: uidx_projects_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_projects_2 ON projects USING btree (project_name);


--
-- Name: uidx_projects_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_projects_rowid ON projects USING btree (guid);


--
-- Name: uidx_protocols_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_protocols_rowid ON protocols USING btree (guid);


--
-- Name: uidx_sample_collection_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_sample_collection_rowid ON sample_collection USING btree (guid);


--
-- Name: uidx_samples_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_samples_1 ON samples USING btree (sample_id);


--
-- Name: uidx_samples_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_samples_2 ON samples USING btree (ext_sample);


--
-- Name: uidx_samples_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_samples_rowid ON samples USING btree (guid);


--
-- Name: uidx_sequences_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_sequences_rowid ON sequences USING btree (guid);


--
-- Name: uidx_sources_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_sources_1 ON sources USING btree (guid);


--
-- Name: uidx_sources_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_sources_rowid ON sources USING btree (guid);


--
-- Name: uidx_storage_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_storage_1 ON "storage" USING btree (storage_id);


--
-- Name: uidx_storage_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_storage_rowid ON "storage" USING btree (guid);


--
-- Name: uidx_storage_samples_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_storage_samples_rowid ON storage_samples USING btree (guid);


--
-- Name: uidx_targets_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_targets_1 ON targets USING btree (guid);


--
-- Name: uidx_targets_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_targets_rowid ON targets USING btree (guid);


--
-- Name: uidx_transfer_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_transfer_rowid ON transfer USING btree (guid);


--
-- Name: uidx_unit_1; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_unit_1 ON unit USING btree (db_unit);


--
-- Name: uidx_unit_2; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_unit_2 ON unit USING btree (ext_unit, ext_id, closing_dt);


--
-- Name: uidx_unit_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_unit_rowid ON unit USING btree (guid);


--
-- Name: uidx_validation_rowid; Type: INDEX; Schema: apiis_admin; Owner: apiis_admin; Tablespace: 
--

CREATE UNIQUE INDEX uidx_validation_rowid ON validation USING btree (guid);


--
-- Name: admin; Type: ACL; Schema: -; Owner: apiis_admin
--

REVOKE ALL ON SCHEMA "admin" FROM PUBLIC;
REVOKE ALL ON SCHEMA "admin" FROM apiis_admin;
GRANT ALL ON SCHEMA "admin" TO apiis_admin;
GRANT ALL ON SCHEMA "admin" TO "admin";


--
-- Name: cong; Type: ACL; Schema: -; Owner: apiis_admin
--

REVOKE ALL ON SCHEMA cong FROM PUBLIC;
REVOKE ALL ON SCHEMA cong FROM apiis_admin;
GRANT ALL ON SCHEMA cong TO apiis_admin;
GRANT ALL ON SCHEMA cong TO cong;


--
-- Name: manager; Type: ACL; Schema: -; Owner: apiis_admin
--

REVOKE ALL ON SCHEMA manager FROM PUBLIC;
REVOKE ALL ON SCHEMA manager FROM apiis_admin;
GRANT ALL ON SCHEMA manager TO apiis_admin;
GRANT ALL ON SCHEMA manager TO manager;


--
-- Name: molabis; Type: ACL; Schema: -; Owner: apiis_admin
--

REVOKE ALL ON SCHEMA molabis FROM PUBLIC;
REVOKE ALL ON SCHEMA molabis FROM apiis_admin;
GRANT ALL ON SCHEMA molabis TO apiis_admin;
GRANT ALL ON SCHEMA molabis TO molabis;


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- Name: scientist; Type: ACL; Schema: -; Owner: apiis_admin
--

REVOKE ALL ON SCHEMA scientist FROM PUBLIC;
REVOKE ALL ON SCHEMA scientist FROM apiis_admin;
GRANT ALL ON SCHEMA scientist TO apiis_admin;
GRANT ALL ON SCHEMA scientist TO scientist;


--
-- Name: staff; Type: ACL; Schema: -; Owner: apiis_admin
--

REVOKE ALL ON SCHEMA staff FROM PUBLIC;
REVOKE ALL ON SCHEMA staff FROM apiis_admin;
GRANT ALL ON SCHEMA staff TO apiis_admin;
GRANT ALL ON SCHEMA staff TO staff;


--
-- Name: super_staff; Type: ACL; Schema: -; Owner: apiis_admin
--

REVOKE ALL ON SCHEMA super_staff FROM PUBLIC;
REVOKE ALL ON SCHEMA super_staff FROM apiis_admin;
GRANT ALL ON SCHEMA super_staff TO apiis_admin;
GRANT ALL ON SCHEMA super_staff TO super_staff;


--
-- Name: visitor; Type: ACL; Schema: -; Owner: apiis_admin
--

REVOKE ALL ON SCHEMA visitor FROM PUBLIC;
REVOKE ALL ON SCHEMA visitor FROM apiis_admin;
GRANT ALL ON SCHEMA visitor TO apiis_admin;
GRANT ALL ON SCHEMA visitor TO visitor;


SET search_path = "admin", pg_catalog;

--
-- Name: amplified_samples; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE amplified_samples FROM PUBLIC;
REVOKE ALL ON TABLE amplified_samples FROM apiis_admin;
GRANT ALL ON TABLE amplified_samples TO apiis_admin;
GRANT SELECT ON TABLE amplified_samples TO "admin";


--
-- Name: analyzed_samples; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE analyzed_samples FROM PUBLIC;
REVOKE ALL ON TABLE analyzed_samples FROM apiis_admin;
GRANT ALL ON TABLE analyzed_samples TO apiis_admin;
GRANT SELECT ON TABLE analyzed_samples TO "admin";


--
-- Name: ar_constraints; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_constraints FROM PUBLIC;
REVOKE ALL ON TABLE ar_constraints FROM apiis_admin;
GRANT ALL ON TABLE ar_constraints TO apiis_admin;
GRANT SELECT ON TABLE ar_constraints TO "admin";


--
-- Name: ar_dbtdescriptors; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_dbtdescriptors FROM PUBLIC;
REVOKE ALL ON TABLE ar_dbtdescriptors FROM apiis_admin;
GRANT ALL ON TABLE ar_dbtdescriptors TO apiis_admin;
GRANT SELECT ON TABLE ar_dbtdescriptors TO "admin";


--
-- Name: ar_dbtpolicies; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_dbtpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_dbtpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_dbtpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_dbtpolicies TO "admin";


--
-- Name: ar_dbttables; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_dbttables FROM PUBLIC;
REVOKE ALL ON TABLE ar_dbttables FROM apiis_admin;
GRANT ALL ON TABLE ar_dbttables TO apiis_admin;
GRANT SELECT ON TABLE ar_dbttables TO "admin";


--
-- Name: ar_role_constraints; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_role_constraints FROM PUBLIC;
REVOKE ALL ON TABLE ar_role_constraints FROM apiis_admin;
GRANT ALL ON TABLE ar_role_constraints TO apiis_admin;
GRANT SELECT ON TABLE ar_role_constraints TO "admin";


--
-- Name: ar_role_dbtpolicies; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_role_dbtpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_role_dbtpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_role_dbtpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_role_dbtpolicies TO "admin";


--
-- Name: ar_role_stpolicies; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_role_stpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_role_stpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_role_stpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_role_stpolicies TO "admin";


--
-- Name: ar_roles; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_roles FROM PUBLIC;
REVOKE ALL ON TABLE ar_roles FROM apiis_admin;
GRANT ALL ON TABLE ar_roles TO apiis_admin;
GRANT SELECT ON TABLE ar_roles TO "admin";


--
-- Name: ar_stpolicies; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_stpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_stpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_stpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_stpolicies TO "admin";


--
-- Name: ar_user_roles; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_user_roles FROM PUBLIC;
REVOKE ALL ON TABLE ar_user_roles FROM apiis_admin;
GRANT ALL ON TABLE ar_user_roles TO apiis_admin;
GRANT SELECT ON TABLE ar_user_roles TO "admin";


--
-- Name: ar_users; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_users FROM PUBLIC;
REVOKE ALL ON TABLE ar_users FROM apiis_admin;
GRANT ALL ON TABLE ar_users TO apiis_admin;
GRANT SELECT ON TABLE ar_users TO "admin";


--
-- Name: ar_users_data; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_users_data FROM PUBLIC;
REVOKE ALL ON TABLE ar_users_data FROM apiis_admin;
GRANT ALL ON TABLE ar_users_data TO apiis_admin;
GRANT SELECT ON TABLE ar_users_data TO "admin";


--
-- Name: blobs; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE blobs FROM PUBLIC;
REVOKE ALL ON TABLE blobs FROM apiis_admin;
GRANT ALL ON TABLE blobs TO apiis_admin;
GRANT SELECT ON TABLE blobs TO "admin";


--
-- Name: codes; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE codes FROM PUBLIC;
REVOKE ALL ON TABLE codes FROM apiis_admin;
GRANT ALL ON TABLE codes TO apiis_admin;
GRANT SELECT ON TABLE codes TO "admin";


--
-- Name: contacts; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE contacts FROM PUBLIC;
REVOKE ALL ON TABLE contacts FROM apiis_admin;
GRANT ALL ON TABLE contacts TO apiis_admin;
GRANT SELECT ON TABLE contacts TO "admin";


--
-- Name: dna_extraction; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE dna_extraction FROM PUBLIC;
REVOKE ALL ON TABLE dna_extraction FROM apiis_admin;
GRANT ALL ON TABLE dna_extraction TO apiis_admin;
GRANT SELECT ON TABLE dna_extraction TO "admin";


--
-- Name: electrophoresises; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE electrophoresises FROM PUBLIC;
REVOKE ALL ON TABLE electrophoresises FROM apiis_admin;
GRANT ALL ON TABLE electrophoresises TO apiis_admin;
GRANT SELECT ON TABLE electrophoresises TO "admin";


--
-- Name: event; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE event FROM PUBLIC;
REVOKE ALL ON TABLE event FROM apiis_admin;
GRANT ALL ON TABLE event TO apiis_admin;
GRANT SELECT ON TABLE event TO "admin";


--
-- Name: gel_images; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE gel_images FROM PUBLIC;
REVOKE ALL ON TABLE gel_images FROM apiis_admin;
GRANT ALL ON TABLE gel_images TO apiis_admin;
GRANT SELECT ON TABLE gel_images TO "admin";


--
-- Name: inspool; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE inspool FROM PUBLIC;
REVOKE ALL ON TABLE inspool FROM apiis_admin;
GRANT ALL ON TABLE inspool TO apiis_admin;
GRANT SELECT ON TABLE inspool TO "admin";


--
-- Name: inspool_err; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE inspool_err FROM PUBLIC;
REVOKE ALL ON TABLE inspool_err FROM apiis_admin;
GRANT ALL ON TABLE inspool_err TO apiis_admin;
GRANT SELECT ON TABLE inspool_err TO "admin";


--
-- Name: languages; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE languages FROM PUBLIC;
REVOKE ALL ON TABLE languages FROM apiis_admin;
GRANT ALL ON TABLE languages TO apiis_admin;
GRANT SELECT ON TABLE languages TO "admin";


--
-- Name: load_stat; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE load_stat FROM PUBLIC;
REVOKE ALL ON TABLE load_stat FROM apiis_admin;
GRANT ALL ON TABLE load_stat TO apiis_admin;
GRANT SELECT ON TABLE load_stat TO "admin";


--
-- Name: locations; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE locations FROM PUBLIC;
REVOKE ALL ON TABLE locations FROM apiis_admin;
GRANT ALL ON TABLE locations TO apiis_admin;
GRANT SELECT ON TABLE locations TO "admin";


--
-- Name: markers; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE markers FROM PUBLIC;
REVOKE ALL ON TABLE markers FROM apiis_admin;
GRANT ALL ON TABLE markers TO apiis_admin;
GRANT SELECT ON TABLE markers TO "admin";


--
-- Name: microsatellites; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE microsatellites FROM PUBLIC;
REVOKE ALL ON TABLE microsatellites FROM apiis_admin;
GRANT ALL ON TABLE microsatellites TO apiis_admin;
GRANT SELECT ON TABLE microsatellites TO "admin";


--
-- Name: new_pest; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE new_pest FROM PUBLIC;
REVOKE ALL ON TABLE new_pest FROM apiis_admin;
GRANT ALL ON TABLE new_pest TO apiis_admin;
GRANT SELECT ON TABLE new_pest TO "admin";


--
-- Name: nodes; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE nodes FROM PUBLIC;
REVOKE ALL ON TABLE nodes FROM apiis_admin;
GRANT ALL ON TABLE nodes TO apiis_admin;
GRANT SELECT ON TABLE nodes TO "admin";


--
-- Name: organisms; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE organisms FROM PUBLIC;
REVOKE ALL ON TABLE organisms FROM apiis_admin;
GRANT ALL ON TABLE organisms TO apiis_admin;
GRANT SELECT ON TABLE organisms TO "admin";


--
-- Name: pcr_amplification; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_amplification FROM PUBLIC;
REVOKE ALL ON TABLE pcr_amplification FROM apiis_admin;
GRANT ALL ON TABLE pcr_amplification TO apiis_admin;
GRANT SELECT ON TABLE pcr_amplification TO "admin";


--
-- Name: pcr_markers; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_markers FROM PUBLIC;
REVOKE ALL ON TABLE pcr_markers FROM apiis_admin;
GRANT ALL ON TABLE pcr_markers TO apiis_admin;
GRANT SELECT ON TABLE pcr_markers TO "admin";


--
-- Name: projects; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE projects FROM PUBLIC;
REVOKE ALL ON TABLE projects FROM apiis_admin;
GRANT ALL ON TABLE projects TO apiis_admin;
GRANT SELECT ON TABLE projects TO "admin";


--
-- Name: protocols; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE protocols FROM PUBLIC;
REVOKE ALL ON TABLE protocols FROM apiis_admin;
GRANT ALL ON TABLE protocols TO apiis_admin;
GRANT SELECT ON TABLE protocols TO "admin";


--
-- Name: sample_collection; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE sample_collection FROM PUBLIC;
REVOKE ALL ON TABLE sample_collection FROM apiis_admin;
GRANT ALL ON TABLE sample_collection TO apiis_admin;
GRANT SELECT ON TABLE sample_collection TO "admin";


--
-- Name: samples; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE samples FROM PUBLIC;
REVOKE ALL ON TABLE samples FROM apiis_admin;
GRANT ALL ON TABLE samples TO apiis_admin;
GRANT SELECT ON TABLE samples TO "admin";


--
-- Name: sequences; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE sequences FROM PUBLIC;
REVOKE ALL ON TABLE sequences FROM apiis_admin;
GRANT ALL ON TABLE sequences TO apiis_admin;
GRANT SELECT ON TABLE sequences TO "admin";


--
-- Name: sources; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE sources FROM PUBLIC;
REVOKE ALL ON TABLE sources FROM apiis_admin;
GRANT ALL ON TABLE sources TO apiis_admin;
GRANT SELECT ON TABLE sources TO "admin";


--
-- Name: storage; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE "storage" FROM PUBLIC;
REVOKE ALL ON TABLE "storage" FROM apiis_admin;
GRANT ALL ON TABLE "storage" TO apiis_admin;
GRANT SELECT ON TABLE "storage" TO "admin";


--
-- Name: storage_samples; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE storage_samples FROM PUBLIC;
REVOKE ALL ON TABLE storage_samples FROM apiis_admin;
GRANT ALL ON TABLE storage_samples TO apiis_admin;
GRANT SELECT ON TABLE storage_samples TO "admin";


--
-- Name: targets; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE targets FROM PUBLIC;
REVOKE ALL ON TABLE targets FROM apiis_admin;
GRANT ALL ON TABLE targets TO apiis_admin;
GRANT SELECT ON TABLE targets TO "admin";


--
-- Name: transfer; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE transfer FROM PUBLIC;
REVOKE ALL ON TABLE transfer FROM apiis_admin;
GRANT ALL ON TABLE transfer TO apiis_admin;
GRANT SELECT ON TABLE transfer TO "admin";


--
-- Name: unit; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE unit FROM PUBLIC;
REVOKE ALL ON TABLE unit FROM apiis_admin;
GRANT ALL ON TABLE unit TO apiis_admin;
GRANT SELECT ON TABLE unit TO "admin";


--
-- Name: validation; Type: ACL; Schema: admin; Owner: apiis_admin
--

REVOKE ALL ON TABLE validation FROM PUBLIC;
REVOKE ALL ON TABLE validation FROM apiis_admin;
GRANT ALL ON TABLE validation TO apiis_admin;
GRANT SELECT ON TABLE validation TO "admin";


SET search_path = cong, pg_catalog;

--
-- Name: amplified_samples; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE amplified_samples FROM PUBLIC;
REVOKE ALL ON TABLE amplified_samples FROM apiis_admin;
GRANT ALL ON TABLE amplified_samples TO apiis_admin;
GRANT SELECT ON TABLE amplified_samples TO cong;


--
-- Name: analyzed_samples; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE analyzed_samples FROM PUBLIC;
REVOKE ALL ON TABLE analyzed_samples FROM apiis_admin;
GRANT ALL ON TABLE analyzed_samples TO apiis_admin;
GRANT SELECT ON TABLE analyzed_samples TO cong;


--
-- Name: ar_constraints; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_constraints FROM PUBLIC;
REVOKE ALL ON TABLE ar_constraints FROM apiis_admin;
GRANT ALL ON TABLE ar_constraints TO apiis_admin;
GRANT SELECT ON TABLE ar_constraints TO cong;


--
-- Name: ar_dbtdescriptors; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_dbtdescriptors FROM PUBLIC;
REVOKE ALL ON TABLE ar_dbtdescriptors FROM apiis_admin;
GRANT ALL ON TABLE ar_dbtdescriptors TO apiis_admin;
GRANT SELECT ON TABLE ar_dbtdescriptors TO cong;


--
-- Name: ar_dbtpolicies; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_dbtpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_dbtpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_dbtpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_dbtpolicies TO cong;


--
-- Name: ar_dbttables; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_dbttables FROM PUBLIC;
REVOKE ALL ON TABLE ar_dbttables FROM apiis_admin;
GRANT ALL ON TABLE ar_dbttables TO apiis_admin;
GRANT SELECT ON TABLE ar_dbttables TO cong;


--
-- Name: ar_role_constraints; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_role_constraints FROM PUBLIC;
REVOKE ALL ON TABLE ar_role_constraints FROM apiis_admin;
GRANT ALL ON TABLE ar_role_constraints TO apiis_admin;
GRANT SELECT ON TABLE ar_role_constraints TO cong;


--
-- Name: ar_role_dbtpolicies; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_role_dbtpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_role_dbtpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_role_dbtpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_role_dbtpolicies TO cong;


--
-- Name: ar_role_stpolicies; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_role_stpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_role_stpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_role_stpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_role_stpolicies TO cong;


--
-- Name: ar_roles; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_roles FROM PUBLIC;
REVOKE ALL ON TABLE ar_roles FROM apiis_admin;
GRANT ALL ON TABLE ar_roles TO apiis_admin;
GRANT SELECT ON TABLE ar_roles TO cong;


--
-- Name: ar_stpolicies; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_stpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_stpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_stpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_stpolicies TO cong;


--
-- Name: ar_user_roles; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_user_roles FROM PUBLIC;
REVOKE ALL ON TABLE ar_user_roles FROM apiis_admin;
GRANT ALL ON TABLE ar_user_roles TO apiis_admin;
GRANT SELECT ON TABLE ar_user_roles TO cong;


--
-- Name: ar_users; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_users FROM PUBLIC;
REVOKE ALL ON TABLE ar_users FROM apiis_admin;
GRANT ALL ON TABLE ar_users TO apiis_admin;
GRANT SELECT ON TABLE ar_users TO cong;


--
-- Name: ar_users_data; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_users_data FROM PUBLIC;
REVOKE ALL ON TABLE ar_users_data FROM apiis_admin;
GRANT ALL ON TABLE ar_users_data TO apiis_admin;
GRANT SELECT ON TABLE ar_users_data TO cong;


--
-- Name: blobs; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE blobs FROM PUBLIC;
REVOKE ALL ON TABLE blobs FROM apiis_admin;
GRANT ALL ON TABLE blobs TO apiis_admin;
GRANT SELECT ON TABLE blobs TO cong;


--
-- Name: codes; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE codes FROM PUBLIC;
REVOKE ALL ON TABLE codes FROM apiis_admin;
GRANT ALL ON TABLE codes TO apiis_admin;
GRANT SELECT ON TABLE codes TO cong;


--
-- Name: contacts; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE contacts FROM PUBLIC;
REVOKE ALL ON TABLE contacts FROM apiis_admin;
GRANT ALL ON TABLE contacts TO apiis_admin;
GRANT SELECT ON TABLE contacts TO cong;


--
-- Name: dna_extraction; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE dna_extraction FROM PUBLIC;
REVOKE ALL ON TABLE dna_extraction FROM apiis_admin;
GRANT ALL ON TABLE dna_extraction TO apiis_admin;
GRANT SELECT ON TABLE dna_extraction TO cong;


--
-- Name: electrophoresises; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE electrophoresises FROM PUBLIC;
REVOKE ALL ON TABLE electrophoresises FROM apiis_admin;
GRANT ALL ON TABLE electrophoresises TO apiis_admin;
GRANT SELECT ON TABLE electrophoresises TO cong;


--
-- Name: event; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE event FROM PUBLIC;
REVOKE ALL ON TABLE event FROM apiis_admin;
GRANT ALL ON TABLE event TO apiis_admin;
GRANT SELECT ON TABLE event TO cong;


--
-- Name: gel_images; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE gel_images FROM PUBLIC;
REVOKE ALL ON TABLE gel_images FROM apiis_admin;
GRANT ALL ON TABLE gel_images TO apiis_admin;
GRANT SELECT ON TABLE gel_images TO cong;


--
-- Name: inspool; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE inspool FROM PUBLIC;
REVOKE ALL ON TABLE inspool FROM apiis_admin;
GRANT ALL ON TABLE inspool TO apiis_admin;
GRANT SELECT ON TABLE inspool TO cong;


--
-- Name: inspool_err; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE inspool_err FROM PUBLIC;
REVOKE ALL ON TABLE inspool_err FROM apiis_admin;
GRANT ALL ON TABLE inspool_err TO apiis_admin;
GRANT SELECT ON TABLE inspool_err TO cong;


--
-- Name: languages; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE languages FROM PUBLIC;
REVOKE ALL ON TABLE languages FROM apiis_admin;
GRANT ALL ON TABLE languages TO apiis_admin;
GRANT SELECT ON TABLE languages TO cong;


--
-- Name: load_stat; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE load_stat FROM PUBLIC;
REVOKE ALL ON TABLE load_stat FROM apiis_admin;
GRANT ALL ON TABLE load_stat TO apiis_admin;
GRANT SELECT ON TABLE load_stat TO cong;


--
-- Name: locations; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE locations FROM PUBLIC;
REVOKE ALL ON TABLE locations FROM apiis_admin;
GRANT ALL ON TABLE locations TO apiis_admin;
GRANT SELECT ON TABLE locations TO cong;


--
-- Name: markers; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE markers FROM PUBLIC;
REVOKE ALL ON TABLE markers FROM apiis_admin;
GRANT ALL ON TABLE markers TO apiis_admin;
GRANT SELECT ON TABLE markers TO cong;


--
-- Name: microsatellites; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE microsatellites FROM PUBLIC;
REVOKE ALL ON TABLE microsatellites FROM apiis_admin;
GRANT ALL ON TABLE microsatellites TO apiis_admin;
GRANT SELECT ON TABLE microsatellites TO cong;


--
-- Name: new_pest; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE new_pest FROM PUBLIC;
REVOKE ALL ON TABLE new_pest FROM apiis_admin;
GRANT ALL ON TABLE new_pest TO apiis_admin;
GRANT SELECT ON TABLE new_pest TO cong;


--
-- Name: nodes; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE nodes FROM PUBLIC;
REVOKE ALL ON TABLE nodes FROM apiis_admin;
GRANT ALL ON TABLE nodes TO apiis_admin;
GRANT SELECT ON TABLE nodes TO cong;


--
-- Name: organisms; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE organisms FROM PUBLIC;
REVOKE ALL ON TABLE organisms FROM apiis_admin;
GRANT ALL ON TABLE organisms TO apiis_admin;
GRANT SELECT ON TABLE organisms TO cong;


--
-- Name: pcr_amplification; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_amplification FROM PUBLIC;
REVOKE ALL ON TABLE pcr_amplification FROM apiis_admin;
GRANT ALL ON TABLE pcr_amplification TO apiis_admin;
GRANT SELECT ON TABLE pcr_amplification TO cong;


--
-- Name: pcr_markers; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_markers FROM PUBLIC;
REVOKE ALL ON TABLE pcr_markers FROM apiis_admin;
GRANT ALL ON TABLE pcr_markers TO apiis_admin;
GRANT SELECT ON TABLE pcr_markers TO cong;


--
-- Name: projects; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE projects FROM PUBLIC;
REVOKE ALL ON TABLE projects FROM apiis_admin;
GRANT ALL ON TABLE projects TO apiis_admin;
GRANT SELECT ON TABLE projects TO cong;


--
-- Name: protocols; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE protocols FROM PUBLIC;
REVOKE ALL ON TABLE protocols FROM apiis_admin;
GRANT ALL ON TABLE protocols TO apiis_admin;
GRANT SELECT ON TABLE protocols TO cong;


--
-- Name: sample_collection; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE sample_collection FROM PUBLIC;
REVOKE ALL ON TABLE sample_collection FROM apiis_admin;
GRANT ALL ON TABLE sample_collection TO apiis_admin;
GRANT SELECT ON TABLE sample_collection TO cong;


--
-- Name: samples; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE samples FROM PUBLIC;
REVOKE ALL ON TABLE samples FROM apiis_admin;
GRANT ALL ON TABLE samples TO apiis_admin;
GRANT SELECT ON TABLE samples TO cong;


--
-- Name: sequences; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE sequences FROM PUBLIC;
REVOKE ALL ON TABLE sequences FROM apiis_admin;
GRANT ALL ON TABLE sequences TO apiis_admin;
GRANT SELECT ON TABLE sequences TO cong;


--
-- Name: sources; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE sources FROM PUBLIC;
REVOKE ALL ON TABLE sources FROM apiis_admin;
GRANT ALL ON TABLE sources TO apiis_admin;
GRANT SELECT ON TABLE sources TO cong;


--
-- Name: storage; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE "storage" FROM PUBLIC;
REVOKE ALL ON TABLE "storage" FROM apiis_admin;
GRANT ALL ON TABLE "storage" TO apiis_admin;
GRANT SELECT ON TABLE "storage" TO cong;


--
-- Name: storage_samples; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE storage_samples FROM PUBLIC;
REVOKE ALL ON TABLE storage_samples FROM apiis_admin;
GRANT ALL ON TABLE storage_samples TO apiis_admin;
GRANT SELECT ON TABLE storage_samples TO cong;


--
-- Name: targets; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE targets FROM PUBLIC;
REVOKE ALL ON TABLE targets FROM apiis_admin;
GRANT ALL ON TABLE targets TO apiis_admin;
GRANT SELECT ON TABLE targets TO cong;


--
-- Name: transfer; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE transfer FROM PUBLIC;
REVOKE ALL ON TABLE transfer FROM apiis_admin;
GRANT ALL ON TABLE transfer TO apiis_admin;
GRANT SELECT ON TABLE transfer TO cong;


--
-- Name: unit; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE unit FROM PUBLIC;
REVOKE ALL ON TABLE unit FROM apiis_admin;
GRANT ALL ON TABLE unit TO apiis_admin;
GRANT SELECT ON TABLE unit TO cong;


--
-- Name: validation; Type: ACL; Schema: cong; Owner: apiis_admin
--

REVOKE ALL ON TABLE validation FROM PUBLIC;
REVOKE ALL ON TABLE validation FROM apiis_admin;
GRANT ALL ON TABLE validation TO apiis_admin;
GRANT SELECT ON TABLE validation TO cong;


SET search_path = manager, pg_catalog;

--
-- Name: amplified_samples; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE amplified_samples FROM PUBLIC;
REVOKE ALL ON TABLE amplified_samples FROM apiis_admin;
GRANT ALL ON TABLE amplified_samples TO apiis_admin;
GRANT SELECT ON TABLE amplified_samples TO manager;


--
-- Name: analyzed_samples; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE analyzed_samples FROM PUBLIC;
REVOKE ALL ON TABLE analyzed_samples FROM apiis_admin;
GRANT ALL ON TABLE analyzed_samples TO apiis_admin;
GRANT SELECT ON TABLE analyzed_samples TO manager;


--
-- Name: blobs; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE blobs FROM PUBLIC;
REVOKE ALL ON TABLE blobs FROM apiis_admin;
GRANT ALL ON TABLE blobs TO apiis_admin;
GRANT SELECT ON TABLE blobs TO manager;


--
-- Name: codes; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE codes FROM PUBLIC;
REVOKE ALL ON TABLE codes FROM apiis_admin;
GRANT ALL ON TABLE codes TO apiis_admin;
GRANT SELECT ON TABLE codes TO manager;


--
-- Name: contacts; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE contacts FROM PUBLIC;
REVOKE ALL ON TABLE contacts FROM apiis_admin;
GRANT ALL ON TABLE contacts TO apiis_admin;
GRANT SELECT ON TABLE contacts TO manager;


--
-- Name: dna_extraction; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE dna_extraction FROM PUBLIC;
REVOKE ALL ON TABLE dna_extraction FROM apiis_admin;
GRANT ALL ON TABLE dna_extraction TO apiis_admin;
GRANT SELECT ON TABLE dna_extraction TO manager;


--
-- Name: electrophoresises; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE electrophoresises FROM PUBLIC;
REVOKE ALL ON TABLE electrophoresises FROM apiis_admin;
GRANT ALL ON TABLE electrophoresises TO apiis_admin;
GRANT SELECT ON TABLE electrophoresises TO manager;


--
-- Name: event; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE event FROM PUBLIC;
REVOKE ALL ON TABLE event FROM apiis_admin;
GRANT ALL ON TABLE event TO apiis_admin;
GRANT SELECT ON TABLE event TO manager;


--
-- Name: gel_images; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE gel_images FROM PUBLIC;
REVOKE ALL ON TABLE gel_images FROM apiis_admin;
GRANT ALL ON TABLE gel_images TO apiis_admin;
GRANT SELECT ON TABLE gel_images TO manager;


--
-- Name: languages; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE languages FROM PUBLIC;
REVOKE ALL ON TABLE languages FROM apiis_admin;
GRANT ALL ON TABLE languages TO apiis_admin;
GRANT SELECT ON TABLE languages TO manager;


--
-- Name: locations; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE locations FROM PUBLIC;
REVOKE ALL ON TABLE locations FROM apiis_admin;
GRANT ALL ON TABLE locations TO apiis_admin;
GRANT SELECT ON TABLE locations TO manager;


--
-- Name: markers; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE markers FROM PUBLIC;
REVOKE ALL ON TABLE markers FROM apiis_admin;
GRANT ALL ON TABLE markers TO apiis_admin;
GRANT SELECT ON TABLE markers TO manager;


--
-- Name: microsatellites; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE microsatellites FROM PUBLIC;
REVOKE ALL ON TABLE microsatellites FROM apiis_admin;
GRANT ALL ON TABLE microsatellites TO apiis_admin;
GRANT SELECT ON TABLE microsatellites TO manager;


--
-- Name: nodes; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE nodes FROM PUBLIC;
REVOKE ALL ON TABLE nodes FROM apiis_admin;
GRANT ALL ON TABLE nodes TO apiis_admin;
GRANT SELECT ON TABLE nodes TO manager;


--
-- Name: organisms; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE organisms FROM PUBLIC;
REVOKE ALL ON TABLE organisms FROM apiis_admin;
GRANT ALL ON TABLE organisms TO apiis_admin;
GRANT SELECT ON TABLE organisms TO manager;


--
-- Name: pcr_amplification; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_amplification FROM PUBLIC;
REVOKE ALL ON TABLE pcr_amplification FROM apiis_admin;
GRANT ALL ON TABLE pcr_amplification TO apiis_admin;
GRANT SELECT ON TABLE pcr_amplification TO manager;


--
-- Name: pcr_markers; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_markers FROM PUBLIC;
REVOKE ALL ON TABLE pcr_markers FROM apiis_admin;
GRANT ALL ON TABLE pcr_markers TO apiis_admin;
GRANT SELECT ON TABLE pcr_markers TO manager;


--
-- Name: projects; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE projects FROM PUBLIC;
REVOKE ALL ON TABLE projects FROM apiis_admin;
GRANT ALL ON TABLE projects TO apiis_admin;
GRANT SELECT ON TABLE projects TO manager;


--
-- Name: protocols; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE protocols FROM PUBLIC;
REVOKE ALL ON TABLE protocols FROM apiis_admin;
GRANT ALL ON TABLE protocols TO apiis_admin;
GRANT SELECT ON TABLE protocols TO manager;


--
-- Name: sample_collection; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE sample_collection FROM PUBLIC;
REVOKE ALL ON TABLE sample_collection FROM apiis_admin;
GRANT ALL ON TABLE sample_collection TO apiis_admin;
GRANT SELECT ON TABLE sample_collection TO manager;


--
-- Name: samples; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE samples FROM PUBLIC;
REVOKE ALL ON TABLE samples FROM apiis_admin;
GRANT ALL ON TABLE samples TO apiis_admin;
GRANT SELECT ON TABLE samples TO manager;


--
-- Name: sequences; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE sequences FROM PUBLIC;
REVOKE ALL ON TABLE sequences FROM apiis_admin;
GRANT ALL ON TABLE sequences TO apiis_admin;
GRANT SELECT ON TABLE sequences TO manager;


--
-- Name: storage; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE "storage" FROM PUBLIC;
REVOKE ALL ON TABLE "storage" FROM apiis_admin;
GRANT ALL ON TABLE "storage" TO apiis_admin;
GRANT SELECT ON TABLE "storage" TO manager;


--
-- Name: storage_samples; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE storage_samples FROM PUBLIC;
REVOKE ALL ON TABLE storage_samples FROM apiis_admin;
GRANT ALL ON TABLE storage_samples TO apiis_admin;
GRANT SELECT ON TABLE storage_samples TO manager;


--
-- Name: transfer; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE transfer FROM PUBLIC;
REVOKE ALL ON TABLE transfer FROM apiis_admin;
GRANT ALL ON TABLE transfer TO apiis_admin;
GRANT SELECT ON TABLE transfer TO manager;


--
-- Name: unit; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE unit FROM PUBLIC;
REVOKE ALL ON TABLE unit FROM apiis_admin;
GRANT ALL ON TABLE unit TO apiis_admin;
GRANT SELECT ON TABLE unit TO manager;


--
-- Name: validation; Type: ACL; Schema: manager; Owner: apiis_admin
--

REVOKE ALL ON TABLE validation FROM PUBLIC;
REVOKE ALL ON TABLE validation FROM apiis_admin;
GRANT ALL ON TABLE validation TO apiis_admin;
GRANT SELECT ON TABLE validation TO manager;


SET search_path = molabis, pg_catalog;

--
-- Name: amplified_samples; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE amplified_samples FROM PUBLIC;
REVOKE ALL ON TABLE amplified_samples FROM apiis_admin;
GRANT ALL ON TABLE amplified_samples TO apiis_admin;
GRANT SELECT ON TABLE amplified_samples TO molabis;


--
-- Name: analyzed_samples; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE analyzed_samples FROM PUBLIC;
REVOKE ALL ON TABLE analyzed_samples FROM apiis_admin;
GRANT ALL ON TABLE analyzed_samples TO apiis_admin;
GRANT SELECT ON TABLE analyzed_samples TO molabis;


--
-- Name: ar_constraints; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_constraints FROM PUBLIC;
REVOKE ALL ON TABLE ar_constraints FROM apiis_admin;
GRANT ALL ON TABLE ar_constraints TO apiis_admin;
GRANT SELECT ON TABLE ar_constraints TO molabis;


--
-- Name: ar_dbtdescriptors; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_dbtdescriptors FROM PUBLIC;
REVOKE ALL ON TABLE ar_dbtdescriptors FROM apiis_admin;
GRANT ALL ON TABLE ar_dbtdescriptors TO apiis_admin;
GRANT SELECT ON TABLE ar_dbtdescriptors TO molabis;


--
-- Name: ar_dbtpolicies; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_dbtpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_dbtpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_dbtpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_dbtpolicies TO molabis;


--
-- Name: ar_dbttables; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_dbttables FROM PUBLIC;
REVOKE ALL ON TABLE ar_dbttables FROM apiis_admin;
GRANT ALL ON TABLE ar_dbttables TO apiis_admin;
GRANT SELECT ON TABLE ar_dbttables TO molabis;


--
-- Name: ar_role_constraints; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_role_constraints FROM PUBLIC;
REVOKE ALL ON TABLE ar_role_constraints FROM apiis_admin;
GRANT ALL ON TABLE ar_role_constraints TO apiis_admin;
GRANT SELECT ON TABLE ar_role_constraints TO molabis;


--
-- Name: ar_role_dbtpolicies; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_role_dbtpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_role_dbtpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_role_dbtpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_role_dbtpolicies TO molabis;


--
-- Name: ar_role_stpolicies; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_role_stpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_role_stpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_role_stpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_role_stpolicies TO molabis;


--
-- Name: ar_roles; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_roles FROM PUBLIC;
REVOKE ALL ON TABLE ar_roles FROM apiis_admin;
GRANT ALL ON TABLE ar_roles TO apiis_admin;
GRANT SELECT ON TABLE ar_roles TO molabis;


--
-- Name: ar_stpolicies; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_stpolicies FROM PUBLIC;
REVOKE ALL ON TABLE ar_stpolicies FROM apiis_admin;
GRANT ALL ON TABLE ar_stpolicies TO apiis_admin;
GRANT SELECT ON TABLE ar_stpolicies TO molabis;


--
-- Name: ar_user_roles; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_user_roles FROM PUBLIC;
REVOKE ALL ON TABLE ar_user_roles FROM apiis_admin;
GRANT ALL ON TABLE ar_user_roles TO apiis_admin;
GRANT SELECT ON TABLE ar_user_roles TO molabis;


--
-- Name: ar_users; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_users FROM PUBLIC;
REVOKE ALL ON TABLE ar_users FROM apiis_admin;
GRANT ALL ON TABLE ar_users TO apiis_admin;
GRANT SELECT ON TABLE ar_users TO molabis;


--
-- Name: ar_users_data; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE ar_users_data FROM PUBLIC;
REVOKE ALL ON TABLE ar_users_data FROM apiis_admin;
GRANT ALL ON TABLE ar_users_data TO apiis_admin;
GRANT SELECT ON TABLE ar_users_data TO molabis;


--
-- Name: blobs; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE blobs FROM PUBLIC;
REVOKE ALL ON TABLE blobs FROM apiis_admin;
GRANT ALL ON TABLE blobs TO apiis_admin;
GRANT SELECT ON TABLE blobs TO molabis;


--
-- Name: codes; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE codes FROM PUBLIC;
REVOKE ALL ON TABLE codes FROM apiis_admin;
GRANT ALL ON TABLE codes TO apiis_admin;
GRANT SELECT ON TABLE codes TO molabis;


--
-- Name: contacts; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE contacts FROM PUBLIC;
REVOKE ALL ON TABLE contacts FROM apiis_admin;
GRANT ALL ON TABLE contacts TO apiis_admin;
GRANT SELECT ON TABLE contacts TO molabis;


--
-- Name: dna_extraction; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE dna_extraction FROM PUBLIC;
REVOKE ALL ON TABLE dna_extraction FROM apiis_admin;
GRANT ALL ON TABLE dna_extraction TO apiis_admin;
GRANT SELECT ON TABLE dna_extraction TO molabis;


--
-- Name: electrophoresises; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE electrophoresises FROM PUBLIC;
REVOKE ALL ON TABLE electrophoresises FROM apiis_admin;
GRANT ALL ON TABLE electrophoresises TO apiis_admin;
GRANT SELECT ON TABLE electrophoresises TO molabis;


--
-- Name: event; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE event FROM PUBLIC;
REVOKE ALL ON TABLE event FROM apiis_admin;
GRANT ALL ON TABLE event TO apiis_admin;
GRANT SELECT ON TABLE event TO molabis;


--
-- Name: gel_images; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE gel_images FROM PUBLIC;
REVOKE ALL ON TABLE gel_images FROM apiis_admin;
GRANT ALL ON TABLE gel_images TO apiis_admin;
GRANT SELECT ON TABLE gel_images TO molabis;


--
-- Name: inspool; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE inspool FROM PUBLIC;
REVOKE ALL ON TABLE inspool FROM apiis_admin;
GRANT ALL ON TABLE inspool TO apiis_admin;
GRANT SELECT ON TABLE inspool TO molabis;


--
-- Name: inspool_err; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE inspool_err FROM PUBLIC;
REVOKE ALL ON TABLE inspool_err FROM apiis_admin;
GRANT ALL ON TABLE inspool_err TO apiis_admin;
GRANT SELECT ON TABLE inspool_err TO molabis;


--
-- Name: languages; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE languages FROM PUBLIC;
REVOKE ALL ON TABLE languages FROM apiis_admin;
GRANT ALL ON TABLE languages TO apiis_admin;
GRANT SELECT ON TABLE languages TO molabis;


--
-- Name: load_stat; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE load_stat FROM PUBLIC;
REVOKE ALL ON TABLE load_stat FROM apiis_admin;
GRANT ALL ON TABLE load_stat TO apiis_admin;
GRANT SELECT ON TABLE load_stat TO molabis;


--
-- Name: locations; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE locations FROM PUBLIC;
REVOKE ALL ON TABLE locations FROM apiis_admin;
GRANT ALL ON TABLE locations TO apiis_admin;
GRANT SELECT ON TABLE locations TO molabis;


--
-- Name: markers; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE markers FROM PUBLIC;
REVOKE ALL ON TABLE markers FROM apiis_admin;
GRANT ALL ON TABLE markers TO apiis_admin;
GRANT SELECT ON TABLE markers TO molabis;


--
-- Name: microsatellites; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE microsatellites FROM PUBLIC;
REVOKE ALL ON TABLE microsatellites FROM apiis_admin;
GRANT ALL ON TABLE microsatellites TO apiis_admin;
GRANT SELECT ON TABLE microsatellites TO molabis;


--
-- Name: new_pest; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE new_pest FROM PUBLIC;
REVOKE ALL ON TABLE new_pest FROM apiis_admin;
GRANT ALL ON TABLE new_pest TO apiis_admin;
GRANT SELECT ON TABLE new_pest TO molabis;


--
-- Name: nodes; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE nodes FROM PUBLIC;
REVOKE ALL ON TABLE nodes FROM apiis_admin;
GRANT ALL ON TABLE nodes TO apiis_admin;
GRANT SELECT ON TABLE nodes TO molabis;


--
-- Name: organisms; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE organisms FROM PUBLIC;
REVOKE ALL ON TABLE organisms FROM apiis_admin;
GRANT ALL ON TABLE organisms TO apiis_admin;
GRANT SELECT ON TABLE organisms TO molabis;


--
-- Name: pcr_amplification; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_amplification FROM PUBLIC;
REVOKE ALL ON TABLE pcr_amplification FROM apiis_admin;
GRANT ALL ON TABLE pcr_amplification TO apiis_admin;
GRANT SELECT ON TABLE pcr_amplification TO molabis;


--
-- Name: pcr_markers; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_markers FROM PUBLIC;
REVOKE ALL ON TABLE pcr_markers FROM apiis_admin;
GRANT ALL ON TABLE pcr_markers TO apiis_admin;
GRANT SELECT ON TABLE pcr_markers TO molabis;


--
-- Name: projects; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE projects FROM PUBLIC;
REVOKE ALL ON TABLE projects FROM apiis_admin;
GRANT ALL ON TABLE projects TO apiis_admin;
GRANT SELECT ON TABLE projects TO molabis;


--
-- Name: protocols; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE protocols FROM PUBLIC;
REVOKE ALL ON TABLE protocols FROM apiis_admin;
GRANT ALL ON TABLE protocols TO apiis_admin;
GRANT SELECT ON TABLE protocols TO molabis;


--
-- Name: sample_collection; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE sample_collection FROM PUBLIC;
REVOKE ALL ON TABLE sample_collection FROM apiis_admin;
GRANT ALL ON TABLE sample_collection TO apiis_admin;
GRANT SELECT ON TABLE sample_collection TO molabis;


--
-- Name: samples; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE samples FROM PUBLIC;
REVOKE ALL ON TABLE samples FROM apiis_admin;
GRANT ALL ON TABLE samples TO apiis_admin;
GRANT SELECT ON TABLE samples TO molabis;


--
-- Name: sequences; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE sequences FROM PUBLIC;
REVOKE ALL ON TABLE sequences FROM apiis_admin;
GRANT ALL ON TABLE sequences TO apiis_admin;
GRANT SELECT ON TABLE sequences TO molabis;


--
-- Name: sources; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE sources FROM PUBLIC;
REVOKE ALL ON TABLE sources FROM apiis_admin;
GRANT ALL ON TABLE sources TO apiis_admin;
GRANT SELECT ON TABLE sources TO molabis;


--
-- Name: storage; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE "storage" FROM PUBLIC;
REVOKE ALL ON TABLE "storage" FROM apiis_admin;
GRANT ALL ON TABLE "storage" TO apiis_admin;
GRANT SELECT ON TABLE "storage" TO molabis;


--
-- Name: storage_samples; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE storage_samples FROM PUBLIC;
REVOKE ALL ON TABLE storage_samples FROM apiis_admin;
GRANT ALL ON TABLE storage_samples TO apiis_admin;
GRANT SELECT ON TABLE storage_samples TO molabis;


--
-- Name: targets; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE targets FROM PUBLIC;
REVOKE ALL ON TABLE targets FROM apiis_admin;
GRANT ALL ON TABLE targets TO apiis_admin;
GRANT SELECT ON TABLE targets TO molabis;


--
-- Name: transfer; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE transfer FROM PUBLIC;
REVOKE ALL ON TABLE transfer FROM apiis_admin;
GRANT ALL ON TABLE transfer TO apiis_admin;
GRANT SELECT ON TABLE transfer TO molabis;


--
-- Name: unit; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE unit FROM PUBLIC;
REVOKE ALL ON TABLE unit FROM apiis_admin;
GRANT ALL ON TABLE unit TO apiis_admin;
GRANT SELECT ON TABLE unit TO molabis;


--
-- Name: validation; Type: ACL; Schema: molabis; Owner: apiis_admin
--

REVOKE ALL ON TABLE validation FROM PUBLIC;
REVOKE ALL ON TABLE validation FROM apiis_admin;
GRANT ALL ON TABLE validation TO apiis_admin;
GRANT SELECT ON TABLE validation TO molabis;


SET search_path = scientist, pg_catalog;

--
-- Name: amplified_samples; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE amplified_samples FROM PUBLIC;
REVOKE ALL ON TABLE amplified_samples FROM apiis_admin;
GRANT ALL ON TABLE amplified_samples TO apiis_admin;
GRANT SELECT ON TABLE amplified_samples TO scientist;


--
-- Name: analyzed_samples; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE analyzed_samples FROM PUBLIC;
REVOKE ALL ON TABLE analyzed_samples FROM apiis_admin;
GRANT ALL ON TABLE analyzed_samples TO apiis_admin;
GRANT SELECT ON TABLE analyzed_samples TO scientist;


--
-- Name: blobs; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE blobs FROM PUBLIC;
REVOKE ALL ON TABLE blobs FROM apiis_admin;
GRANT ALL ON TABLE blobs TO apiis_admin;
GRANT SELECT ON TABLE blobs TO scientist;


--
-- Name: codes; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE codes FROM PUBLIC;
REVOKE ALL ON TABLE codes FROM apiis_admin;
GRANT ALL ON TABLE codes TO apiis_admin;
GRANT SELECT ON TABLE codes TO scientist;


--
-- Name: contacts; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE contacts FROM PUBLIC;
REVOKE ALL ON TABLE contacts FROM apiis_admin;
GRANT ALL ON TABLE contacts TO apiis_admin;
GRANT SELECT ON TABLE contacts TO scientist;


--
-- Name: dna_extraction; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE dna_extraction FROM PUBLIC;
REVOKE ALL ON TABLE dna_extraction FROM apiis_admin;
GRANT ALL ON TABLE dna_extraction TO apiis_admin;
GRANT SELECT ON TABLE dna_extraction TO scientist;


--
-- Name: electrophoresises; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE electrophoresises FROM PUBLIC;
REVOKE ALL ON TABLE electrophoresises FROM apiis_admin;
GRANT ALL ON TABLE electrophoresises TO apiis_admin;
GRANT SELECT ON TABLE electrophoresises TO scientist;


--
-- Name: gel_images; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE gel_images FROM PUBLIC;
REVOKE ALL ON TABLE gel_images FROM apiis_admin;
GRANT ALL ON TABLE gel_images TO apiis_admin;
GRANT SELECT ON TABLE gel_images TO scientist;


--
-- Name: markers; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE markers FROM PUBLIC;
REVOKE ALL ON TABLE markers FROM apiis_admin;
GRANT ALL ON TABLE markers TO apiis_admin;
GRANT SELECT ON TABLE markers TO scientist;


--
-- Name: microsatellites; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE microsatellites FROM PUBLIC;
REVOKE ALL ON TABLE microsatellites FROM apiis_admin;
GRANT ALL ON TABLE microsatellites TO apiis_admin;
GRANT SELECT ON TABLE microsatellites TO scientist;


--
-- Name: organisms; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE organisms FROM PUBLIC;
REVOKE ALL ON TABLE organisms FROM apiis_admin;
GRANT ALL ON TABLE organisms TO apiis_admin;
GRANT SELECT ON TABLE organisms TO scientist;


--
-- Name: pcr_amplification; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_amplification FROM PUBLIC;
REVOKE ALL ON TABLE pcr_amplification FROM apiis_admin;
GRANT ALL ON TABLE pcr_amplification TO apiis_admin;
GRANT SELECT ON TABLE pcr_amplification TO scientist;


--
-- Name: pcr_markers; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_markers FROM PUBLIC;
REVOKE ALL ON TABLE pcr_markers FROM apiis_admin;
GRANT ALL ON TABLE pcr_markers TO apiis_admin;
GRANT SELECT ON TABLE pcr_markers TO scientist;


--
-- Name: projects; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE projects FROM PUBLIC;
REVOKE ALL ON TABLE projects FROM apiis_admin;
GRANT ALL ON TABLE projects TO apiis_admin;
GRANT SELECT ON TABLE projects TO scientist;


--
-- Name: protocols; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE protocols FROM PUBLIC;
REVOKE ALL ON TABLE protocols FROM apiis_admin;
GRANT ALL ON TABLE protocols TO apiis_admin;
GRANT SELECT ON TABLE protocols TO scientist;


--
-- Name: sample_collection; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE sample_collection FROM PUBLIC;
REVOKE ALL ON TABLE sample_collection FROM apiis_admin;
GRANT ALL ON TABLE sample_collection TO apiis_admin;
GRANT SELECT ON TABLE sample_collection TO scientist;


--
-- Name: samples; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE samples FROM PUBLIC;
REVOKE ALL ON TABLE samples FROM apiis_admin;
GRANT ALL ON TABLE samples TO apiis_admin;
GRANT SELECT ON TABLE samples TO scientist;


--
-- Name: sequences; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE sequences FROM PUBLIC;
REVOKE ALL ON TABLE sequences FROM apiis_admin;
GRANT ALL ON TABLE sequences TO apiis_admin;
GRANT SELECT ON TABLE sequences TO scientist;


--
-- Name: storage; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE "storage" FROM PUBLIC;
REVOKE ALL ON TABLE "storage" FROM apiis_admin;
GRANT ALL ON TABLE "storage" TO apiis_admin;
GRANT SELECT ON TABLE "storage" TO scientist;


--
-- Name: storage_samples; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE storage_samples FROM PUBLIC;
REVOKE ALL ON TABLE storage_samples FROM apiis_admin;
GRANT ALL ON TABLE storage_samples TO apiis_admin;
GRANT SELECT ON TABLE storage_samples TO scientist;


--
-- Name: transfer; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE transfer FROM PUBLIC;
REVOKE ALL ON TABLE transfer FROM apiis_admin;
GRANT ALL ON TABLE transfer TO apiis_admin;
GRANT SELECT ON TABLE transfer TO scientist;


--
-- Name: unit; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE unit FROM PUBLIC;
REVOKE ALL ON TABLE unit FROM apiis_admin;
GRANT ALL ON TABLE unit TO apiis_admin;
GRANT SELECT ON TABLE unit TO scientist;


--
-- Name: validation; Type: ACL; Schema: scientist; Owner: apiis_admin
--

REVOKE ALL ON TABLE validation FROM PUBLIC;
REVOKE ALL ON TABLE validation FROM apiis_admin;
GRANT ALL ON TABLE validation TO apiis_admin;
GRANT SELECT ON TABLE validation TO scientist;


SET search_path = staff, pg_catalog;

--
-- Name: amplified_samples; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE amplified_samples FROM PUBLIC;
REVOKE ALL ON TABLE amplified_samples FROM apiis_admin;
GRANT ALL ON TABLE amplified_samples TO apiis_admin;
GRANT SELECT ON TABLE amplified_samples TO staff;


--
-- Name: analyzed_samples; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE analyzed_samples FROM PUBLIC;
REVOKE ALL ON TABLE analyzed_samples FROM apiis_admin;
GRANT ALL ON TABLE analyzed_samples TO apiis_admin;
GRANT SELECT ON TABLE analyzed_samples TO staff;


--
-- Name: blobs; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE blobs FROM PUBLIC;
REVOKE ALL ON TABLE blobs FROM apiis_admin;
GRANT ALL ON TABLE blobs TO apiis_admin;
GRANT SELECT ON TABLE blobs TO staff;


--
-- Name: codes; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE codes FROM PUBLIC;
REVOKE ALL ON TABLE codes FROM apiis_admin;
GRANT ALL ON TABLE codes TO apiis_admin;
GRANT SELECT ON TABLE codes TO staff;


--
-- Name: contacts; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE contacts FROM PUBLIC;
REVOKE ALL ON TABLE contacts FROM apiis_admin;
GRANT ALL ON TABLE contacts TO apiis_admin;
GRANT SELECT ON TABLE contacts TO staff;


--
-- Name: dna_extraction; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE dna_extraction FROM PUBLIC;
REVOKE ALL ON TABLE dna_extraction FROM apiis_admin;
GRANT ALL ON TABLE dna_extraction TO apiis_admin;
GRANT SELECT ON TABLE dna_extraction TO staff;


--
-- Name: electrophoresises; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE electrophoresises FROM PUBLIC;
REVOKE ALL ON TABLE electrophoresises FROM apiis_admin;
GRANT ALL ON TABLE electrophoresises TO apiis_admin;
GRANT SELECT ON TABLE electrophoresises TO staff;


--
-- Name: event; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE event FROM PUBLIC;
REVOKE ALL ON TABLE event FROM apiis_admin;
GRANT ALL ON TABLE event TO apiis_admin;
GRANT SELECT ON TABLE event TO staff;


--
-- Name: gel_images; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE gel_images FROM PUBLIC;
REVOKE ALL ON TABLE gel_images FROM apiis_admin;
GRANT ALL ON TABLE gel_images TO apiis_admin;
GRANT SELECT ON TABLE gel_images TO staff;


--
-- Name: languages; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE languages FROM PUBLIC;
REVOKE ALL ON TABLE languages FROM apiis_admin;
GRANT ALL ON TABLE languages TO apiis_admin;
GRANT SELECT ON TABLE languages TO staff;


--
-- Name: locations; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE locations FROM PUBLIC;
REVOKE ALL ON TABLE locations FROM apiis_admin;
GRANT ALL ON TABLE locations TO apiis_admin;
GRANT SELECT ON TABLE locations TO staff;


--
-- Name: markers; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE markers FROM PUBLIC;
REVOKE ALL ON TABLE markers FROM apiis_admin;
GRANT ALL ON TABLE markers TO apiis_admin;
GRANT SELECT ON TABLE markers TO staff;


--
-- Name: microsatellites; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE microsatellites FROM PUBLIC;
REVOKE ALL ON TABLE microsatellites FROM apiis_admin;
GRANT ALL ON TABLE microsatellites TO apiis_admin;
GRANT SELECT ON TABLE microsatellites TO staff;


--
-- Name: nodes; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE nodes FROM PUBLIC;
REVOKE ALL ON TABLE nodes FROM apiis_admin;
GRANT ALL ON TABLE nodes TO apiis_admin;
GRANT SELECT ON TABLE nodes TO staff;


--
-- Name: organisms; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE organisms FROM PUBLIC;
REVOKE ALL ON TABLE organisms FROM apiis_admin;
GRANT ALL ON TABLE organisms TO apiis_admin;
GRANT SELECT ON TABLE organisms TO staff;


--
-- Name: pcr_amplification; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_amplification FROM PUBLIC;
REVOKE ALL ON TABLE pcr_amplification FROM apiis_admin;
GRANT ALL ON TABLE pcr_amplification TO apiis_admin;
GRANT SELECT ON TABLE pcr_amplification TO staff;


--
-- Name: pcr_markers; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_markers FROM PUBLIC;
REVOKE ALL ON TABLE pcr_markers FROM apiis_admin;
GRANT ALL ON TABLE pcr_markers TO apiis_admin;
GRANT SELECT ON TABLE pcr_markers TO staff;


--
-- Name: projects; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE projects FROM PUBLIC;
REVOKE ALL ON TABLE projects FROM apiis_admin;
GRANT ALL ON TABLE projects TO apiis_admin;
GRANT SELECT ON TABLE projects TO staff;


--
-- Name: protocols; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE protocols FROM PUBLIC;
REVOKE ALL ON TABLE protocols FROM apiis_admin;
GRANT ALL ON TABLE protocols TO apiis_admin;
GRANT SELECT ON TABLE protocols TO staff;


--
-- Name: sample_collection; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE sample_collection FROM PUBLIC;
REVOKE ALL ON TABLE sample_collection FROM apiis_admin;
GRANT ALL ON TABLE sample_collection TO apiis_admin;
GRANT SELECT ON TABLE sample_collection TO staff;


--
-- Name: samples; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE samples FROM PUBLIC;
REVOKE ALL ON TABLE samples FROM apiis_admin;
GRANT ALL ON TABLE samples TO apiis_admin;
GRANT SELECT ON TABLE samples TO staff;


--
-- Name: sequences; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE sequences FROM PUBLIC;
REVOKE ALL ON TABLE sequences FROM apiis_admin;
GRANT ALL ON TABLE sequences TO apiis_admin;
GRANT SELECT ON TABLE sequences TO staff;


--
-- Name: storage; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE "storage" FROM PUBLIC;
REVOKE ALL ON TABLE "storage" FROM apiis_admin;
GRANT ALL ON TABLE "storage" TO apiis_admin;
GRANT SELECT ON TABLE "storage" TO staff;


--
-- Name: storage_samples; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE storage_samples FROM PUBLIC;
REVOKE ALL ON TABLE storage_samples FROM apiis_admin;
GRANT ALL ON TABLE storage_samples TO apiis_admin;
GRANT SELECT ON TABLE storage_samples TO staff;


--
-- Name: transfer; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE transfer FROM PUBLIC;
REVOKE ALL ON TABLE transfer FROM apiis_admin;
GRANT ALL ON TABLE transfer TO apiis_admin;
GRANT SELECT ON TABLE transfer TO staff;


--
-- Name: unit; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE unit FROM PUBLIC;
REVOKE ALL ON TABLE unit FROM apiis_admin;
GRANT ALL ON TABLE unit TO apiis_admin;
GRANT SELECT ON TABLE unit TO staff;


--
-- Name: validation; Type: ACL; Schema: staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE validation FROM PUBLIC;
REVOKE ALL ON TABLE validation FROM apiis_admin;
GRANT ALL ON TABLE validation TO apiis_admin;
GRANT SELECT ON TABLE validation TO staff;


SET search_path = super_staff, pg_catalog;

--
-- Name: amplified_samples; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE amplified_samples FROM PUBLIC;
REVOKE ALL ON TABLE amplified_samples FROM apiis_admin;
GRANT ALL ON TABLE amplified_samples TO apiis_admin;
GRANT SELECT ON TABLE amplified_samples TO super_staff;


--
-- Name: analyzed_samples; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE analyzed_samples FROM PUBLIC;
REVOKE ALL ON TABLE analyzed_samples FROM apiis_admin;
GRANT ALL ON TABLE analyzed_samples TO apiis_admin;
GRANT SELECT ON TABLE analyzed_samples TO super_staff;


--
-- Name: blobs; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE blobs FROM PUBLIC;
REVOKE ALL ON TABLE blobs FROM apiis_admin;
GRANT ALL ON TABLE blobs TO apiis_admin;
GRANT SELECT ON TABLE blobs TO super_staff;


--
-- Name: codes; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE codes FROM PUBLIC;
REVOKE ALL ON TABLE codes FROM apiis_admin;
GRANT ALL ON TABLE codes TO apiis_admin;
GRANT SELECT ON TABLE codes TO super_staff;


--
-- Name: contacts; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE contacts FROM PUBLIC;
REVOKE ALL ON TABLE contacts FROM apiis_admin;
GRANT ALL ON TABLE contacts TO apiis_admin;
GRANT SELECT ON TABLE contacts TO super_staff;


--
-- Name: dna_extraction; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE dna_extraction FROM PUBLIC;
REVOKE ALL ON TABLE dna_extraction FROM apiis_admin;
GRANT ALL ON TABLE dna_extraction TO apiis_admin;
GRANT SELECT ON TABLE dna_extraction TO super_staff;


--
-- Name: electrophoresises; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE electrophoresises FROM PUBLIC;
REVOKE ALL ON TABLE electrophoresises FROM apiis_admin;
GRANT ALL ON TABLE electrophoresises TO apiis_admin;
GRANT SELECT ON TABLE electrophoresises TO super_staff;


--
-- Name: event; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE event FROM PUBLIC;
REVOKE ALL ON TABLE event FROM apiis_admin;
GRANT ALL ON TABLE event TO apiis_admin;
GRANT SELECT ON TABLE event TO super_staff;


--
-- Name: gel_images; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE gel_images FROM PUBLIC;
REVOKE ALL ON TABLE gel_images FROM apiis_admin;
GRANT ALL ON TABLE gel_images TO apiis_admin;
GRANT SELECT ON TABLE gel_images TO super_staff;


--
-- Name: languages; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE languages FROM PUBLIC;
REVOKE ALL ON TABLE languages FROM apiis_admin;
GRANT ALL ON TABLE languages TO apiis_admin;
GRANT SELECT ON TABLE languages TO super_staff;


--
-- Name: locations; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE locations FROM PUBLIC;
REVOKE ALL ON TABLE locations FROM apiis_admin;
GRANT ALL ON TABLE locations TO apiis_admin;
GRANT SELECT ON TABLE locations TO super_staff;


--
-- Name: markers; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE markers FROM PUBLIC;
REVOKE ALL ON TABLE markers FROM apiis_admin;
GRANT ALL ON TABLE markers TO apiis_admin;
GRANT SELECT ON TABLE markers TO super_staff;


--
-- Name: microsatellites; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE microsatellites FROM PUBLIC;
REVOKE ALL ON TABLE microsatellites FROM apiis_admin;
GRANT ALL ON TABLE microsatellites TO apiis_admin;
GRANT SELECT ON TABLE microsatellites TO super_staff;


--
-- Name: nodes; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE nodes FROM PUBLIC;
REVOKE ALL ON TABLE nodes FROM apiis_admin;
GRANT ALL ON TABLE nodes TO apiis_admin;
GRANT SELECT ON TABLE nodes TO super_staff;


--
-- Name: organisms; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE organisms FROM PUBLIC;
REVOKE ALL ON TABLE organisms FROM apiis_admin;
GRANT ALL ON TABLE organisms TO apiis_admin;
GRANT SELECT ON TABLE organisms TO super_staff;


--
-- Name: pcr_amplification; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_amplification FROM PUBLIC;
REVOKE ALL ON TABLE pcr_amplification FROM apiis_admin;
GRANT ALL ON TABLE pcr_amplification TO apiis_admin;
GRANT SELECT ON TABLE pcr_amplification TO super_staff;


--
-- Name: pcr_markers; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_markers FROM PUBLIC;
REVOKE ALL ON TABLE pcr_markers FROM apiis_admin;
GRANT ALL ON TABLE pcr_markers TO apiis_admin;
GRANT SELECT ON TABLE pcr_markers TO super_staff;


--
-- Name: projects; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE projects FROM PUBLIC;
REVOKE ALL ON TABLE projects FROM apiis_admin;
GRANT ALL ON TABLE projects TO apiis_admin;
GRANT SELECT ON TABLE projects TO super_staff;


--
-- Name: protocols; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE protocols FROM PUBLIC;
REVOKE ALL ON TABLE protocols FROM apiis_admin;
GRANT ALL ON TABLE protocols TO apiis_admin;
GRANT SELECT ON TABLE protocols TO super_staff;


--
-- Name: sample_collection; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE sample_collection FROM PUBLIC;
REVOKE ALL ON TABLE sample_collection FROM apiis_admin;
GRANT ALL ON TABLE sample_collection TO apiis_admin;
GRANT SELECT ON TABLE sample_collection TO super_staff;


--
-- Name: samples; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE samples FROM PUBLIC;
REVOKE ALL ON TABLE samples FROM apiis_admin;
GRANT ALL ON TABLE samples TO apiis_admin;
GRANT SELECT ON TABLE samples TO super_staff;


--
-- Name: sequences; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE sequences FROM PUBLIC;
REVOKE ALL ON TABLE sequences FROM apiis_admin;
GRANT ALL ON TABLE sequences TO apiis_admin;
GRANT SELECT ON TABLE sequences TO super_staff;


--
-- Name: storage; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE "storage" FROM PUBLIC;
REVOKE ALL ON TABLE "storage" FROM apiis_admin;
GRANT ALL ON TABLE "storage" TO apiis_admin;
GRANT SELECT ON TABLE "storage" TO super_staff;


--
-- Name: storage_samples; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE storage_samples FROM PUBLIC;
REVOKE ALL ON TABLE storage_samples FROM apiis_admin;
GRANT ALL ON TABLE storage_samples TO apiis_admin;
GRANT SELECT ON TABLE storage_samples TO super_staff;


--
-- Name: transfer; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE transfer FROM PUBLIC;
REVOKE ALL ON TABLE transfer FROM apiis_admin;
GRANT ALL ON TABLE transfer TO apiis_admin;
GRANT SELECT ON TABLE transfer TO super_staff;


--
-- Name: unit; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE unit FROM PUBLIC;
REVOKE ALL ON TABLE unit FROM apiis_admin;
GRANT ALL ON TABLE unit TO apiis_admin;
GRANT SELECT ON TABLE unit TO super_staff;


--
-- Name: validation; Type: ACL; Schema: super_staff; Owner: apiis_admin
--

REVOKE ALL ON TABLE validation FROM PUBLIC;
REVOKE ALL ON TABLE validation FROM apiis_admin;
GRANT ALL ON TABLE validation TO apiis_admin;
GRANT SELECT ON TABLE validation TO super_staff;


SET search_path = visitor, pg_catalog;

--
-- Name: amplified_samples; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE amplified_samples FROM PUBLIC;
REVOKE ALL ON TABLE amplified_samples FROM apiis_admin;
GRANT ALL ON TABLE amplified_samples TO apiis_admin;
GRANT SELECT ON TABLE amplified_samples TO visitor;


--
-- Name: analyzed_samples; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE analyzed_samples FROM PUBLIC;
REVOKE ALL ON TABLE analyzed_samples FROM apiis_admin;
GRANT ALL ON TABLE analyzed_samples TO apiis_admin;
GRANT SELECT ON TABLE analyzed_samples TO visitor;


--
-- Name: blobs; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE blobs FROM PUBLIC;
REVOKE ALL ON TABLE blobs FROM apiis_admin;
GRANT ALL ON TABLE blobs TO apiis_admin;
GRANT SELECT ON TABLE blobs TO visitor;


--
-- Name: codes; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE codes FROM PUBLIC;
REVOKE ALL ON TABLE codes FROM apiis_admin;
GRANT ALL ON TABLE codes TO apiis_admin;
GRANT SELECT ON TABLE codes TO visitor;


--
-- Name: contacts; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE contacts FROM PUBLIC;
REVOKE ALL ON TABLE contacts FROM apiis_admin;
GRANT ALL ON TABLE contacts TO apiis_admin;
GRANT SELECT ON TABLE contacts TO visitor;


--
-- Name: dna_extraction; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE dna_extraction FROM PUBLIC;
REVOKE ALL ON TABLE dna_extraction FROM apiis_admin;
GRANT ALL ON TABLE dna_extraction TO apiis_admin;
GRANT SELECT ON TABLE dna_extraction TO visitor;


--
-- Name: electrophoresises; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE electrophoresises FROM PUBLIC;
REVOKE ALL ON TABLE electrophoresises FROM apiis_admin;
GRANT ALL ON TABLE electrophoresises TO apiis_admin;
GRANT SELECT ON TABLE electrophoresises TO visitor;


--
-- Name: event; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE event FROM PUBLIC;
REVOKE ALL ON TABLE event FROM apiis_admin;
GRANT ALL ON TABLE event TO apiis_admin;
GRANT SELECT ON TABLE event TO visitor;


--
-- Name: gel_images; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE gel_images FROM PUBLIC;
REVOKE ALL ON TABLE gel_images FROM apiis_admin;
GRANT ALL ON TABLE gel_images TO apiis_admin;
GRANT SELECT ON TABLE gel_images TO visitor;


--
-- Name: languages; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE languages FROM PUBLIC;
REVOKE ALL ON TABLE languages FROM apiis_admin;
GRANT ALL ON TABLE languages TO apiis_admin;
GRANT SELECT ON TABLE languages TO visitor;


--
-- Name: locations; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE locations FROM PUBLIC;
REVOKE ALL ON TABLE locations FROM apiis_admin;
GRANT ALL ON TABLE locations TO apiis_admin;
GRANT SELECT ON TABLE locations TO visitor;


--
-- Name: markers; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE markers FROM PUBLIC;
REVOKE ALL ON TABLE markers FROM apiis_admin;
GRANT ALL ON TABLE markers TO apiis_admin;
GRANT SELECT ON TABLE markers TO visitor;


--
-- Name: microsatellites; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE microsatellites FROM PUBLIC;
REVOKE ALL ON TABLE microsatellites FROM apiis_admin;
GRANT ALL ON TABLE microsatellites TO apiis_admin;
GRANT SELECT ON TABLE microsatellites TO visitor;


--
-- Name: nodes; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE nodes FROM PUBLIC;
REVOKE ALL ON TABLE nodes FROM apiis_admin;
GRANT ALL ON TABLE nodes TO apiis_admin;
GRANT SELECT ON TABLE nodes TO visitor;


--
-- Name: organisms; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE organisms FROM PUBLIC;
REVOKE ALL ON TABLE organisms FROM apiis_admin;
GRANT ALL ON TABLE organisms TO apiis_admin;
GRANT SELECT ON TABLE organisms TO visitor;


--
-- Name: pcr_amplification; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_amplification FROM PUBLIC;
REVOKE ALL ON TABLE pcr_amplification FROM apiis_admin;
GRANT ALL ON TABLE pcr_amplification TO apiis_admin;
GRANT SELECT ON TABLE pcr_amplification TO visitor;


--
-- Name: pcr_markers; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE pcr_markers FROM PUBLIC;
REVOKE ALL ON TABLE pcr_markers FROM apiis_admin;
GRANT ALL ON TABLE pcr_markers TO apiis_admin;
GRANT SELECT ON TABLE pcr_markers TO visitor;


--
-- Name: projects; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE projects FROM PUBLIC;
REVOKE ALL ON TABLE projects FROM apiis_admin;
GRANT ALL ON TABLE projects TO apiis_admin;
GRANT SELECT ON TABLE projects TO visitor;


--
-- Name: protocols; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE protocols FROM PUBLIC;
REVOKE ALL ON TABLE protocols FROM apiis_admin;
GRANT ALL ON TABLE protocols TO apiis_admin;
GRANT SELECT ON TABLE protocols TO visitor;


--
-- Name: sample_collection; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE sample_collection FROM PUBLIC;
REVOKE ALL ON TABLE sample_collection FROM apiis_admin;
GRANT ALL ON TABLE sample_collection TO apiis_admin;
GRANT SELECT ON TABLE sample_collection TO visitor;


--
-- Name: samples; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE samples FROM PUBLIC;
REVOKE ALL ON TABLE samples FROM apiis_admin;
GRANT ALL ON TABLE samples TO apiis_admin;
GRANT SELECT ON TABLE samples TO visitor;


--
-- Name: sequences; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE sequences FROM PUBLIC;
REVOKE ALL ON TABLE sequences FROM apiis_admin;
GRANT ALL ON TABLE sequences TO apiis_admin;
GRANT SELECT ON TABLE sequences TO visitor;


--
-- Name: storage; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE "storage" FROM PUBLIC;
REVOKE ALL ON TABLE "storage" FROM apiis_admin;
GRANT ALL ON TABLE "storage" TO apiis_admin;
GRANT SELECT ON TABLE "storage" TO visitor;


--
-- Name: storage_samples; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE storage_samples FROM PUBLIC;
REVOKE ALL ON TABLE storage_samples FROM apiis_admin;
GRANT ALL ON TABLE storage_samples TO apiis_admin;
GRANT SELECT ON TABLE storage_samples TO visitor;


--
-- Name: transfer; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE transfer FROM PUBLIC;
REVOKE ALL ON TABLE transfer FROM apiis_admin;
GRANT ALL ON TABLE transfer TO apiis_admin;
GRANT SELECT ON TABLE transfer TO visitor;


--
-- Name: unit; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE unit FROM PUBLIC;
REVOKE ALL ON TABLE unit FROM apiis_admin;
GRANT ALL ON TABLE unit TO apiis_admin;
GRANT SELECT ON TABLE unit TO visitor;


--
-- Name: validation; Type: ACL; Schema: visitor; Owner: apiis_admin
--

REVOKE ALL ON TABLE validation FROM PUBLIC;
REVOKE ALL ON TABLE validation FROM apiis_admin;
GRANT ALL ON TABLE validation TO apiis_admin;
GRANT SELECT ON TABLE validation TO visitor;


--
-- PostgreSQL database dump complete
--

